program dalikliai_ir_kartotiniai;
  { 64 udavinys }

  function dbdf (x, y : integer) : integer;
    { randa skaii x ir y bendrj didiausi dalikl }
  begin
    if x = 0
       then dbdf := y
       else dbdf := dbdf (y mod x, x);
  end;

  function mbkf (x, y : integer) : integer;
    { randa skaii x ir y bendrj maiausi kartotin }
  begin
    mbkf := x div dbdf (x, y) * y
  end;

  procedure netruksta (var a, b, s, mbk : integer);
    { jei inomi visi skaiiai, patikrina, ar jie teisingi }
  begin
    if (a + b <> s) or (mbkf (a, b) <> mbk)
       then begin  { skaii atstatyti nepavyko }
              a := 0; b := 0;
              s := 0; mbk := 0;
            end;
  end;

  procedure vienas (var a, b, s, mbk : integer);
    { atstato skaiius, kai neinomas vienas skaiius }
  begin
    { atstatysime trkstam skaii }
    if a = 0
       then a := s - b
       else if b = 0
               then b := s - a
               else if s = 0
                       then s := a + b
                       else mbk := mbkf (a, b);
    { patikrinsime, ar pavyko atstatyti }
    netruksta (a, b, s, mbk);
  end;

  procedure du (var a, b, s, mbk : integer);
    { atstato skaiius, kai neinomi du skaiiai }
    var d, tarp : integer;
        rasta : boolean;
  begin
    if (a = 0) and (b = 0)
       then begin { perrinksime mbk daliklius }
              d := 0;
              rasta := false;
              while (d <= mbk div 2) and not rasta do
                begin
                  d := d + 1;
                  if (mbk mod d = 0) and (s > d)
                     then rasta := mbkf(s - d, d) = mbk
                 end;
              if rasta
                 then begin
                        a := d;
                        b := s - d;
                      end;
            end
       else if (s = 0) and (mbk = 0)
               then begin
                      s := a + b;
                      mbk := mbkf (a, b);
                     end
       else if mbk = 0
               then begin
                      if a = 0
                         then a := s - b
                         else b := s - a;
                       mbk := mbkf (a, b);
                    end
       else begin { neinomas a arba b ir s }
              tarp := mbk div (a + b);
              if a = 0
                 then a := tarp * dbdf (tarp, b)
                 else b := tarp * dbdf (a, tarp);
              s := a + b;
            end;
    { patikrinsime, ar pavyko atstatyti }
    netruksta (a, b, s, mbk);
  end;

  procedure trys (var a, b, s, mbk : integer);
    { atstato skaiius, kai neinomi trys skaiiai }
  begin
    { atstatytsime skaii a }
    if a = 0
       then a := 1;
    { atstatysime skaii b }
    if s <> 0
       then b := s - a
       else if mbk <> 0
               then b := mbk
               else b := 1;
    { ir likusius du skaiius }
    if s = 0
       then s := a + b;
    if mbk = 0
       then mbk := mbkf(a, b);
    netruksta (a, b, s, mbk);
  end;

  procedure keturi (var a, b, s, mbk : integer);
    { atstato skaiius, kai neinomi visi keturi skaiiai }
  begin
    a := 1; b := 1;
    s := 2; mbk := 1;
  end;

  procedure atstatyti (var a, b, s, mbk : integer);
    { atstato trkstamus skaiius }
    var truksta,  { kiek skaii reikia atstatyti }
        a1, b1, s1, mbk1 : integer;
  begin
    { rasime kiek skaii trksta }
    truksta := ord(a = 0) + ord(b = 0) + ord(s = 0) + ord(mbk = 0);
    { isaugosime pradinius duomenis }
    a1 := a; b1 := b; s1 := s; mbk1 := mbk;
    if (s <> 0) and ((a >= s) or (b >= s))
       then begin { dmuo negali bti maesnis u sum }
              a := 0; b := 0;
              s := 0; mbk := 0;
            end
        else case truksta of
               0 : netruksta (a, b, s, mbk);
               1 : vienas (a, b, s, mbk);
               2 : du (a, b, s, mbk);
               3 : trys (a, b, s, mbk);
               4 : keturi (a, b, s, mbk);
             end;
      if (a = 0) and (truksta <> 0)
         { jei nepavyko atstatyti, griname ankstesnes reikmes }
         then begin
                a := a1; b := b1;
                s := s1; mbk := mbk1;
               end;
  end;

  var f : text;
      i, a, b, s, mbk : integer;
begin
  writeln ('veskite keturis skaiius: ');
  readln (a, b, s, mbk);
  atstatyti (a, b, s, mbk);
  writeln (a, ' ', b, ' ', s, ' ', mbk);
end.
