program remeliai;
  { 70 udavinys }
  const max_d = 30; { maksimalios pieinio dimensijos }
  type piesinys = array [1..max_d, 1..max_d] of char;
       remel = array ['A'..'Z'] of record
                                        x1, y1,
                                        x2, y2 : integer;
                                      end;
                 { rmelio apatinio kairiojo ir virutinio deiniojo }
                 { kamp koordinats }
        aibe = set of char; { aib skirting raidi, i kuri }
                            { sudaryti rmeliai }

  var ps : piesinys; { sudliot rmeli pieinys }
      a, p : integer;  { pieinio auktis ir plotis }
      { globals kintamieji visoms procedroms }

  {--------------------------------------------------------}
  procedure nuimti (remaib : aibe; rem : remel;
                    var raide : char); { raid, i kurios sudarytas }
                                       { nuimtasis rmelis }
    { nuima virutinj rmel, jo vietoje sudeda tako simbolius }
    var rasta : boolean;
        r : char;
        i : integer;
  begin
    { rasime rmel, kur reikia nuimti }
    rasta := false;
    r := 'A';
    while not rasta do  { tikrinsime, ar negalime nuimti rmelio, }
      if r in remaib    { sudaryto i raidi r }
           then begin
                  rasta := true;
                  { tikriname vertikalias rmelio sienas }
                  for i := rem[r].x1 to rem[r].x2 do
                   begin
                      rasta := (rasta and
                               (ps[i, rem[r].y1] in [r, '.'])) and
                               (ps[i, rem[r].y2] in [r, '.']);
                   end;
                  { tikriname horizontalias rmelio sienas }
                  for i := rem[r].y1 to rem[r].y2 do
                      rasta :=  rasta and
                               ((ps[rem[r].x1, i] in [r, '.']) and
                                (ps[rem[r].x2, i] in [r, '.']));
                   if not rasta
                      then r := succ(r)
                end
           else r := succ (r);
    raide := r;
    { nuimame raides }
    for i := rem[r].x1 to rem[r].x2 do
       begin
         ps[i, rem[r].y1] := '.';
         ps[i, rem[r].y2] := '.';
       end;
    for i := rem[r].y1 to rem[r].y2 do
       begin
         ps[rem[r].x1, i] := '.';
         ps[rem[r].x2, i] := '.';
       end;
  end;

  procedure koordinates (remaib : aibe; var rem : remel);
    { suranda vis rmeli koordinates - upildo masyv rem }
    var r : char;
        i, j : integer;
  begin
    { inicializuojame masyv rem }
    for r := 'A' to 'Z' do
      if r in remaib
           then begin
                  rem[r].x1 := max_d;
                  rem[r].y1 := max_d;
                  rem[r].x2 := 0;
                  rem[r].y2 := 0;
                end;
     { upildome j }
     for i := 1 to a do
       for j := 1 to p do
         if ps[i, j] <> '.'
            then begin
                   r := ps[i, j];
                   { tikriname eilut }
                   if i < rem[r].x1
                      then rem[r].x1 := i;
                   if i > rem[r].x2
                      then rem[r].x2 := i;
                   { tikriname stulpel }
                   if j < rem[r].y1
                      then rem[r].y1 := j;
                   if j > rem[r].y2
                      then rem[r].y2 := j;
                 end;
  end;


  procedure ieskoti (var tvarka : string);
    { surandama kokia tvarka buvo sudlioti rmeliai }
    var remaib : aibe;
        rem : remel;
        i, j : integer;
        raide : char;
  begin
    tvarka := '';
    remaib := [];
    { surasime visas raides i kuri sudaryti rmeliai }
    for i := 1 to a do
       for j := 1 to p do
           if ps[i, j] <> '.'
              then remaib := remaib + [ps[i, j]];
    { rasime kiekvieno rmelio koordinates }
    koordinates (remaib, rem);
    while remaib <> [] do { kol nenuimti visi rmeliai }
      begin
        nuimti (remaib, rem, raide);  { nuimamas virutinis rmelis }
        tvarka := tvarka + raide;
        remaib := remaib - [raide];
      end
  end;
{----------------------------------------------------------}
  var f : text;
      i, j : integer;
      tvarka : string;
begin
  assign (f, 'remeliai.dat');
  reset (f);
  readln (f, a);
  readln (f, p);
  for i := a downto 1 do
    begin
      for j := 1 to p do
         read (f, ps[i, j]);
      readln (f);
    end;
  close (f);

  ieskoti (tvarka);

  assign (f, 'remeliai.rez');
  rewrite (f);
  writeln (f, tvarka);
  close (f)
end.