#include <stdio.h>
#include <string.h>

#define LMAX 4010
#define NCMAX 21

//#define isOK(i, j)  ( ((ok[i][j >> 3]) & (bit[j & 7])) != 0 )
//#define setOK(i, j) ( (ok[i][j >> 3]) |= (bit[j & 7]) ) 

#define isOK(i, j) (ok[i][j])
#define setOK(i, j) (ok[i][j] = 1)

unsigned char ok[LMAX][LMAX/* >> 3*/], bit[8] = {1, 2, 4, 8, 16, 32, 64, 128 };
int P[3][LMAX], left[LMAX], right[LMAX], pre[LMAX], len[NCMAX];
char cuv[NCMAX][LMAX], sir[LMAX];
int i, j, k, L, Lmic, N, M, c;
char comp[256];

int main()
{
	// initializare
	comp['a'] = 't';
	comp['t'] = 'a';
	comp['c'] = 'g';
	comp['g'] = 'c';
	
	freopen("evo.in", "r", stdin);
	freopen("evo.out", "w", stdout);
	
	scanf("%d", &N);
	for (i = 1; i <= N; i++)
	{
		scanf("%s", cuv[i] + 1);
		len[i] = strlen(cuv[i] + 1);
	}
	
	scanf("%d", &M);
	while (M--)
	{
		scanf("%s", sir + 1);
		L = strlen(sir + 1);
		
		// initializare
		
		for (i = 1, Lmic = (L >> 3) + 3; i <= L; i++)
			for (j = 0; j <= L/*mic*/; j++)
				ok[i][j] = 0;
		
		// solutie
		
		// un KMP micutz :) , dar nu neaparat necesar (merge si algoritmul "naiv")
		
		c = 0;

		for (i = 1; i <= N; i++)
		{
			// functia prefix
			pre[1] = 0;
			k = 0;
			
			for (j = 2; j <= len[i]; j++)
			{
				while (k > 0 && cuv[i][k + 1] != cuv[i][j])
					k = pre[k];
				
				if (cuv[i][k + 1] == cuv[i][j])
					k++;
				
				pre[j] = k;
			}
			
			// string matching
			k = 0;
			for (j = 1; j <= L; j++)
			{
				while (k > 0 && cuv[i][k + 1] != sir[j])
					k = pre[k];
				
				if (cuv[i][k + 1] == sir[j])
					k++;
				
				if (k == len[i])
				{
					setOK((j - len[i] + 1), j);
					k = pre[k];
					c = 1;
				}
			}
		}

		if (!c)
			fprintf(stderr, "?");

		fprintf(stderr, "*\n");
		
		// dinamica O(L^2)
		
		// lungime 1
		for (i = 1; i <= L; i++)
		{
			P[0][i] = 0;
			P[1][i] = 0;
			left[i] = L + 1;
			right[i] = 0;
			
			if (isOK(i, i))
				left[i] = right[i] = i;
		}
		
		// lungime 2..L
		for (k = 2, c = 1; k <= L; k++)
		{
			c = (c + 1) % 3;
			
			for (i = 1; i <= L - k + 1; i++)
			{
				j = i + k - 1;
				
				// calculam P[i][j] , adica P[c][i]
				if (sir[i] == comp[sir[j]])
					P[c][i] = P[(c + 1) % 3][i + 1] + 1;
				else
					P[c][i] = 0;
				
				// calculam ok[i][j]
				if (!(isOK(i, j)) && P[c][i] >= 2 &&
					(right[i] >= (j - P[c][i] + 1) ||
					left[j] <= (i + P[c][i] - 1))
					)
					setOK(i, j);

				if (isOK(i, j))
				{
					right[i] = j;
					left[j] = i;
				}
			}
		}
		
		// afisare
		if (isOK(1, L))
		{
			printf("da\n");
			fprintf(stderr, "da\n");
		}
		else
		{
			printf("nu\n");
			fprintf(stderr, "nu\n");
		}
	}
	
	return 0;
}
