Program _bombo_;

const NMAX = 4;
      MMAX = 6;
      TMAX = NMAX * MMAX;
      MIC = -1;

type timearray = array [0..TMAX] of longint;
     ptimearray = ^timearray;

var bmax: array[0..MMAX, 0..MMAX, 0..MMAX, 0..MMAX] of ptimearray;
    z, b: array[1..NMAX, 1..MMAX] of longint;
    count, x, y: array[1..NMAX] of integer;
    i, j, k, N, M, i1, i2, i3, i4, tnext: integer;
    vmax, bo: longint;

begin
assign(input, 'bombo.in');
reset(input);
read(N, M);

for i := 1 to N do
  for j := 1 to M do
    read(z[i, j], b[i, j]);

close(input);

for i := 1 to N do
  count[i] := M;

for i := N + 1 to NMAX do
  count[i] := 0;

for i1 := count[1] downto 0 do
  for i2 := count[2] downto 0 do
    for i3 := count[3] downto 0 do
      for i4 := count[4] downto 0 do
        begin
          new(bmax[i1, i2, i3, i4]);

          for i := 0 to TMAX do
            bmax[i1, i2, i3, i4]^[i] := MIC;

          if (i1 = count[1]) and (i2 = count[2]) and (i3 = count[3]) and (i4 = count[4]) then
            bmax[i1, i2, i3, i4]^[0] := 0
          else
            begin
              x[1] := i1; x[2] := i2; x[3] := i3; x[4] := i4;

              for i := 1 to NMAX do
                y[i] := x[i];

              for i := 1 to N do
                if (x[i] < count[i]) then
                  begin
                    y[i] := y[i] + 1;

                    for j := 0 to TMAX do
                      begin
                        if (bmax[y[1], y[2], y[3], y[4]]^[j] <= MIC) then
                          continue;

                        if (j < z[i, y[i]]) then
                          begin
                            tnext := j + 1;
                            bo := bmax[y[1], y[2], y[3], y[4]]^[j] +
                                  (z[i, y[i]] - j) * b[i, y[i]];
                          end
                        else
                          begin
                            tnext := j;
                            bo := bmax[y[1], y[2], y[3], y[4]]^[j];
                          end;

                        if (tnext <= TMAX) and (bmax[x[1], x[2], x[3], x[4]]^[tnext] < bo) then
                          bmax[x[1], x[2], x[3], x[4]]^[tnext] := bo;
                      end;

                    y[i] := y[i] - 1;
                  end;
            end;
        end;

assign(output, 'bombo.out');
rewrite(output);

vmax := MIC;

for i := 0 to TMAX do
  if (bmax[0, 0, 0, 0]^[i] > vmax) then
    vmax := bmax[0, 0, 0, 0]^[i];

writeln(vmax);
close(output);
end.
