#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

const int nmax=50001;
const int mmax=100000;


struct muc {
	int a,b,c;
};



muc v[ mmax ]; //Muchiile 
bool used[ mmax ]; //Daca am folosit muchia in apm
int m,n;


//MIezu
set<pair<int,int> >vitale;
//


map<pair<int,int> ,int>cost; //Se putea evita dar salvez timp la implementare

void read() {	
	FILE *fin=fopen ("vitale.in","r");
	fscanf (fin,"%d %d",&n,&m);
	int i;
	for (i=0; i < m; ++i) {
		fscanf (fin,"%d %d %d",&v[ i ].a,&v[ i ].b,&v[ i ].c);
		if (v[ i ].a > v[ i ].b) swap(v[ i ].a,v[ i ].b);
		cost[ make_pair(v[i].a,v[i].b) ]=v[ i ].c;
		cost[ make_pair(v[i].b,v[i].a) ]=v[ i ].c;
	}
	fclose(fin);
}

inline bool cmp(struct muc a,struct muc b) {
	return a.c < b.c ? 1 : 0;
}


int padre[ nmax ];
int dd[ nmax ]; //Dimensiunea componentei de la apm cu radacina in a
int cmax; //Cea mai scumpa muchie din apm


vector<int>lv[ nmax ]; //Apm-u


void apm() {
     sort( v, v+m, cmp );
     int i;
	for (i=0; i < m; ++i) {
		int aa,bb;
		aa=v[ i ].a;
		bb=v[ i ].b;
		while (padre[ aa ]) aa=padre[ aa ];
		while (padre[ bb ]) bb=padre[ bb ];
		if (aa == bb) continue;
		used[ i ]=1;
		lv[ v[i].a ].push_back( v[ i ].b );
		lv[ v[i].b ].push_back( v[ i ].a );
		vitale.insert( make_pair(v[ i ].a, v[ i ].b) );
		cmax=v[ i ].c;
		padre[ aa ]=bb;
		dd[ aa ]+=dd[ bb ];
		if (dd[ aa ]==n) break;
	}
}


int lev[ nmax ];
int pi[ nmax ];

void df(int nod,int l) {
	lev[ nod ]=l;
	vector<int>::iterator i;
	for (i=lv[ nod ].begin(); i!= lv[ nod ].end(); ++i) 
		if (!lev[ *i ]) {
			pi[ *i ]=nod;
			df( *i,l+1 );
		}
}


void final() {
	int i;
	for (i=0; i < m; ++i) {
		if (v[ i ].c > cmax) break;
		if (used[ i ]) continue;
		int aa,bb;
		aa=v[ i ].a;
		bb=v[ i ].b;
		if (lev[ bb ] < lev[ aa ]) swap( aa, bb );
		do {
			if (cost[ make_pair(bb,pi[ bb ]) ] == v[ i ].c) 
				vitale.erase( make_pair( min(bb,pi[bb]),max(bb,pi[bb]) ) );
			bb=pi[ bb ];
		}while (bb!=aa);
	}
}


int main() {
	FILE *fout=fopen ("vitale.out","w");
	read();
	apm();
	df(1,1);
	final();
	set<pair<int,int> >::iterator i;
	fprintf (fout,"%d\n",vitale.size() );
	for (i=vitale.begin(); i!=vitale.end(); ++i)
		fprintf (fout,"%d %d\n",i->first,i->second);
	fclose(fout);
	return 0;
}

	


			
			
	




	
		
		
	
	

