# include <stdio.h>
# include <string.h>

# define _fin  "vitale.in"
# define _fout "vitale.out"

# define maxm 1000
# define maxn 500


int m, n, v[maxm][2], c[maxm], viz[maxn], maam[maxn], vit[maxm];
long long caam;
int *vv[maxn], cnt[maxn], vm[maxm];	// vm = viz muchie

// maam = muchiile arborelui de acoperie minim

void readf()
{
    int i;
    FILE *fin = fopen(_fin, "r");

    for(fscanf(fin, "%d %d", &n, &m), i=1; i<=m; i++)
	fscanf(fin, "%d %d %d", &v[i][0], &v[i][1], c+i),
	++cnt[ v[i][0] ], ++cnt[ v[i][1] ];

    for(i=1; i<=n; i++)
	vv[i] = new int [ cnt[i] + 1],
	vv[i][0] = 0;

    for(i=1; i<=m; i++)
	vv[ v[i][0] ][ ++vv[v[i][0]][0] ] = i,
	vv[ v[i][1] ][ ++vv[v[i][1]][0] ] = i;

    fclose(fin);
}

void writef()
{
    int i;
    FILE *fout=fopen(_fout,"w");

    for(fprintf(fout, "%d\n", vit[0]), i=1; i<=vit[0]; i++)
	fprintf(fout, "%d %d\n", v[vit[i]][0], v[vit[i]][1]);

    fclose(fout);
}

int a[maxm], h[maxm];	// heap-ul
int bka[maxm], bkh[maxm];

# define st(i) ( (i) << 1 )
# define dr(i) ( ((i) << 1) | 1 )
# define pr(i) ( (i) >> 1 )

void heapify(int nod)
{
    int i = nod, min;

    while(1)	//
    {
	min=i;

	if ( st(i) <= a[0] && c[a[st(i)]] < c[a[i]] ) min = st(i);
	if ( dr(i) <= a[0] && c[a[dr(i)]] < c[a[min]] ) min = dr(i);

	if ( min == i ) return;

	a[i] ^= a[min] ^= a[i] ^= a[min];
	h[ a[i] ] = i;
	h[ a[min] ] = min;

	i=min;
    }
}

void insert(int nod)
{
    int i = ++a[0];

    while ( c[ nod ] < c[ a[pr(i)] ] && i > 1 )
    {
	a[i] = a[pr(i)];
	h[a[i]] = i;
	i = pr(i);
    }

    h[a[i]=nod] = i;
}

int getmin()
{
    if ( a[0] == 0 ) return -1;

    int ret = a[1];
    a[1] = a[ a[0]-- ];
    h[ a[1] ] = 1;
    heapify(1);

    return ret;
}
/* quicksort pt. muchiile vitale */
int qs_poz(int st, int dr)
{
    int x[2] = { v[vit[st]][0], v[vit[st]][1] }, xx=vit[st];

    while ( st < dr )
    {
	while ( st < dr && ( v[vit[dr]][0] > x[0] || ( v[vit[dr]][0] == x[0] && v[vit[dr]][1] >= x[1] ) ) ) dr--;
	vit[st] = vit[dr];
	while ( st < dr && ( v[vit[st]][0] < x[0] || ( v[vit[st]][0] == x[0] && v[vit[st]][1] <= x[1] ) ) ) st++;
	vit[dr] = vit[st];
    }

    vit[st] = xx;
    return st;
}

void qs_norm(int st, int dr)
{
    int m = qs_poz(st, dr);
    if ( st < m ) qs_norm(st, m-1);
    if ( m < dr ) qs_norm(m+1, dr);
}


void solve()
{
    // efectuez primul AAM pentru a vedea care muchii ar putea fi vitale

    // creez o singura data heap-ul
    int i, nviz, min, mc, caux, nc;

    for(i=1; i<=vv[1][0]; i++)
	insert(vv[1][i]),
	vm[ vv[1][i] ] = 1;

    for(i=1; i<m; i++)	// am nevoie sa extrag exact n-1 muchii
    {
	min = getmin();

	if ( vm[min]==-1 )
	{
	    --m;
	    continue;
	}

	if ( !viz[nc = v[min][0]] )
	    for(i=1; i<=vv[nc][0]; i++)
		if ( !vm[ v[nc][i] ] )
		   insert( vv[nc][i] ),
		   vm[ vv[nc][i] ] = 1;
		else
		   vm[ vv[nc][i] ] = -1;

	viz[ v[min][0] ] = 1;

	if ( !viz[nc = v[min][1]] )
	    for(i=1; i<=v[nc][0]; i++)
		if ( !vm[ v[nc][i] ] )
		   insert( v[nc][i] ),
		   vm[ v[nc][i] ] = 1;
		else
		   vm[ v[nc][i] ] = -1;

	viz[ v[min][1] ] = 1;

	caam += c[ min ];
	vm[ min ] = -1;
    }

    if ( m == n-1 ) // arbore
    {
	for(i=1; i<=m; i++)
	    vit[ ++vit[0] ] = i;

	// toate muchiile sunt solutie
	return;
    }

    // acum luam pe rand toate muchiile din aam si le scoatem
    for(i=1; i<=maam[0]; i++)
    {
	memcpy(a, bka, sizeof(bka));
	memcpy(h, bkh, sizeof(bkh));
	memset(viz, 0, sizeof(viz));

	for(nviz=caux=0; nviz != n;)
	{
	    min = getmin();

	    if ( min == i ) continue; // nu folosim muchia curenta

	    if ( viz[ v[min][0] ] || viz[ v[min][1] ] )
		 caux += (long long)c[min],
		 maam[ ++maam[0] ] = min;

	    else continue;

	    nviz += ( !viz[ v[min][0] ] );
	    nviz += ( !viz[ v[min][1] ] );

	    viz[ v[min][0] ] = viz[ v[min][1] ] = 1;
	}

	if ( caux == caam )
	    vit[ ++vit[0] ] = i;
    }
}

int main()
{
    readf();
    solve();
    writef();

    return 0;
}