#include<stdio.h>
#include<stdlib.h>

#include<algorithm>
using namespace std;

#define MIN(x,y) ((x)<(y)?(x):(y))
#define MAX(x,y) ((x)>(y)?(x):(y))

#define MAXN 50002
#define MAXM 100002

int dm[MAXN];

int cval;
int nad[MAXN];
int mluat[MAXM];
int mcrit[MAXM];

int n, m;
int *lad[MAXN];
int gr[MAXN];
struct mymuc {int x, y, c;} muc[MAXM], outmuc[MAXM], orgmuc[MAXM];

struct mcmp
{
   const bool operator () (const mymuc &a, const mymuc &b)
   {
      return (a.c==b.c) ? ((a.x==b.x) ? (a.y<b.y) : (a.x<b.x)) : (a.c<b.c);
   }
};
struct omcmp
{
   const bool operator () (const mymuc &a, const mymuc &b)
   {
      return (a.x==b.x) ? ((a.y==b.y) ? (a.c<b.c) : (a.y<b.y)) : (a.x<b.x);
   }
};

int parinte(int x)
{
   if (dm[x] != x)
      return dm[x] = parinte(dm[x]);
   else return x;
}

int tmp[MAXN];
void unite (int x, int y)
{
   dm[dm[x]] = dm[y];
   
   for (int i=0; i<gr[y]; ++i)
      tmp[i] = lad[y][i];
   free(lad[y]);
   lad[y] = (int *) malloc(sizeof(int) * (gr[x]+gr[y]+1));
   for (int i=0; i<gr[y]; ++i)
      lad[y][i] = tmp[i];
   for (int i=0; i<gr[x]; ++i)
      lad[y][i+gr[y]] = lad[x][i];
   gr[y] +=gr[x];
}


int ad;
void dfs(int pos, int mpar)
{
   ++ad;
   nad[pos] = ad;
   int i, vec;
   for (i=gr[pos]-1; i>=0; --i)
   {
      if (!mluat[lad[pos][i]] && cval==muc[lad[pos][i]].c)
      {
         if (parinte(muc[lad[pos][i]].x) == pos) vec = parinte(muc[lad[pos][i]].y);
            else vec = parinte(muc[lad[pos][i]].x);
         if (lad[pos][i] != mpar)
         {
            if (nad[vec] == 0)
               dfs(vec, lad[pos][i]);
            nad[pos] = MIN(nad[pos], nad[vec]);
         }
      }
   }
   if (nad[pos] == ad)
      mcrit[mpar] = 1;
   /*
      for (i=gr[pos]-1; i>=0; --i)
      if (!mluat[lad[pos][i]] && cval==muc[lad[pos][i]].c)
      {
         if (parinte(muc[lad[pos][i]].x) == pos) vec = parinte(muc[lad[pos][i]].y);
            else vec = parinte(muc[lad[pos][i]].x);
         if (lad[pos][i] == mpar)
         {
            mcrit[lad[pos][i]] = 1;
            break;
         }
      }
   */
   --ad;
}

int main(void)
{
   freopen("vitale.in", "rt", stdin);
   freopen("vitale.out", "wt", stdout);

   int x, y, z;
   int i;

   scanf("%d%d", &n, &m);
   for (i=0; i<m; ++i)
   {
      scanf("%d%d%d", &x, &y, &z);
      muc[i].x = x; muc[i].y = y; muc[i].c = z;
      gr[x]++; gr[y]++;
   }
   sort(&muc[0], &muc[m], mcmp());
   memcpy(orgmuc, muc, sizeof(orgmuc));
   
   for (i=0; i<=n; ++i)
   {
      lad[i] = (int *) malloc(sizeof(int) * (gr[i]+1));
      gr[i] = 0;
   }
   for (i=0; i<m; ++i)
   {
      x = muc[i].x; y = muc[i].y;
      lad[x][gr[x]++] = i;
      lad[y][gr[y]++] = i;
   }

   for (i=0; i<=n; ++i) dm[i] = i;

   int last, minm, maxm;
   int j;
   last = muc[0].c; minm=1000000; maxm=-1;
   muc[m].x = muc[m].y = 0; muc[m].c = 1100000000;
   for (i=0; i<=m; ++i)
   {
      x = parinte(muc[i].x); y = parinte(muc[i].y);
      z = muc[i].c;
      if (z!=last)
      {
         cval = last;
         for (j=minm; j<=maxm; ++j)
            nad[j] = 0;
         for (j=minm; j<=maxm; ++j)
            if (nad[j] == 0)
            {
               ad = 1;
               dfs(j, 100001);
            }

         for (j=i-1; j>=0 && muc[j].c==last; --j)
            if (parinte(muc[j].x) != parinte(muc[j].y))
            {
               unite(muc[j].x, muc[j].y);
               muc[j].x = muc[j].y;
            }
            
         last = z;
         minm=1000000; maxm=-1;
         i--;
      }
      else
      {
         minm = MIN(minm, x); minm = MIN(minm, y);
         maxm = MAX(maxm, x); maxm = MAX(maxm, y);
      }
   }

   memcpy(muc, orgmuc, sizeof(muc));
   x = 0;
   for (i=0; i<m; ++i)
      if (mcrit[i])
      {
         //outmuc[x] = muc[i];
         outmuc[x].x = muc[i].x;
         outmuc[x].y = muc[i].y;
         outmuc[x].c = muc[i].c;
         
         if (outmuc[x].y<outmuc[x].x)
         {
            y = outmuc[x].x;
            outmuc[x].x = outmuc[x].y;
            outmuc[x].y = y;
         }
         ++x;
      }
   sort(&outmuc[0], &outmuc[x], omcmp());
   printf("%d\n", x);
   for (i=0; i<x; ++i)
      printf("%d %d\n", outmuc[i].x, outmuc[i].y);

   return 0;
}

