program vitale;

const filein = 'vitale.in';
      fileout = 'vitale.out';
      Nmax = 50000;
      Mmax = 100000;
      infinit = 1500000000; //un miliard jumate

type pnod = ^nod;
     nod = record
       val, cost : longint;
       next : pnod;
     end;

var N, M, max, lheap, cont, i, lung, lfin : longint;
    vec : array[0..Nmax] of pnod;
    viz : array[0..Nmax] of boolean;
    d, poz, heap, admax, par, niv : array[0..Nmax] of longint;
    st1, st2, v, st3, el1, el2, fin1, fin2 : array[0..Mmax] of longint;

procedure readdata;
var i, a, b, c : longint;
    p : pnod;
begin
assign(input, filein); reset(input);
read(N, M);

for i := 1 to M do
  begin
    read(a, b, c);

    new(p); p^.next := vec[a];
    p^.val := b; p^.cost := c;
    vec[a] := p;

    new(p); p^.next := vec[b];
    p^.val := a; p^.cost := c;
    vec[b] := p;
  end;
close(input);
end;

procedure reconst(k : longint);
var max, aux : longint;
begin
max := k;

if 2*k <=lheap then
if d[heap[2*k]] < d[k] then
  max := 2*k;

if 2*k+1 <=lheap then
if d[heap[2*k+1]] < d[k] then
  max := 2*k+1;

if max <> k then
  begin
    aux := heap[k];
    heap[k] := heap[max];
    heap[max] := aux;

    poz[heap[k]] := k;
    poz[heap[max]] := max;

    reconst(max);
  end;
end;

procedure scoate;
begin
if d[heap[1]] > max then
  max := d[heap[1]];

heap[1] := heap[lheap];
poz[heap[1]] := 1;
dec(lheap);
reconst(1);
end;

procedure reconst2(k : longint);
var max, aux : longint;
begin
if k = 1 then exit;
max := k div 2;
if d[heap[max]] > d[heap[k]] then
  begin
    aux := heap[k];
    heap[k] := heap[max];
    heap[max] := aux;

    poz[heap[k]] := k;
    poz[heap[max]] := max;

    reconst2(max);
  end;
end;

procedure afla_max;
var viz : array[1..Nmax] of boolean;
    i, j, min, poz : longint;
    p : pnod;
begin
fillchar(viz, sizeof(viz), false);
for i := 2 to N do d[i] := infinit;
d[1] := 0;
for i := 1 to N do
  begin
    min := maxlongint;
    for j := 1 to N do
      if not viz[j] then
      if d[j] < min then
        begin
          min := d[j];
          poz := j;
        end;
    if min > max then max := min;
    viz[poz] := true;

    p := vec[poz];
    while p <> nil do
      begin
        if not viz[p^.val] then
        if p^.cost < d[p^.val] then
          d[p^.val] := p^.cost;
        p := p^.next;
      end;
  end;
end;

procedure insert_stiva(i, j, c : longint);
begin
inc(cont);
st1[cont] := i;
st2[cont] := j;
st3[cont] := c;
end;

procedure qsort(st, dr : longint);
var i, j, m, sch, aux : longint;
begin
i := st;
j := dr;
m := (st + dr) shr 1;
sch := v[m];

repeat
  while v[i] < sch do inc(i);
  while v[j] > sch do dec(j);
  if i <= j then
    begin
      aux := v[i]; v[i] :=v[j]; v[j] :=aux;
      aux := el1[i]; el1[i] :=el1[j]; el1[j] :=aux;
      aux := el2[i]; el2[i] :=el2[j]; el2[j] :=aux;
      inc(i);
      dec(j);
    end;
until i > j;

if i < dr then qsort(i, dr);
if j > st then qsort(st, j);
end;

procedure scoate_stiva(i, j : longint);
begin
lung := 0;
while (st1[cont] <> i) or (st2[cont] <> j) do
  begin
    inc(lung); v[lung] := st3[cont];
    el1[lung] := st1[cont];
    el2[lung] := st2[cont];
    dec(cont);
  end;
inc(lung);
v[lung] := st3[cont];
el1[lung] := i;
el2[lung] := j;
dec(cont);
qsort(1, lung);
for i := lung downto 2 do
  if v[i] <> v[i-1] then
    begin
      inc(lfin);
      fin1[lfin] := el1[i];
      fin2[lfin] := el2[i];
    end
  else break;
for j := i downto 0 do
  if v[j] <> v[i] then break;

for i := j downto 1 do
  begin
    inc(lfin);
    fin1[lfin] := el1[i];
    fin2[lfin] := el2[i];
  end;
end;

procedure df(k : longint);
var p : pnod;
begin
viz[k] := true;
admax[k] := niv[k];
p := vec[k];
while p <> nil do
  begin
    if p^.cost <= max then
      begin
        if not viz[p^.val] then
          begin
            niv[p^.val] := niv[k]+1;
            par[p^.val] := k;
            insert_stiva(k, p^.val, p^.cost);
            df(p^.val);
            if admax[p^.val] < admax[k] then
              admax[k] := admax[p^.val];

            if admax[p^.val] >= niv[k] then
              begin
                scoate_stiva(k, p^.val);
              end;
          end
        else
          begin
            if (niv[p^.val] < niv[k]) and (p^.val <> par[k]) then
              begin
                if niv[p^.val] < admax[k] then admax[k] := niv[p^.val];
                insert_stiva(k, p^.val, p^.cost);
              end;
          end;
      end;
    p := p^.next;
  end;
end;

procedure sort2(st, dr : longint);
var i, j, m, sch1, sch2, aux : longint;
begin
i := st;
j := dr;
m := (st + dr) shr 1;
sch1 := fin1[m];
sch2 := fin2[m];

repeat
  while (fin1[i] < sch1) or ((fin1[i] = sch1) and (fin2[i] < sch2)) do inc(i);
  while (fin1[j] > sch1) or ((fin1[j] = sch1) and (fin2[j] > sch2)) do dec(j);
  if i <= j then
    begin
      aux := fin1[i]; fin1[i] :=fin1[j]; fin1[j] :=aux;
      aux := fin2[i]; fin2[i] :=fin2[j]; fin2[j] :=aux;
      inc(i);
      dec(j);
    end;
until i > j;

if i < dr then sort2(i, dr);
if j > st then sort2(st, j);
end;

procedure writedata;
var i : longint;
begin
assign(output, fileout); rewrite(output);
writeln(lfin);

for i := 1 to lfin do
  writeln(fin1[i],' ',fin2[i]);
close(output);
end;

begin
readdata;
afla_max;
df(1);
for i := 1 to lfin do
  if fin1[i] > fin2[i] then begin
    fin1[i] := fin1[i]  xor fin2[i];
    fin2[i] := fin1[i]  xor fin2[i];
    fin1[i] := fin1[i]  xor fin2[i];
  end;

sort2(1, lfin);

writedata;
end.
