#include <fstream.h>
#define Infile "diamant.in"
#define Outfile "diamant.out"
#define DIM 501

long int x[DIM];
long int sum[DIM], a[DIM];
long int n, m, q, lung, nrsol;

void Read();
void Solve();
void Back ( int k );
void Write();
void Ok();

int main()
{
	Read();
	Solve();
	Write();

	return 0;
}

void Read()
{
	ifstream fin(Infile);

	fin >> n >> m >> q;

	lung = n * m;

	fin.close();
}

void Solve()
{
	int i, j, val;
	val = 0;
	for ( i = 1; i <= n; i++ )
		for ( j = 1; j <= m; j++ )
		{
			val++;
			a[val] = i * j;
		}


	Back(1);

}

void Back ( int k )
{
	int i, ii, jj;
	for ( i = -1; i <= 1; i++ )
	{
		x[k] = i;

		sum[k] = sum[k-1] + i * a[k];

		if ( k == lung ) Ok();
		else if ( k < lung ) Back(k+1);

		sum[k] = 0;
	}
}

void Ok()
{
	if ( sum[lung] == q )
		nrsol++;
	nrsol = nrsol % 10000;
}

void Write()
{
	ofstream fout(Outfile);

	fout << nrsol << endl;

	fout.close();
}



