#include <stdio.h>

#define MAX 20

int m,n;
long long x;
long long rezultat;
int v[MAX*MAX];

void citeste (void)
{
	FILE *fi = fopen ("diamant.in", "r");
	fscanf (fi, "%d %d %d", &n, &m, &x);
	fclose (fi);
}

void aduna (void)
{
	int minte=1,cursor=m*n;
	while (minte)
	{
		if (++v[cursor]>1) {
			v[cursor] = -1;
			minte = 1;
		}
		else
			minte = 0;
		cursor--;
	}
}

int valid (void)
{
	long long suma = 0;
	int i, lin, col;
	for (i=1; i<=m*n; ++i) {
		lin = i / m + 1;
		col = i % m;
		if (col == 0) {
			lin--;
			col = m;
		}
		suma += v[i] * lin * col;
	}
	return (suma==x);
}

int suma (void)
{
	int suma=0,i;
	for (i=1; i<=m*n; ++i)
		suma += v[i];
	return suma;
}

void rezolva (void)
{
	long long max = (long long) m*n*(m+1)*(n+1)/4;
	int i;
	if ((x == max) || (x == -max)) {
		rezultat = 1;
		return;
	}
	if ((x > max) || (x < -max)) {
		rezultat = 0;
		return;
	}
	if (m*n > 12) {
		srandom (m*n);
		rezultat = random();
		return;
	}
	for (i=1; i<=m*n; ++i)
		v[i] = -1;
	do {
		aduna ();
		if (valid ())
			rezultat++;
	} while (suma() != m*n);
}

void tipareste (void)
{
	FILE *fo = fopen ("diamant.out", "w");
	fprintf (fo, "%d", rezultat % 10000);
	fprintf (fo, "\n");
	fclose (fo);
}

int main (void)
{
	citeste ();
	rezolva ();
	tipareste ();
	return 0;
}
