#include <stdio.h>
#define MOD 30103
#define nmax 8111

int n,m,h,k,fact[nmax],inv[nmax],sol,N;

int smn(int i,int j,int t)
{
  return(((n+m+h-i-j-t)&1)?-1:+1);
}

int comb(int i,int j)
{
  if(i<j)
    return(0);    
  return((((fact[i]*inv[j])%MOD)*inv[i-j])%MOD);
}

int doit(int i,int j,int t)
{
  return((((comb(i*j*t,k)*comb(n,i))%MOD)*((comb(m,j)*comb(h,t))%MOD))%MOD);
}

int put(int a,int x)
{
  if(!x)
    return(1);
  int aux=put(a,x>>1);
  aux=(aux*aux)%MOD;
  if(x&1)
    aux=(aux*a)%MOD;
  return(aux);
}

int main()
{
  FILE *fi=fopen("borg.in","r"),*fo=fopen("borg.out","w");
  fscanf(fi,"%d %d %d %d",&n,&m,&h,&k);  
  fclose(fi);
  int i,j,t;
  for(N=n*m*h,fact[0]=inv[0]=1,i=1;i<=N;++i)
  {
    fact[i]=(fact[i-1]*i)%MOD;
    inv[i]=put(fact[i],MOD-2);
  }
  for(i=1;i<=n;++i)
    for(j=1;j<=m;++j)
      for(t=1;t<=h;++t)
      {
	sol+=smn(i,j,t)*doit(i,j,t);
	if(sol>=0)
	  sol%=MOD;
	else
	  sol+=MOD;	  
      }
  fprintf(fo,"%d\n",sol);
  fclose(fo);
  return(0);
}
