#include <stdio.h>
#include <stdlib.h>

typedef struct Muchie{
	int A;
	int B;
	int C;//costul SAU indicele real al muchiei
}Muchie;

int N, M;
Muchie Muc[100001];
Muchie Tmp[100001];

int Comp0;//nr. comp. cnx.
int ContC[50001];//card(comp. cnx.)
int Comp[50001];//carei comp. ii apartine nodul i?

int Grad[50001];
int *Vec[50001];

int SOL0;
char sol[100001];
Muchie SOL[100001];

//============

int n;
int m;
int grad[50001];
Muchie *vec[50001];

int Alloc0;
Muchie Alloc[100001];

void Sortare(Muchie *Muc, int Start, int Stop, int type){
	if (Start!=Stop){
		int Med = (Start+Stop)/2;
		int pos,pos1,pos2;
		Sortare(Muc, Start,Med, type);
		Sortare(Muc, Med+1,Stop, type);
		pos = Start;
		pos1= Start;
		pos2= Med+1;
		if (type==1){
			for(;pos1<=Med && pos2<=Stop;pos++){
				if (Muc[pos1].C<Muc[pos2].C){
					Tmp[pos] = Muc[pos1++];
				}else{
					Tmp[pos] = Muc[pos2++];
				}
			}
		}else{
			for(;pos1<=Med && pos2<=Stop;pos++){
				if (Muc[pos1].A < Muc[pos2].A || Muc[pos1].A == Muc[pos2].A && Muc[pos1].B < Muc[pos2].B){
					Tmp[pos] = Muc[pos1++];
				}else{
					Tmp[pos] = Muc[pos2++];
				}
			}
		}
		for(;pos1<=Med;pos++){
			Tmp[pos] = Muc[pos1++];
		}
		for(;pos2<=Stop;pos++){
			Tmp[pos] = Muc[pos2++];
		}
		for(pos=Start;pos<=Stop;pos++){
			Muc[pos] = Tmp[pos];
		}
	}
}

void Change(int pos, int val){
	ContC[Comp[pos]]--;
	if (ContC[Comp[pos]] == 0) Comp0--;
	Comp[pos] = val;
	//if (ContC[Comp[pos]] == 0) Comp0++;
	ContC[Comp[pos]]++;
}

void Convert(int pos, int val1, int val2){
	Change(pos, val2);
	int a;
	for(a=0;a<Grad[pos];a++){
		if (Comp[Vec[pos][a]] == val1){
			Convert(Vec[pos][a], val1, val2);
		}
	}
}

int compcnx[50001];
int Stiva0;
int Stiva[50001];
int StivaM[50001];
int EsteS[50001];

int KillCicle(int pos, int tata){
	compcnx[pos] = 1;
	Stiva [++Stiva0] = pos;
	EsteS[pos] = Stiva0;
	int a,b;
	for(a=0;a<grad[pos];a++) if (vec[pos][a].B != tata){
		if (EsteS[vec[pos][a].B]){
			//muchie inapoi;
			for(b=EsteS[vec[pos][a].B];b<=Stiva0;b++){
				sol[StivaM[b]] = 0;
			}
			sol[vec[pos][a].C] = 0;
		}else{
			StivaM[Stiva0] = vec[pos][a].C;
			KillCicle(vec[pos][a].B, pos);
		}
	}
	Stiva0--;
	EsteS[pos] = 0;
}

int main(void){
	int a,b;
	int tmp;
	FILE *e,*ee;
	e=fopen("vitale.in","r");
		fscanf(e, "%d %d", &N, &M);
		for(a=1;a<=M;a++){
			fscanf(e, "%d %d %d", &Muc[a].A, &Muc[a].B, &Muc[a].C);
			Grad[Muc[a].A]++;
			Grad[Muc[a].B]++;
		}
		for(a=1;a<=N;a++){
			Vec[a] = (int*)malloc(Grad[a]*sizeof(int));
			Grad[a] = 0;
		}
		for(a=1;a<=M;a++){
			Vec[Muc[a].A][Grad[Muc[a].A]++] = Muc[a].B;
			Vec[Muc[a].B][Grad[Muc[a].B]++] = Muc[a].A;
		}
	fclose(e);
	Comp0 = N;
	for(a=1;a<=N;a++){
		ContC[a] = 1;
		Comp[a] = a;
	}
	for(a=1;a<=M;a++){
		sol[a] = 1;
	}
	Sortare(Muc, 1, M, 1);
	for(a=1;a<=M;){
		Alloc0=0;
		n=N;
		m=0;
		for(b=a;Muc[b].C==Muc[a].C;b++){
			Alloc[++Alloc0].A = Comp[Muc[b].A];
			Alloc[  Alloc0].B = Comp[Muc[b].B];
			Alloc[  Alloc0].C = b;
			Alloc[++Alloc0].A = Comp[Muc[b].B];
			Alloc[  Alloc0].B = Comp[Muc[b].A];
			Alloc[  Alloc0].C = b;
		}
		Sortare(Alloc,1,Alloc0,2);
		m=Alloc0;
		Alloc0=0;
		for(b=1;b<=m;b++){
			if (Alloc[b].A == Alloc[b].B || Alloc[b].A == Alloc[b-1].A && Alloc[b].B == Alloc[b-1].B){
				sol[Alloc[b].C] = 0;
				sol[Alloc[b-1].C] = 0;
			}else{
				Alloc[++Alloc0] = Alloc[b];
			}
		}
		m=Alloc0;
		for(b=1;b<=n;b++){
			grad[b] = 0;
			vec[b] = NULL;
			compcnx[b] = 0;
		}
		for(b=m;b>=1;b--){
			grad[Alloc[b].A]++;
			vec[Alloc[b].A] = &Alloc[b];
		}
		Stiva0=0;
		for(b=1;b<=N;b++) if (grad[b]){
			if (!compcnx[b]){
				KillCicle(b,0);
			}
		}

		for(b=a;Muc[b].C==Muc[a].C;b++){
			if (Comp[Muc[b].A] != Comp[Muc[b].B]){
				if (ContC[Comp[Muc[b].A]] < ContC[Comp[Muc[b].B]]){
					tmp = Muc[b].A;
					Muc[b].A = Muc[b].B;
					Muc[b].B = tmp;
				}
				Convert(Muc[b].B, Comp[Muc[b].B], Comp[Muc[b].A]);
			}
		}
		a=b;
	}
	for(a=1;a<=M;a++) if (sol[a]){
		if (Muc[a].A > Muc[a].B){
			tmp = Muc[a].A;
			Muc[a].A = Muc[a].B;
			Muc[a].B = tmp;
		}
		SOL[++SOL0] = Muc[a];
	}
	if (SOL0) Sortare(SOL, 1, SOL0, 2);
	ee=fopen("vitale.out","w");
		fprintf(ee,"%d\n", SOL0);
		for(a=1;a<=SOL0;a++){
			fprintf(ee,"%d %d\n", SOL[a].A, SOL[a].B);
		}
	fclose(ee);
	return 0;
}

