
#include <cstdio>
#include <cstring>

#define MV (21*21*10*10*2+11)
#define HF (MV/2)
#define DD 210
#define AT (M*(M+1)/2)
#define TREH ((N*(N+1)/2)*(M*(M+1)/2))

int N, M, X, L[21][2*DD+10], T[21][MV];

inline int gL( int a, int b ){
   if( b >= -DD && b <= DD ) return L[a][b+DD]%10000;
   return 0;
}

inline void uL( int a, int b, int v ){
   if( b >= -DD && b <= DD )
   { L[a][b+DD] += v; L[a][b+DD] %= 10000; }
}

int rec( int i, int k )
{
    int & r = T[i][k+HF], c;

    if( r != -1 ) return r;

    r = 0;

    if( i == 0 ) return r=0;
    
    for( int j = -AT; j <= AT; j++)
       if( gL(M,j) && k+i*j >= -TREH && k+i*j <= TREH )
          c = rec( i-1, k+i*j),
          c %= 10000,
          c *= gL(M,j),
          r = ( r + c ) % 10000;

    return r;
}

int main()
{
    freopen("diamant.in", "r", stdin);
    freopen("diamant.out", "w", stdout);

    int i, j, k;

    scanf("%d %d %d", &N, &M, &X);

    if( X < -TREH || X > TREH )
    { printf("%d\n", 0 ); return 0; }

//    printf("-> %d\n", TREH );

    uL(0,0,1);

    for(i = 1; i <= M; i++)
        for(j = -DD; j <= DD; j++)
            uL( i,j, gL(i-1,j) ),
            uL( i,j, gL(i-1,j-i) ),
            uL( i,j, gL(i-1,j+i) );

            
//    memset( T, -1, sizeof( T ) );

    T[0][HF] = 1;

    int COUNT = 0;

    for(i = 1; i <= N; i++)
       for(j = -AT; j <= AT; j++)
          if( gL(M,j) )
          for(k = HF - TREH; k <= HF + TREH; k++)
              if( k + i*j <= HF + TREH && k + i*j >= HF - TREH
                  && T[i-1][k+i*j] )
                  T[i][k] += T[i-1][k+i*j] * gL(M,j),
                  T[i][k] %= 10000;
/*
   for(i = 1; i <= N; i++)
       for(j = 0; j < MV; j++)
          if( j - HF <= ( i*(i+1)/2 )*AT && j - HF >= -(i*(i+1)/2)*AT )
          {
             COUNT += 25;
          }
*/
//   printf("%d\n", COUNT );
//              printf("A[%d][%d] = %d\n", i, j, T[i][j] );

//    printf("BAH!\n");
//    printf("%d\n", TREH );
//    printf("%d\n", rec( N, X ) );
    printf("%d\n", T[N][X+HF] );    
    return 0;
}
