using namespace std;

#include <cstdio>
#include <vector>
#include <queue>
#include <algorithm>

#define pb push_back
#define MV (1<<16)

#define X first
#define Y second
#define mk make_pair

int N, M, d[MV], amin[2*MV], p[MV];
vector<int> g[MV], cost[MV], arb[MV], arbc[MV];
vector< pair<int,int> > sol;

struct mine{
   int x, y, c;
   mine(){};
   mine( int a, int b, int cc ){ x = a, y = b, c = cc; }
};

bool operator < ( mine m1, mine m2 ){
   return m1.c > m2.c;
}

priority_queue< mine > heap;

inline void upd( int pos, int val )
{
   d[ pos ] = val;

   for( int i = ( pos + MV ) >> 1; i >= 1; i >>= 1 )
   {
       if( d[ amin[2*i] ] <= d[ amin[2*i+1] ] )
          amin[i] = amin[2*i];
       else
          amin[i] = amin[2*i+1];
   }
}

void prim()
{
    int i, j, x, cst = 0;
    char u[MV];

    memset( u, 0, sizeof( u ) );
    
    for(i = 0; i < MV; i++)
        amin[MV+i] = i;
    for(i = MV - 1; i >= 1; i--)
        amin[i] = amin[2*i];

    for(i = 0; i < MV; i++)
        upd(i,1000111222);
       
    upd(0,0);
    p[0] = -1;

    for(i = 1; i <= N; i++)
    {
        x = amin[1];
        u[x] = 1;

        if( p[x] >= 0 )
        {
//           printf("=> %d, %d\n", p[x], x );
           arb[ p[x] ].pb( x ), arb[x].pb( p[x] ),
           arbc[ p[x] ].pb( d[x] ), arbc[ x ].pb( d[x] );
        }
        
//        cst += d[x];
//        printf("%d %d\n", x, d[x] );  fflush( stdout );
        upd(x,1000111222);
        for(j = 0; j < g[x].size(); j++)
          if( !u[ g[x][j] ] && d[ g[x][j] ] > cost[x][j]  )
          {
//              printf("-> %d\n", g[x][j] );
              upd( g[x][j], cost[x][j] ),
              p[ g[x][j] ] = x;
          }
    }

//    printf("cost = %d\n", cst );
}

void solve()
{
    char u[MV]; memset( u, 0, sizeof( u ) );
    int i, x, y, j, k, q[2*MV], coco[2*MV], l, r, el, cur;
    mine mm;

    q[l=r=0] = 0;

    for( ; l<=r; l++ )
    {
       el = q[l]; u[el] = 1;
       for(i = 0; i < arb[el].size(); i++)
          if( !u[ arb[el][i] ] )
              u[ arb[el][i] ] = 1,
              q[++r] = arb[el][i],
              p[ arb[el][i] ] = el,
              coco[r] = arbc[el][i];
    }

    memset( u, 0, sizeof( u ) );

    for(i = 1; i < N; i++)
    {
//        u[ x = q[l++] ] = 1;
        u[ x = p[ q[i] ] ] = 1;
//        printf("anal : %d\n", x );

        for(j = 0; j < g[x].size(); j++)
           if( !u[ g[x][j] ] )
           {
//              printf("add : %d,%d\n", x, g[x][j] );
              heap.push( mine( x, g[x][j], cost[x][j] ) );
           }
/*
        for(j = 0; j < arb[x].size(); j++)
        if( !u[ arb[x][j] ] )
*/
            el = q[i];
            cur = coco[i];
/*
            printf("testing : %d %d -> %d\n", x, el, cur );
            printf("%d\n", heap.size() ); fflush( stdout );
*/
            mm = heap.top();
            if( (mm.x == x && mm.y == el)
                || ( mm.y == el && mm.x == x ) )
                heap.pop();
            if( heap.size() == 0 )
            {
            sol.pb( mk( x+1, el+1 ) );
//            printf("noheap!\n");
      P      }
            else{
              mm = heap.top();
              if( mm.c > cur ){
              sol.pb( mk( x+1, el+1 ) );
//             printf("hh!\n");
              }
            }
            
            u[ el ] = 1;

            for(k = 0; k < arb[el].size(); k++)
               if( u[ arb[el][k] ] && heap.size() )
               {
                 mm = heap.top();
                 if( (mm.x == el && mm.y ==  arb[el][k] )
                    || ( mm.y == el && mm.x == arb[el][k] ) )
                         heap.pop();
               }
 //       }
    }
    
}

int main()
{
    freopen("vitale.in", "r", stdin);
    freopen("vitale.out", "w", stdout);

    int i, x, y, c;

    scanf("%d %d", &N, &M);
    for(i = 1; i <= M; i++)
    {
       scanf("%d %d %d", &x, &y, &c);
       --x, --y;
       g[x].pb(y), g[y].pb(x);
       cost[x].pb(c), cost[y].pb(c);
    }

    prim();
    solve();

    for(i = 0; i < sol.size(); i++)
       if( sol[i].X > sol[i].Y )
          swap( sol[i].X, sol[i].Y );

    sort( sol.begin(), sol.end() );

    printf("%d\n", sol.size() );
    for(i = 0; i < sol.size(); i++)
       printf("%d %d\n", sol[i].X, sol[i].Y );
    
    return 0;
}
