#include <stdio.h>
#include <string.h>
#define modulo 10000

int D[100000], E[100000];
#define D(x) D[x+50000]
#define E(x) E[x+50000]
int N, M, X;

int Solve()
{
    int min, max, i, j, l, t;
    
    memset(D, 0, sizeof(D));
    D(0) = 1; min = max = 0;
    for (i = 1; i <= N; i++)
    for (j = 1; j <= M; j++)
    {
        t = i * j;
        min -= t, max += t;
        for (l = min; l <= max; l++)
            E(l) = (D(l+t) + D(l-t) + D(l)) % modulo;
        for (l = min; l <= max; l++) D(l) = E(l);
    }
    return D(X);
}

int main()
{
    int i, j, t;
    
    freopen("diamant.in", "r", stdin);
    freopen("diamant.out", "w", stdout);
    scanf("%d %d %d", &N, &M, &X);
    if (X < 0) X *= -1;
    t = 0;
    for (i = 1; i <= N; i++)
    for (j = 1; j <= M; j++)
        t += i * j;
    if (X > t) printf("0\n");
    else printf("%d\n", Solve());

    return 0;
}
