#include <stdio.h>
#include <string.h>

#define FIN "diamant.in"
#define FOUT "diamant.out"

#define MAX_N 2
#define MOD 10000
#define ADD 50000
#define MAX_V 100000

int C[MAX_N][MAX_V];

int main(void)
{
    int i, j, k, last, actual, new_add, N, M, X;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d %d %d", &N, &M, &X);
    if (X > (N * (N + 1) * M * (M + 1)) >> 2)
    {
        printf("0\n");
        return 0;
    }
    last = 0, actual = 1;
    memset(C, 0, sizeof(C));
    C[last][ADD] = 1;
    for (i = 0; i < N; i++)
        for (j = 0; j < M; j++, last = 1 - last, actual = 1 - actual)
        {
            new_add = (i + 1) * (j + 1);
            memset(C[actual], 0, sizeof(C[actual]));
            for (k = 0; k < MAX_V; k++)
            {
                if (k - new_add >= 0) C[actual][k] += C[last][k - new_add];
                C[actual][k] += C[last][k];
                if (k + new_add < MAX_V) C[actual][k] += C[last][k + new_add];
                C[actual][k] %= MOD;
            }
        }

    printf("%d\n", C[last][X + ADD]);

    return 0;
}
