#include <stdio.h>
#include <string.h>

#define MAXS 45000
#define Q 10000

void read(void);

int M, N, X, S, V[2 * MAXS], tmp[2 * MAXS];

int main(void)
{
	int i, j, nr, k;

    freopen("diamant.in", "r", stdin);
    freopen("diamant.out", "w", stdout);

	read();

    S = N * (N + 1) * M * (M + 1) / 4;
    V[S] = 1;

    if (X > S || X < -S)
    {
		printf("0\n");

        return 0;
    }

    for (i = 1; i <= M; i++)
    	for (j = 1; j <= N; j++)
        {
        	memset(tmp, 0, sizeof(tmp));
        	nr = i * j;
			for (k = 0; k <= 2 * S; k++)
            	if (V[k])
	            {
	            	if (k + nr <= 2 * S)
	                	tmp[k + nr] += V[k], tmp[k+ nr] %= Q;
					if (k - nr >= 0)
	                	tmp[k - nr] += V[k], tmp[k - nr] %= Q;
					tmp[k] += V[k], tmp[k] %= Q;
    	        }
            memcpy(V, tmp, sizeof(tmp));
        }

	printf("%d\n", V[S + X]);

    return 0;
}

void read(void)
{
	scanf("%d %d %d", &M, &N, &X);
}
