#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

const int nmax=150000;
const int lgmax=20;

struct entry {
       int first,second,pos;
}v[ nmax ];

inline bool cmp(entry a,entry b) {
       return a.first == b.first ? a.second < b.second : a.first < b.first;
}

int l=0,n,imax;
int pos[ lgmax ][ nmax ];
int start[ 10000 ],order[ nmax ];
int rmq[ lgmax ][ nmax ];
int lung[ 10000 ];


void build_sarray() {
     int i,step,j;
     for (i=1,step=1; (step>>1) <= l; ++i,step<<=1) {
         for (j=0; j < l; ++j) {
             v[ j ].first= pos[ i-1 ][ j ];
             v[ j ].second = j + step >= l ? -1 : pos[ i-1 ][ j+step ];
             v[ j ].pos=j;
         }
         sort(v,v+l,cmp);
         int c=0;
         pos[ i ][ v[0].pos ]=0;
         for (j=1; j < l; ++j) {
             if (!(v[ j ].first == v[ j-1 ].first && v[ j ].second == v[ j-1 ].second) ) c++;
             pos[ i ][ v[j].pos ]=c;
         }
     }
     imax=i-1;
     for (i=0; i < l; ++i)
         order[ pos[imax][i] ]=i;
for (i=0; i+1 < l; ++i) {
         int aa=order[ i ];
         int bb=order[ i+1 ];
         int j;
         for (j=imax; j >=0; --j)
             if (pos[ j ][ aa ]==pos[ j ][ bb ]) {
                aa+=1<<j;
                bb+=1<<j;
                rmq[ 0 ][ i ]+=1<<j;
                if (aa >= l || bb >= l) break;
             }
     }
}

void build_rmq() {
     int i,j,step;
     for (i=1,step=1; (step<<1) < l; ++i,step<<=1) {
         for (j=0; j +(step<<1) < l; ++j)
             rmq[ i ][ j ]=min(rmq[ i-1 ][ j ],rmq[ i-1 ][ j + step ]);
     }
}
     
int log_2[ nmax ];


void build_log() {
     int i,j=0;
     for (i=0; i<nmax; ++i) {
         if ( (1<<(j+1) ) <= i ) j++;
         log_2[ i ]=j;
     }
}

int main() {
     FILE *fin=fopen ("ratina.in","r");
     FILE *fout=fopen ("ratina.out","w");
     int m;
     fscanf (fin,"%d %d\n",&n,&m);
     int i;
     for (i=0; i < n; ++i) {
         char s[ 2002 ];
	fgets(s,2002,fin);
	int ll=strlen(s);
	if (s[ ll-1 ]=='\n') ll--;
	 lung[ i ]=ll;
	int j;
	 start[ i ]=l;
         for (j=0; j< ll; ++j) {
        	if (s[ j ]=='\n') break; 
	    pos[ 0 ][ l++ ]=s[ j ];
	}
         pos[ 0 ][ l++ ]=-i;
     }
     build_sarray();
     build_rmq();
     build_log();
     while (m--) {
           int d,mn,mx,x;
           int bla; //In cazul in care este un singur cuvant in interogare
           mn=2*nmax;
           mx=-nmax;
	char s[ 100 ];
	fgets(s,100,fin);
	int ll=strlen(s);
	int count=0;
	x=0;
	for (i=0; i < ll; ++i)
		if (s[ i ] >='0' && s[ i ] <='9') x=x*10 + s[ i ]-'0';
		else {
			count++;
			if (count==1) {x=0;continue;}
			mn=min(mn,pos[ imax ][ start[x-1] ]);
			mx=max(mx,pos[ imax ][ start[x-1] ]);
			bla=lung[ x-1 ];
			x=0;
		}
	if (x > 0) {
		mn=min(mn,pos[ imax ][ start[x-1] ]);
		mx=max(mx,pos[ imax ][ start[x-1] ]);
		bla=lung[ x-1 ];
	}
	   int lgg=log_2[ mx-mn ];
	if (mn != mx) fprintf (fout,"%d\n",min(rmq[ lgg ][ mn ],rmq[ lgg ][ mx - (1<<lgg) ]) );
           else fprintf (fout,"%d\n",bla);
     }
     fclose(fout);
     return 0;
}
