# include <stdio.h>
# include <string.h>

# define _fin  "matrice.in"
# define _fout "matrice.out"

# define maxn  1002


int a [maxn][maxn], b[maxn][maxn], m, n;
int gr[maxn][maxn];
int l1, c1, l2, c2, amax;


void readf()
{
    int i, j;
    FILE *fin = fopen(_fin, "r");

    for(fscanf(fin, "%d %d", &n, &m), i=1; i<=n; i++)
	for(j=1; j<=m; j++)
	    fscanf(fin, "%d", &a[i][j]);

    fclose(fin);
}

inline int min(int x, int y) { return ( x < y ? x : y ); }

void solve()
{
    int i, j, k;

    for(i=1; i<=n; i++)
    {
	b[i][1] = 1;
	gr[i][1]= a[i][1] < a[i][2] ? 1 : -1;

	for(j=2; j<=m; j++)
	{
	    if ( a[i][j] > a[i][j-1] )
		if ( gr[i][j-1] > 0 )
		{
		    b[i][j]  = b[i][j-1] + 1;
		    gr[i][j] = gr[i][j-1];
		}
		else
		{
		    b[i][j]  = j+gr[i][j-1]+1;
		    gr[i][j] = j-1;
		}
	    else
		if ( gr[i][j-1] < 0 )   // aveam o scadere
		{
		    b[i][j] = b[i][j-1]+1;
		    gr[i][j] = gr[i][j-1];
		}
		else
		{
		    b[i][j] = j-gr[i][j-1]+1;
		    gr[i][j] = 1-j;
		}
	}
    }

    int aaux, lmin, pmin;

    for(i=1; i<=n; i++) 		// linie
	for(j=1; j<=m; j++) 		// (i,j) + (i,k)
	{
	    lmin = aaux = b[i][j];

	    if ( aaux > amax )
		 amax = aaux, l2 = i, c2 = j, l1 = i, c1 = j-lmin+1;

	    for(k=i+1; k<=n; k++)
	    {
	       lmin = min ( lmin, b[k][j] );
	       aaux = lmin * ( k-i+1 );

	       if ( aaux > amax )
		    amax = aaux, l2 = k, c2 = j, l1 = i, c1 = j-lmin+1;
	    }
	}
}

void writef()
{
    FILE *fout = fopen(_fout, "w");
    fprintf(fout, "%d %d %d %d\n", l1, c1, l2, c2), fclose(fout);
}

int main()
{
    readf();
    solve();
    writef();

    return 0;
}