# ifdef __BORLANDC__
	# define NMAX 50
# else
	# define NMAX 1003
	using namespace std;
# endif

# include <fstream.h>
# include <stdio.h>

int a[NMAX][NMAX],ld[NMAX][NMAX],ls[NMAX][NMAX],best[NMAX][NMAX],n,m;

int l1,l2,c1,c2;

struct nod {int val,poz;};
nod deque[NMAX][NMAX];
int start[NMAX],end[NMAX],empty[NMAX];//inceputul si sfarsitul fiecarei  deque


void deqadd(int ind,int val, int poz)
{
	if (empty[ind])
	 {
	  start[ind]=end[ind]=0;deque[ind][0].val=val;
	  deque[ind][0].poz=poz;
	  empty[ind]=0;
	  return;
	 }
	// cat timp avem elem mai mari le dam afara
	while (end[ind] != start[ind]-1
	       && deque[ind][end[ind]].val >= val )
	       end[ind]--;
	if (end[ind] == start[ind]-1)
	 {
	   start[ind]=end[ind]=0;deque[ind][0].val=val;
	  deque[ind][0].poz=poz;
	  empty[ind]=0;
	  return;
	 }
	end[ind]++;
	deque[ind][end[ind]].val=val;deque[ind][end[ind]].poz=poz;
}

int deqpop(int ind, int pozi,int pozj)// ne interseaza deci un element >= decat un poz dat
{
	// >= i si <= j ....
	while (start[ind] != end[ind]+1 &&
	 !(deque[ind][start[ind]].poz >= pozi && deque[ind][start[ind]].poz <= pozj))
	 start[ind]++;
	// no sa fie goala niciodata .....
	return deque[ind][start[ind]].val;
}

void read()
{
	FILE * fin;fin=fopen("matrice.in","r");
	fscanf(fin,"%d %d",&n,&m);
	int i,j;
	for (i=1;i<=n;i++)
	 for (j=1;j<=m;j++)
	  fscanf(fin,"%d",&a[i][j]);
	fclose(fin);
}

void solve()
{
// calculam ls[][] lung celui mai lung subsecv cresc incepand din [i][j]
	int i,j,k;
	int minim,smax=0;

	for (i=1;i<=n;i++)
	 {
	  ls[i][m]=1;
	  for (j=m-1;j>=1;j--)
	   if (a[i][j] < a[i][j+1]) ls[i][j]=1+ls[i][j+1];
	   else ls[i][j]=1;
	 }
// calc ld[][] cel mai lung subsecv descrect din [i][j]
	for (i=1;i<=n;i++)
	 {
	  ld[i][m]=1;
	  for (j=m-1;j>=1;j--)
	   if (a[i][j] > a[i][j+1]) ld[i][j]=1+ld[i][j+1];
	   else ld[i][j]=1;
	 }
/* calculam best[][] ca fiind lung celei mai lungi subsecv valide
     best[i][j]= max {
			ls[i][j],
			ld[i][j]
			ls[i][j]+ld[i][ j+ls[i][j] ]	  // subsir cresc+ s d
			ld[i][j]+ls[i][ j+ld[i][j] ]
		     }
*/
	for (i=1;i<=n;i++)
	 for (j=1;j<=m;j++)
	  {
	   best[i][j]=0;
	   if (ls[i][j] > best[i][j]) best[i][j]=ls[i][j];
	   if (ld[i][j] > best[i][j]) best[i][j]=ld[i][j];
	   if (j+ls[i][j] <= m && ls[i][j]+ld[i][ j+ls[i][j] ] > best[i][j])
	    best[i][j]=ls[i][j]+ld[i][ j+ls[i][j] ];
	   if (j+ld[i][j] <= m && ld[i][j]+ls[i][ j+ld[i][j] ] > best[i][j])
	    best[i][j]=ld[i][j]+ls[i][ j+ld[i][j] ];

	  }
/*
	retinem m dequeuri si  facem
	pt fiecare 2 linii fixate
	 ne plimbam cu o coloana j si verificam minimul de la fiecare pas
	 reactualizam cele m dequeuri
*/

// init deques;
	for (i=1;i<=m;i++)
	 empty[i]=1;


	for (i=1;i<=n;i++)
	 for (j=i;j<=n;j++)
	  {
	   // bagam elem liniei j din best in deque
	   for (k=1;k<=m;k++)
	    deqadd(k,best[j][k],j);

	   for (k=1;k<=m;k++) // fiecare col
	     {
	      // luam minimul
	      minim=deqpop(k,i,j);
	      // verificam aria
	      if ( (j-i+1)*minim > smax)
	       {
		l1=i;l2=j;c1=k;c2=k+minim-1;smax=(j-i+1)*minim;
	       }

	     }

	  }


}

void print()
{
	FILE * fout;fout=fopen("matrice.out","w");
	fprintf(fout,"%d %d %d %d\n",l1,c1,l2,c2);
	fclose(fout);
}

int main()
{
	read();
	solve();
	print();
	return 0;
}
