#include<stdio.h>

#include<string>
using namespace std;

#define MAX(x,y) ((x)>(y)?(x):(y))
#define MIN(x,y) ((x)<(y)?(x):(y))

#define MAXN 10002
#define MAXL 2042
#define MAXTL 230000

int p2[32];

int n, m;
int fix[MAXN];
int sz[MAXN];

string t;
int tl;

int chc[MAXTL];

int ind[20][MAXTL]; // ocupa 19MB
int pos[MAXTL];

int maxpas;

struct sv
{
   int e[2];
   int ix;
} gr[MAXTL], gr2[MAXTL];

void csort(int pas)
{
   memset(chc, 0, sizeof(chc));
   int i;
   for (i=0; i<tl; ++i)
      chc[gr[i].e[pas]]++;
   for (i=1; i<=tl; ++i)
      chc[i] += chc[i-1];

   for (i=tl-1; i>=0; --i)
      gr2[(chc[gr[i].e[pas]]--)-1] = gr[i];
   memcpy(gr, gr2, sizeof(gr));
//   for (i=0; i<tl; ++i) gr[i] = gr2[i];
}

int lcp(int a, int b)
{
   int x=a, y=b, t=0, i;
   for (i=maxpas-1; i>=0; --i)
      if (x+p2[i] < tl && y+p2[i]<tl && ind[i][x] == ind[i][y])
      {
         t += p2[i];
         x += p2[i];
         y += p2[i];
      }
   return t;
}

int main(void)
{
   freopen("ratina.in", "rt", stdin);
   freopen("ratina.out", "wt", stdout);

   int i, j;
   char buf[MAXL];

   scanf("%d%d\n", &n, &m);

   t = '|';
   for (i=0; i<n; ++i)
   {
//      gets(buf);
//      fgets(buf, MAXL, stdin); buf[strlen(buf)-1] = 0;
      scanf("%s\n", buf);
      fix[i+1] = t.length();
      sz[i+1] = strlen(buf);
      t += buf;
      t += '|';
   }

//   t = "ababa";
   tl = t.length();

   for (i=1, p2[0]=1; i<24; ++i) p2[i] = p2[i-1]*2;

   for (i=0; i<tl; ++i)
      chc[t[i]-'a']++;
   for (i=1; i<32; ++i)
      chc[i] += chc[i-1];

   for (i=tl-1; i>=0; --i)
      pos[chc[t[i]-'a']--] = i;

   int q=1;
   ind[0][pos[1]] = 1;
   for (i=2; i<=tl; ++i)
   {
      if (t[pos[i]] != t[pos[i-1]]) ++q;
      ind[0][pos[i]] = q;
   }

   for (i=1; q<tl; ++i)
   {
      for (j=0; j<tl; ++j)
      {
         gr[j].e[0] = ind[i-1][j];
         if (j+p2[i-1]>=tl) gr[j].e[1] = 0;
         else gr[j].e[1] = ind[i-1][j+p2[i-1]];
         gr[j].ix = j;
      }

      csort(1);
      csort(0);
      
      q=1;
      ind[i][gr[0].ix] = 1;
      for (j=1; j<tl; ++j)
      {
         if (gr[j].e[0] != gr[j-1].e[0] || gr[j].e[1] != gr[j-1].e[1]) ++q;
         ind[i][gr[j].ix] = q;
      }
   }

   maxpas = i-1;
   int lmin, lmax;
   int lminp, lmaxp;
   int lmins, lmaxs;
   int x, y;

   for (i=0; i<m; ++i)
   {
      lmin = MAXTL; lmax = -MAXTL;
      scanf("%d", &q);
      for (j=0; j<q; ++j)
      {
         scanf("%d", &x);
         y = fix[x];
         if (ind[maxpas][y] < lmin)
         {
            lmin = ind[maxpas][y];
            lminp = y; lmins = x;
         }
         if (ind[maxpas][y] > lmax)
         {
            lmax = ind[maxpas][y];
            lmaxp = y; lmaxs = x;
         }
      }
      if (lminp == lmaxp)
         printf("%d\n", sz[lmins]);
      else
      {
         y = lcp(lminp, lmaxp);
         if (y>sz[lmins] || y>sz[lmaxs])
            y = MIN(sz[lmins], sz[lmaxs]);
         printf("%d\n", y);
      }
   }
   
   fclose(stdin);
   fclose(stdout);
   return 0;
}

