{$IFDEF NORMAL}
  {$I-,Q-,R-,S-}
{$ENDIF NORMAL}
{$IFDEF DEBUG}
  {$I-,Q-,R-,S-}
{$ENDIF DEBUG}
{$IFDEF RELEASE}
  {$I-,Q-,R-,S-}
{$ENDIF RELEASE}
const
  lim=1000;
  arb=2048;
var
  cresc,desc,ok:array[0..lim,0..lim] of longint;
  add:array[1..arb] of longint;
  q:array[1..lim] of longint;
  kkt2,kkt:array[1..4] of longint;
  rmq:array[1..lim,1..lim,0..10 ]of longint;
  sol2,raspunsquery,nodmax,h,k,i,j,n,m,x,p,sol,u,v:longint;

function max(a,b:longint):longint;
begin
  if a>b
    then max:=a
    else max:=b;
end;

procedure update(nod,lo,hi,st,dr,cat:longint);
var
  mij:longint;
begin
  if nod>nodmax then nodmax:=nod;
  if (st<=lo)and(hi<=dr)
    then inc(add[nod],cat)
    else
    begin
      mij:=(lo+hi) shr 1;
      if st<=mij then update(nod shl 1,lo,mij,st,dr,cat);
      if dr>mij then update((nod shl 1)+1,mij+1,hi,st,dr,cat);
    end;
end;

procedure query(nod,lo,hi,st,dr:longint);
var
  mij:longint;
begin
  inc(raspunsquery,add[nod]);
  if (st<=lo) and (hi<=dr)
    then exit
    else
    begin
      mij:=(lo+hi) shr 1;
      if st<=mij then query(nod shl 1,lo,mij,st,dr);
      if dr>mij then query((nod shl 1)+1,mij+1,hi,st,dr);
    end;

end;

begin
  assign(input,'matrice.in');
  reset(input);
  readln(n,m);
  for i:=1 to n do
    for j:=1 to m do
    begin
      read(ok[i,j]);
      if ok[i,j]>ok[i,j-1]
        then cresc[i,j]:=cresc[i,j-1]+1
        else cresc[i,j]:=1;
      if ok[i,j]<ok[i,j-1]
        then desc[i,j]:=desc[i,j-1]+1
        else desc[i,j]:=1;
    end;
  for i:=1 to n do
    for j:=1 to m do
    begin
    {cazu I}
    p:=j-cresc[i,j]+1;
    p:=p-desc[i,p]+1;
    ok[i,j]:=p;
    {cazu II}
    p:=j-desc[i,j]+1;
    p:=p-cresc[i,p]+1;
    if p<ok[i,j] then ok[i,j]:=p;
    {ok[i,j]:=j+1-max(j-cresc[i,j]+1-desc[i,j-cresc[i,j]+1]+1 , j-desc[i,j]+1-cresc[i,j-desc[i,j]+1]+1);}
    end;

      h:=0;
      while (1 shl (h+1))<=n do inc(h);
    for j:=1 to m do
    begin
      for i:=1 to n do rmq[j,i,0]:=ok[i,j];
      for k:=1 to h do
        for i:=1 to (n-(1 shl k)+1) do
      begin
        rmq[j,i,k]:=max(rmq[j,i,k-1],rmq[j,i+(1 shl (k-1)),k-1]);
      end;
    end;
    sol:=0;
    if (n<=600) and (m<=600) then
    begin
    for i:=n downto 1 do
      for j:=1 to (n-i+1) do
        for k:=1 to m do
        begin
          p:=0;
          while (1 shl (p+1))<=i do inc(p);
          h:=max(rmq[k,j,p],rmq[k,j+(1 shl (p-1)),p]);
          if (k-h+1)*i>sol then
          begin
            sol:=(k-h+1)*i;
            kkt[1]:=j; kkt[2]:=h;
            kkt[3]:=j+i-1; kkt[4]:=k;
          end;
        end;
    end;
    sol2:=0;
    for j:=1 to m do
    begin
      u:=1; v:=0; nodmax:=0;
      for i:=1 to n do
      begin
        raspunsquery:=0;
        query(1,1,m,ok[i,j],ok[i,j]);
        inc(raspunsquery);
        if raspunsquery*(j-ok[i,j]+1)>sol then
        begin
          sol2:=raspunsquery*(j-ok[i,j]+1);
          kkt2[1]:=i-raspunsquery+1; kkt2[2]:=ok[i,j];
          kkt2[3]:=i; kkt2[4]:=j;
        end;
        update(1,1,m,ok[i,j],m,1);
        while (u<=v) and (q[v]<ok[i,j]) do
        begin
          raspunsquery:=0;
          query(1,1,m,q[v],q[v]);
          update(1,1,m,q[v],ok[i,j]-1,-raspunsquery);
          dec(v);
        end;
        inc(v);
        q[v]:=ok[i,j];
      end;
      for i:=1 to nodmax do add[i]:=0;
    end;

  assign(output,'matrice.out');
  rewrite(output);
  if sol>sol2 then writeln(kkt[1],' ',kkt[2],' ',kkt[3],' ',kkt[4])
   else  writeln(kkt2[1],' ',kkt2[2],' ',kkt2[3],' ',kkt2[4]);
  close(output);
end.
