#include <stdio.h>
#include <memory.h>

short int mat[1000][1000];
int n, m;

struct {
	char type;
	short int start;
	short int last;
} rel[1000][1000];

short int len[1000][1000];
int max[1000][1000];

FILE *in, *out;

int main () {
	int i, j, k, l;

	in = fopen ("matrice.in", "r");
	out = fopen ("matrice.out", "w");

	fscanf (in, "%d %d", &n, &m);
	for (i=0;i<n;i++) {
		for (j=0;j<m;j++) {
			fscanf (in, "%d", &k);
			mat[i][j] = k;
		}
	}

	//init rel; use column two; for each line:
	for (i=0;i<n;i++) {
		if (mat[i][1] > mat[i][0]) {
			rel[i][1].type = 0;
		}
		else {
			rel[i][1].type = 1;
		}
		rel[i][1].start = 0;
		rel[i][1].last = -1;
	}
	//now, make rel:
	for (i=0;i<n;i++) {
		for (j=2;j<m;j++) {
			if (mat[i][j] > mat[i][j-1]) {
				rel[i][j].type = 0;
				if (rel[i][j-1].type == 0) {
					rel[i][j].start = rel[i][j-1].start;
					rel[i][j].last = rel[i][j-1].last;
				}
				else {
					rel[i][j].start = j-1;
					rel[i][j].last = rel[i][j-1].start;
				}
			}
			else { //mat[i][j] < mat[i][j-1]
				rel[i][j].type = 1;
				if (rel[i][j-1].type == 1) {
					rel[i][j].start = rel[i][j-1].start;
					rel[i][j].last =rel[i][j-1].last;
				}
				else {
					rel[i][j].start = j-1;
					rel[i][j].last = rel[i][j-1].start;
				}
			}
		}
	}
/*	for (i=0;i<n;i++) {
		printf ("(N,N,N) ");
		for (j=1;j<m;j++) {
			printf ("(%d,%d,%d) ", rel[i][j].type, rel[i][j].start, rel[i][j].last);
		}
		printf ("\n");
	}*/
	//init len:
	for (i=0;i<n;i++) {
		len[i][0] = 1;
		len[i][1] = 2;
	}
	//make len
	for (i=0;i<n;i++) {
		for (j=2;j<m;j++) {
			if (rel[i][j].last == -1) len[i][j] = j+1;
			else len[i][j] = j - rel[i][j].last + 1;
		}
	}
/*	for (i=0;i<n;i++) {
		for (j=0;j<m;j++) {
			printf ("%d ", len[i][j]);
		}
		printf ("\n");
	}*/
	//who needs them numbers anyway??
	memcpy (mat, len, 1000*1000*sizeof (short int));
	for (j=0;j<m;j++) {
		max[0][j] = len[0][j] = mat[0][j];
		max[j][0] = j+1;
		max[j][1] = 2*(j+1);
	}
	for (i=1;i<n;i++) {
		for (j=2;j<m;j++) {
			max[i][j] = len[i][j] = mat[i][j];
			k = (mat[i][j] > len[i-1][j])?len[i-1][j]:mat[i][j];
			if (max[i][j] < (max[i-1][j]/len[i-1][j]+1)*k) {
				max[i][j] = (max[i-1][j]/len[i-1][j]+1)*k;
				len[i][j] = k;
			}
		}
	}
/*	for (i=0;i<n;i++) {
		for (j=0;j<m;j++) {
			printf ("%d ", max[i][j]);
		}
		printf ("\n");
	}*/
	
	k = l = 0;
	for (i=0;i<n;i++) {
		for (j=0;j<m;j++) {
			if (max[i][j] > max[k][l]) {
				k = i;
				l = j;
			}
		}
	}
	j = l - len[k][l] + 1;
	i = k - max[k][l]/len[k][l] + 1;

	fprintf (out, "%d %d %d %d\n", i+1, j+1, k+1, l+1);

	fclose (in);
	fclose (out);
	
	return 0;
}
