#include <stdio.h>
#include <string.h>

struct anod{
       int i;
       anod *st, *dr;
};

struct nod{
       char l;
       nod *fiu;
       nod *next;
       anod *e;
};


char cuvinte[200001];
char *sc[10001];  //10001
char *ramas;

nod sta[30];

int oc[15];
int noc;

int n,m ;

void adauga_e(anod *&c,int nr){
     if(!c) {
       c=new anod; c->i=nr;
       c->st=c->dr=0;
     }else{
       if(nr<c->i) adauga_e(c->st, nr);
       else adauga_e(c->dr, nr);
     }
}

nod *cauta(nod *c, char d){
    while(c){
             if(c->l==d) return c;
             c=c->next;
    }
    return 0;
}

void adauga(int nr, char *d){
     int l=strlen(d);
     nod *c=&sta[d[0]-'a'];
     adauga_e(c->e,nr);

     nod *nc;//=c->fiu;

     int i;
     for(i=1;i<l;i++){
       nc=cauta(c->fiu,d[i]);
       if(!nc){ nc=new nod;
                nc->next=c->fiu;
                c->fiu=nc;
                nc->fiu=0;
                nc->l=d[i];
                nc->e=0;
                adauga_e(nc->e, nr);
       }else
         adauga_e(nc->e, nr);
       c=nc;
     }
}

int verifica(anod *e, int nr){
   if(!e) return 0;
   if(e->i==nr) return 1;
   if(e->i>nr) return verifica(e->st, nr);
   return verifica(e->dr, nr);
}

int verifica_t(anod *e){
  for(int i=1;i<noc;i++)
     if(!verifica(e, oc[i])) return 0;
  return 1;
}

int cauta_v(){
    char *pc=sc[oc[0]];
    int l=strlen(pc);
    nod *c=&sta[pc[0]-'a'];

    if(!verifica_t(c->e)) return 0;

    int nr=1, i;

    for(i=1;i<l;i++){
      c=cauta(c->fiu, pc[i]);
      if(!verifica_t(c->e)) return nr;
      nr++;
    }

    return nr;
}

int main(){

    ramas=cuvinte;

    FILE *f=fopen("ratina.in", "r");
    fscanf(f, "%d %d", &n, &m);
    int i, j;

    for(i=1;i<=n;i++){
      fscanf(f, "%s", ramas);
//      adauga(i,ramas);
      sc[i]=ramas;
      ramas+=strlen(ramas)+1;
    }

    int ts=1, tf=n;
    for(i=1;i<=n;i+=4)
        adauga(i, sc[i]);
    for(i=2;i<=n;i+=4)
        adauga(i, sc[i]);
    for(i=3;i<=n;i+=4)
        adauga(i, sc[i]);
    for(i=4;i<=n;i+=4)
        adauga(i, sc[i]);        


    FILE *fis_o=fopen("ratina.out", "w");

    for(i=1;i<=m;i++){
      fscanf(f, "%d", &noc);
      for(j=0;j<noc;j++)
        fscanf(f, "%d", &oc[j]);
      fprintf(fis_o, "%d\n", cauta_v());
    }
    fclose(fis_o);
    fclose(f);
    return 0;
}