#include<stdio.h>

#define NMAX 410
#define KMAX 310
#define INF 999999999

void read();
void solve();
int dist(int i, int j);

int N, K, A[NMAX], V[NMAX][KMAX], S[NMAX][KMAX], d[NMAX][NMAX], sol[NMAX][KMAX],
	d2[NMAX][NMAX], sol2[NMAX][NMAX];

int main()
{
	freopen("petrom.in", "r", stdin);
     freopen("petrom.out", "w", stdout);

     read();
     solve();
	return 0;
}

void read()
{
	int i;
     
	scanf("%d %d ", &N, &K);

     for(i = 1; i <= N; i++)
     	scanf("%d ", A + i);
}

void solve()
{
	int i, j, k, ok;

     for(i = 1; i <= N; i++)
     for(j = i - 1; j; j--)
     	d[j][i] = d[j + 1][i] + dist(j, i);

     for(i = 1; i <= N; i++)
     for(j = i + 1; j <= N; j++)
     	d2[i][j] = d2[i][j - 1] + dist(i, j);
     for(i = 1; i <= N; i++)
     	S[i][0] = INF;
          
     for(i = 1; i <= N; i++)
     for(j = 1; j <= K && j <= i; j++)
     {
     	S[i][j] = INF;
          V[i][j] = INF;
		for(k = 1; k < i; k++)
          {
	          if(V[k][j] + d2[k][i] < S[i][j])
          	S[i][j] = V[k][j] + d2[k][i], sol[i][j] = k;
               if(S[k - 1][j - 1] + d[k][i] < V[i][j])
          	V[i][j] = S[k - 1][j - 1] + d[k][i], sol2[i][j] = k - 1;
          }

          if(S[i - 1][j - 1] + d[i][i] < V[i][j])
          	V[i][j] = S[i - 1][j - 1] + d[i][i], sol2[i][j] = i - 1;
               
          if(V[i][j] < S[i][j])
		S[i][j] = V[i][j], sol[i][j] = i;
     }
     printf("%d\n", S[N][K]);
     for(j = K, i = N; j; j--)
     {
     	if(V[i][j] == S[i][j])
          {
          	printf("%d\n", i);
			i = sol2[i][j];
          }
          else
          {
	          i = sol[i][j];
               printf("%d\n", i);
               i = sol2[i][j];
          }
     }
}

int dist(int i, int j)
{
	return A[j] - A[i];
}

