#include <stdio.h>

int mat[1000][1000];
int n, m;

int sir_check( int *v, int n )
{
	if( n==1 || n==2 ) return 1;
    int i = 1;

    if( v[1] > v[0] )
    {
    	// crescator ( + descrescator );
        while( v[i] > v[i-1] && i<n ) i++;
        if( i == n ) return 1; 	// doar crescator

        // trebuie sa fie desc
        if( (i+1) == n ) return 1;
        i++;
        while( v[i] < v[i-1] && i<n ) i++;
        if( i == n ) return 1;
    }
    else
    {
    	// descrescator ( + crescator )
        while( v[i] < v[i-1] && i<n ) i++;
        if( i == n ) return 1; // doar descrescator

        // trebuie cresc
        if( (i+1) == n ) return 1;
        i++;
        while( v[i] > v[i-1] && i<n ) i++;
        if( i==n ) return 1;
    }
    return 0;
}

struct max_mat
{
	int l1, c1;
	int l2, c2;
};

int check_mat( int l1, int c1, int l2, int c2 )
{
    for( int i=l1; i<=l2; i++ )
    	if( !sir_check( mat[i]+c1, c2-c1+1 ) ) return 0;
    return 1;
}

max_mat get_max( int l, int c )
{
	if( l==1 && c==1 )
    {
    	max_mat r;
        r.l1 = r.c1 = 1;
        r.l2 = r.c2 = 1;
        return r;
    }
	int maxl, maxc;
    maxl = n-l+1;
    maxc = m-c+1;
    for( int i=0; i<maxl; i++ )
    {
	   	for( int j=0; j<maxc; j++ )
        {
        	if( check_mat( i, j, i+l-1, j+c-1 ) )
            {
            	max_mat r;
                r.l1 = i+1;
                r.c1 = j+1;
                r.l2 = i+l;
                r.c2 = j+c;
                return r;
            }
        }
    }
    max_mat r1, r2, r3;
    
    r1 = get_max( l-1, c );
    int a1 = (r1.l2-r1.l1)*(r1.c2-r1.c1);
    if( a1 == (l-1)*c ) return r1;
    
    r2 = get_max( l, c-1 );
    int a2 = (r2.l2-r2.l1)*(r2.c2-r2.c1);
    if( a2 == l*(c-1) ) return r2;
    
    r3 = get_max( l-1, c-1 );
    int a3 = (r3.l2-r3.l1)*(r3.c2-r3.c1);    

    if( a1 >= a2 && a1 >= a3 ) return r1;
    if( a2 >= a1 && a2 >= a3 ) return r2;
    return r3;
}

int main()
{
	FILE *f = fopen( "matrice.in", "r" );
    if( !f ) return 1;

    fscanf( f, "%d %d", &n, &m );
    for( int i=0; i<n; i++ )
    	for( int j=0; j<m; j++ )
        {
        	fscanf( f, "%d", &mat[i][j] );
        }
    fclose(f);

    max_mat r = get_max( n, m );

    f = fopen( "matrice.out", "w" );
    fprintf( f, "%d %d %d %d", r.l1, r.c1, r.l2, r.c2 );
    fclose(f);

	return 0;
}
