#include <fstream.h>
#define INFILE "petrom.in"
#define OUTFILE "petrom.out"
#define MAXI 405

int n, k, i, j, min, po, c, poy, cost;
int a[MAXI], sel[MAXI], b[MAXI], d[MAXI], s[MAXI][MAXI];

void LoadData();
void Solve();
void Print();
int Mod( int k );

int main()
{
	LoadData();
	Solve();
	return 0;
}

int Mod( int k )
{
	if( k > 0 ) return k;
	else return -k;
}

void LoadData()
{
	ifstream fin(INFILE);
	fin >> n >> k;
	int i;
	for( i = 1; i <= n; i++ ) { fin >> a[i]; }

	fin.close();
}
void Solve()
{       //ninja metod
	ofstream fout(OUTFILE);
	min = 30003;
	if( k == n )
	{
		fout << "0\n";
		for( i = 1; i <= n; i++ )
			fout << i << "\n";
	}
	else
		if( k == n - 1 )
		{
			for( i = 1; i <= n; i++ )
				for( j = i + 1; j <= n; j++ )
					if( Mod (a[j] - a[i]) < min )
					{
						min = Mod( a[j] - a[i] );
						po = j;
					}
			fout << min << "\n";
			for( i = 1; i <= n; i++ )
				if( i != po ) fout << i << "\n";
		}
		else
		{

			for( i = 1; i <= n; i++ )
				for( j = 1; j <= n; j++ )
					if( i != j ) s[i][j] = Mod( a[i] - a[j] );
					else s[i][j] = 32000;
			c = 1;
			while( c <= n - k )
			{
				min = 32000;
				for ( i = 1; i <= n; i++ )
					for( j = 1 + i; j <= n; j++ )
						if( min > s[i][j] )
						{
							min = s[i][j];
							po = i;
							poy = j;
						}
				s[po][poy] = 32001;
				s[poy][po] = 32001;
				sel[poy] = min;
				c++;
			}
			for( i = 1; i <= n; i++ )
				cost += sel[i];
			fout << cost << "\n";
			for( i = 1; i <= n; i++ )
				if( !sel[i] ) fout << i << "\n";

		}


}



