#include <string.h>
#include <stdio.h>

struct CUVANT
{
	char *cuvant;

    CUVANT *urm;
};
CUVANT *cp, *cu;

void AlocCuvant( CUVANT *cuv, long dim, char *s )
{
	cuv->cuvant = new char[dim];
	strcpy( cuv->cuvant, s );
}

int CalcGrad( char *ss, int grad, CUVANT *cuv )
{
	for( int i = 0; i < grad; i++ )
		if( ss[i] != cuv->cuvant[i] )
			return i;

    return grad;
}

int main()
{
	FILE *in, *out;
	in = fopen( "ratina.in", "rt" );
	out = fopen( "ratina.out", "wt" );

	int n;
	long m;

	fscanf( in, "%d", &n );
	fscanf( in, "%ld", &m );

	char *s = new char[2000];


	cp = new CUVANT;
	cu = new CUVANT;

    cp->urm = cu;

    fgetc( in );
	for( int i = 0; i < n; i++ )
	{
		fgets( s, 2000, in );
		s[strlen( s ) - 1] = NULL;

		CUVANT *cuv = new CUVANT;
		AlocCuvant( cuv, strlen( s ), s );


        cuv->urm = cp->urm;
		cp->urm = cuv;
	}

	delete s;

	for( long j = 0; j < m; j++ )
	{
		int t;
		int nr_ord;
		fscanf( in, "%d", &t );
		fscanf( in, "%d", &nr_ord );

        CUVANT *cuv = cp;
		while( n + 1 - nr_ord++ )
		{
        	cuv = cuv->urm;	
		}

		long grad = strlen( cuv->cuvant );
		char *ss = new char[strlen( cuv->cuvant )];
		strcpy( ss, cuv->cuvant );

		for( int k = 1; k < t; k++ )
		{
			fscanf( in, "%d", &nr_ord );

			cuv = cp;
			while( n + 1 - nr_ord++ )
			{
            	cuv = cuv->urm;
			}

			if( grad != 0 )
				grad = CalcGrad( ss, grad, cuv );
		}

        fprintf( out, "%d\n", grad );
    }

	fclose( in );
	fclose( out );

	return 0;
}