#include <stdio.h>

#define MAXN 1001

short m,n,a[MAXN][MAXN],b[MAXN][MAXN],lmax[MAXN][MAXN];
short l1,l2,c1,c2;

void citeste (void)
{
	short i,j;
	FILE *fi = fopen ("matrice.in", "r");
	fscanf (fi, "%d %d", &n, &m);
	for (i=1; i<=n; ++i) {
		a[i][0] = 0;
		for (j=1; j<=m; ++j) {
			fscanf (fi, "%d", &a[i][j]);
			if (a[i][j] > a[i][j-1])
				b[i][j] = 1;
			else
				b[i][j] = -1;
		}
	}
	fclose (fi);
}

void lungimi (void)
{
	short i,j,k;
	short schimbat;
	for (i=1; i<=n; ++i) {
		for (j=1; j<m-2; ++j) {
			schimbat = 0;
			lmax[i][j] = 3;
			for (k=j+2; (k<=m) && (schimbat<2); ++k, ++lmax[i][j])
				if (b[i][k] != b[i][k-1])
					schimbat++;
			if (schimbat==2)
				lmax[i][j] -= 2;
			else
				lmax[i][j]--;
		}
		lmax[i][m-2] = 3;
		lmax[i][m-1] = 2;
		lmax[i][m] = 1;
	}
}

void rezolva (void)
{
	int max = 0,aria;
	short i,j,lmin,k,t;
	lungimi ();
	for (i=1; i<=n; ++i)
		for (j=1; j<=m; ++j)
			for (k=i; k<=n; ++k) {
				lmin = lmax[i][j];
				for (t=i+1; t<=k; ++t)
					if (lmax[t][j] < lmin)
						lmin = lmax[t][j];
				aria = lmin * (k-i+1);
				if (aria > max)
					l1=i, l2=k, c1=j, c2=j+lmin-1, max=aria;
			}
}

void tipareste (void)
{
	FILE *fo = fopen ("matrice.out", "w");
	fprintf (fo, "%d %d %d %d\n", l1, c1, l2, c2);
	fclose (fo);
}

int main (void)
{
	citeste ();
	rezolva ();
	tipareste ();
	return 0;
}

