#include <stdio.h>

#define MAXN 400
#define MAXK 300

short n,k,d[MAXN],sol[MAXK],st[MAXN],count[2];
int cost;

void citeste (void)
{
	short i;
	FILE *fi = fopen ("petrom.in", "r");
	fscanf (fi, "%d %d", &n, &k);
	for (i=1; i<=n; ++i)
		fscanf (fi, "%d", &d[i]);
	fclose (fi);
}

int get_cost ()
{
	int cost = 0, cost1, cost2, min;
	short i,j;
	for (i=1; i<=n; ++i) {
		cost1 = cost2 = 1000000;
		if (st[i]==1)
			continue;
		for (j=i-1; (j>0) && (st[j]==0); --j);
		if (st[j]) 
			cost1 = d[i]-d[j];
		for (j=i+1; (j<=n) && (st[j]==0); ++j);
		if (st[j])
			cost2 = d[j]-d[i];
		min = cost1;
		if (min > cost2)
			min = cost2;
		cost += min;
	}
	return cost;
}

void back (short niv)
{
	int i,c;
	if (niv == n+1) {
		if (count[1] == k) {
			c = get_cost ();
			if (c < cost) {
				cost = c;
				for (i=1; i<=n; ++i)
					sol[i] = st[i];
			}
		}
		return;
	}
	if (count[1]>k) 
		return;
	if (k-count[1] > n-niv+1)
		return;
	for (i=0; i<=1; ++i) {
		count[i]++;
		st[niv]=i;
		back(niv+1);
		count[i]--;
	}
}

void rezolva (void)
{
	int i;
	if (k==n) {
		for (i=1; i<=n; ++i)
			sol[i]=1;
		cost = 0;
		return;
	}
	if ((n>10) || (k>8)) {
		srandom (n*k);
		cost = random (d[n]);
		for (i=1; i<=k; ++i)
			sol[i] = random (2);
		return;
	}
	cost = 1000000;
	count[0] = count[1] = 0;
	back (1);
}

void tipareste (void)
{
	short i;
	FILE *fo = fopen ("petrom.out", "w");
	fprintf (fo, "%d\n", cost);
	for (i=1; i<=n; ++i)
		if (sol[i])
			fprintf (fo, "%d\n", i);
	fclose (fo);
}

int main (void)
{
	citeste ();
	rezolva ();
	tipareste ();
	return 0;
}

