#include <stdio.h>
#include <string.h>

#define MAXN 10001
#define MAXCUVANT 2001
#define MAXM 100001

typedef char cuvant[MAXCUVANT];

int n,m;
short a[MAXN][MAXN], sol[MAXM];
cuvant cuvinte[MAXN];

short get_asem (short i, short j)
{
	short rez = 0;
	if (a[i][j] != -1)
		return a[i][j];
	while (cuvinte[i][rez] == cuvinte[j][rez]) {
		rez++;
		if ((cuvinte[i][rez]=='\n') || (cuvinte[j][rez]=='\n'))
			break;
	}
	a[i][j] = a[j][i] = rez;
	//printf ("Asemanarea dintre cuvintele %d si %d este: %d\n", i, j, rez);
	return rez;
}

short rezolva (short nr, short v[11])	
{
	short rezultat = strlen (cuvinte[v[1]]);
	short i,j,as;
	for (i=1; i<nr; ++i)
		for (j=i+1; j<=nr; ++j) {
			as = get_asem (v[i], v[j]);
			if (as < rezultat)
				rezultat = as;
			if (rezultat == 0)
				return 0;
		}
	return rezultat;
}

void citeste (void)
{
	int i,j;
	short v[11],nr;
	FILE *fi = fopen ("ratina.in", "r");
	fscanf (fi, "%d %d", &n, &m);
	fgetc (fi);
	for (i=1; i<=n; ++i) {
		fgets (cuvinte[i], MAXCUVANT, fi);
		//puts (cuvinte[i]);
		/* apare cu un caracter mai lung (\n) */
		a[i][i] = strlen (cuvinte[i]) - 1;
		for (j=i+1; j<=n; ++j)
			a[i][j] = a[j][i] = -1;
	}
	for (i=1; i<=m; ++i) {
		fscanf (fi, "%d", &nr);
		//printf ("%d ", nr);
		for (j=1; j<=nr; ++j) {
			fscanf (fi, "%d", &v[j]);
			//printf ("%d ", v[j]);
		}
		sol[i] = rezolva (nr, v);
		//printf ("\tSolutia pentru interogarea %d este %d\n", i, sol[i]);
		//printf ("\n");
	}
	fclose (fi);
}

void tipareste (void)
{
	FILE *fo = fopen ("ratina.out", "w");
	int i;
	for (i=1; i<=m; ++i)
		fprintf (fo, "%d\n", sol[i]);
	fclose (fo);
}

int main (void)
{
	citeste ();
	tipareste ();
	return 0;
}

