#include <stdio.h>
#define NMAX 406
#define KMAX 306
#define INF 30000000
#define MAX(x, y) ((x) > (y) ? (x) : (y))
#define MIN(x, y) ((x) < (y) ? (x) : (y))
#define dst(b1, b2) (d[b2] - d[b1])

int n, K;
int d[NMAX], ds[NMAX];
int cmin[NMAX][KMAX];
int lastb[NMAX][KMAX];

int foo(int i) {
  return (i-1)*d[i] - ds[i-1];
}

void solve()
{
  int i, j, k, v1, v2;
  for(i = 1; i <= n; i++)
  {
    cmin[i][0] = INF;
    lastb[i][1] = 0;
  }
  for(i = 1; i <= K; i++)
  {
    cmin[i][i] = 0;
    lastb[i][i] = i;
  }
  for(i = 1; i <= n; i++)
    for(k = 1; k < i && k <= K; k++)
    {
      v1 = cmin[i-1][k] + dst(lastb[i-1][k], i);
      if(k > 1)
      {
        v2 = cmin[i-1][k-1];
        for(j = i-1; dst(lastb[j][k-1], j) > dst(j, i); j--)
          v2 = v2 - dst(lastb[j][k-1], j) + dst(j, i);
      } else {
        v2 = foo(i);
      }
      
      if(v1 < v2)
      {
        cmin[i][k] = v1;
        lastb[i][k] = lastb[i-1][k];
      } else {
        cmin[i][k] = v2;
        lastb[i][k] = i;
      }
//printf("cmin[%d][%d] = MIN (%d, %d) ; lastb = %d\n", i, k, v1, v2, lastb[i][k]);
    }
}

void show(int b, int k)
{
  if(k > 1)
    show(lastb[b - 1][k-1], k-1);
  printf("%d\n", b);
}

int main()
{
  int i;
  freopen("petrom.in", "r", stdin);
  freopen("petrom.out", "w", stdout);
  scanf("%d%d", &n, &K);
  d[0] = -INF;
  for(i = 1; i <= n; i++)
  {
    scanf("%d", &d[i]);
    ds[i] = ds[i-1] + d[i];
  }
  solve();
  printf("%d\n", cmin[n][K]);
  show(lastb[n][K], K);
  return 0;
}
