#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define NMAX 10002
#define MAXLEN 2006

int n, m;
char cuv[NMAX][MAXLEN];
int c[NMAX], cc[NMAX];
int sol;

int solve(int c1, int c2)
{
  int i;
  if(c1 == c2)
    return strlen(cuv[c1]);
  for(i = 0; cuv[c1][i] && cuv[c2][i]; i++)
    if(cuv[c1][i] != cuv[c2][i])
      return i;
  return i;
}

int sortf1(const void *a, const void *b) {
  return strcmp(cuv[*((int *)a)], cuv[*((int *)b)]);
}

int main()
{
  int i, j, qn, q, minq, maxq;
  freopen("ratina.in", "r", stdin);
  freopen("ratina.out", "w", stdout);
  scanf("%d %d\n", &n, &m);
  for(i = 1; i <= n; i++)
  {
    scanf("%s\n", cuv[i]);
    c[i] = i;
  }
  qsort(c+1, n, sizeof(int), sortf1);
  for(i = 1; i <= n; i++)
    cc[c[i]] = i;
  for(i = 1; i <= m; i++)
  {
    scanf("%d", &qn);
    minq = n;
    maxq = 1;
    for(j = 1; j <= qn; j++)
    {
      scanf("%d", &q);
      if(cc[q] < minq) minq = cc[q];
      if(cc[q] > maxq) maxq = cc[q];
    }
    printf("%d\n", solve(c[minq], c[maxq]));
  }
  return 0;
}
