#include <stdio.h>
#include <string.h>

#define NMAX 10001
#define EMAX 28
#define FMAX 32768
#define LMAX 2001
#define minim(a,b) ((a>b)?(b):(a))
#define maxim(a,b) ((a>b)?(a):(b))

FILE *fin,*fout;
int N;
long M;
char *sir[NMAX+1];
int o[NMAX+1],lung[NMAX+1];
int nr[EMAX+1],st[EMAX+1][NMAX+1];
int lcp[NMAX+1],pos[NMAX+1];
long arb[FMAX+1];
char csir[LMAX+1];
int start;
char car;

void RadixSort(int inf,int sup,int p)
{int i,j;
 int stp[EMAX+1],etp[EMAX+1],last;
 for (i=1;i<='z'-'a'+1;++i) nr[i]=stp[i]=etp[i]=0;
 for (i=inf;i<=sup;++i)
     {car=sir[o[i]][p];
      nr[car-'a'+1]++;
      st[car-'a'+1][nr[car-'a'+1]]=o[i];
     }
 for (i=1,last=0;i<='z'-'a'+1;++i)
    {if (i>1) stp[i]=last;
     else stp[i]=last=inf;
     last+=nr[i];
     for (j=1;j<=nr[i];++j)
	if (lung[st[i][j]]==p+1) {o[stp[i]]=st[i][j];++stp[i];st[i][j]=0;}
    }
 for (i=1;i<='z'-'a'+1;++i)
    {start=stp[i];
     for (j=1;j<=nr[i];++j)
       if (st[i][j]>0) {o[stp[i]]=st[i][j];++stp[i];st[i][j]=0;}
     etp[i]=stp[i]-1;
     stp[i]=start;
    }
 for (i=1;i<='z'-'a'+1;++i)
    if (etp[i]>=stp[i]+1) RadixSort(stp[i],etp[i],p+1);
}

int get_lcp(int p1,int p2)
{int i,ep;
 ep=minim(lung[p1],lung[p2]);
 for (i=0;i<ep&&sir[p1][i]==sir[p2][i];++i);
 return i;
}

void build_tree(long nivel,long inf,long sup)
{int med;
 if (inf==sup) arb[nivel]=lcp[inf];
 else {med=(inf+sup)>>1;
       build_tree(2*nivel,inf,med);
       build_tree(2*nivel+1,med+1,sup);
       arb[nivel]=minim(arb[2*nivel],arb[2*nivel+1]);
      }
}
int query(long nivel,long inf,long sup,long cs,long cd)
{long med,x1,x2;
 if (cs<=inf&&cd>=sup) return arb[nivel];
 else {med=(inf+sup)>>1;
       if (cs<=med) x1=query(2*nivel,inf,med,cs,cd);
       else x1=N+1;
       if (cd>med) x2=query(2*nivel+1,med+1,sup,cs,cd);
       else x2=N+1;
       return minim(x1,x2);
      }
}

int main()
{long i;
 int t,j,sp,ep,nc,rez;
 fin=fopen("ratina.in","r");
 fscanf(fin,"%d %ld",&N,&M);
 for (i=1;i<=N;++i)
     {fscanf(fin,"%s",csir);
      lung[i]=strlen(csir);
      sir[i]=new char[lung[i]+1];
      for (j=0;j<lung[i];++j) sir[i][j]=csir[j];
      o[i]=i;
     }
 if (N>1)
 {
 RadixSort(1,N,0);
 for (i=1;i<N;++i)
     lcp[i]=get_lcp(o[i],o[i+1]);
 build_tree(1,1,N-1);
 }
 for (i=1;i<=N;++i) pos[o[i]]=i;
 fout=fopen("ratina.out","w");
 for (i=1;i<=M;++i)
     {fscanf(fin,"%d",&t);
      sp=N+1;ep=0;
      for (j=1;j<=t;++j)
	  {fscanf(fin,"%d",&nc);
	   sp=minim(sp,pos[nc]);
	   ep=maxim(ep,pos[nc]);
	  }
      if (sp==ep) fprintf(fout,"%d\n",lung[o[sp]]);
      else {rez=query(1,1,N-1,sp,ep-1);
	    fprintf(fout,"%d\n",rez);
	   }
     }
 fclose(fin);
 fclose(fout);
 return 0;
}