#include <stdio.h>

typedef struct Tip{
	int pos;
	int val;
}Tip;

Tip S  [1001];
Tip Tmp[1001];

int N, M;
int Q[1001][1001];
int W[1001][1001];

int A[1001];
int T[1001];
int Start[1001];
int Stop[1001];

int SOL;
int SOL1, SOL2, SOL3, SOL4;

void Sortare(int Start, int Stop){
	if (Start!=Stop){
		int Med = (Start+Stop)/2;
		int pos,pos1,pos2;
		Sortare(Start,Med);
		Sortare(Med+1,Stop);
		pos = Start;
		pos1= Start;
		pos2= Med+1;
		for(;pos1<=Med && pos2<=Stop;pos++){
			if (S[pos1].val>S[pos2].val){
				Tmp[pos] = S[pos1++];
			}else{
				Tmp[pos] = S[pos2++];
			}
		}
		for(;pos1<=Med;pos++){
			Tmp[pos] = S[pos1++];
		}
		for(;pos2<=Stop;pos++){
			Tmp[pos] = S[pos2++];
		}
		for(pos=Start;pos<=Stop;pos++){
			S[pos] = Tmp[pos];
		}
	}
}

int main(void){
	int a,b,c;
	int max,maxp;
	int start,stop;
	FILE *e,*ee;
	e=fopen("matrice.in","r");
		fscanf(e, "%d %d", &N, &M);
		for(a=1;a<=N;a++){
			for(b=1;b<=M;b++){
				fscanf(e, "%d", &Q[a][b]);
			}
		}
	fclose(e);
	for(a=1;a<=N;a++){
		if (Q[a][1] > Q[a][2]) W[a][1] = 1;
		if (Q[a][1] < Q[a][2]) W[a][1] =-1;
		for(b=2;b<M;b++){
			if (Q[a][b-1] < Q[a][b] && Q[a][b] > Q[a][b+1]) W[a][b] = 1;
			if (Q[a][b-1] > Q[a][b] && Q[a][b] < Q[a][b+1]) W[a][b] =-1;
		}
		if (Q[a][M-1] < Q[a][M]) W[a][M] = 1;
		if (Q[a][M-1] > Q[a][M]) W[a][M] =-1;
	}
	for(a=1;a<=N;a++){
		for(b=2;W[a][b]!=-W[a][1] && b<M;b++);
		A[a] = b;
	}
	SOL = 0;
	SOL1 = SOL2 = SOL3 = SOL4 = 0;
	for(a=1;a<=M;a++){
		for(c=1;c<=N;c++){
			if (W[c][a]){
				for(b=A[c];W[c][b]!=W[c][a] && b<M;b++);
				A[c] = b;
			}
		}
		for(b=1;b<=N;b++){
			S[b].pos = b;
			S[b].val = A[b];
		}
		Sortare(1,N);
		for(b=1;b<=N;b++){
			T[b] = 1;
			Start[b] = 0;
			Stop[b] = 0;
		}
		c=1;
		max=0;
		maxp=0;
		for(b=M;b>=a;b--){
			for(;S[c].val==b;c++){
				T[S[c].pos] = 0;
				if (Stop[S[c].pos-1]){
					start = Stop[S[c].pos-1];
					Stop[S[c].pos-1] = 0;
				}else{
					start = S[c].pos;
				}
				if (Start[S[c].pos+1]){
					stop = Start[S[c].pos+1];
					Start[S[c].pos+1] = 0;
				}else{
					stop = S[c].pos;
				}
				Start[start] = stop;
				Stop[stop] = start;
				if (max < stop-start+1){
					max = stop-start+1;
					maxp= start;
				}
			}
			if (SOL < max * (b-a+1)){
				SOL = max * (b-a+1);
				SOL1 = maxp;
				SOL2 = a;
				SOL3 = maxp+max-1;
				SOL4 = b;
			}
		}
	}
	ee=fopen("matrice.out","w");
		fprintf(ee, "%d %d %d %d\n", SOL1, SOL2, SOL3, SOL4);
	fclose(ee);
	return 0;
}

