
using namespace std;

#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>

#define MC 10100
#define MV (1<<14)

int N, M;
string ss[MC];

/*
void gen()
{
   freopen("ratina.in", "w", stdout);

   int i, j;

   M = 100000, N = 10000;

   printf("%d %d\n",  N, M);
   for(i = 0; i < N; i++)
   {
     for(j = 0; j < 20; j++)
         printf("%c", (const char)( i % 26 + 'a' ) );
     printf("\n");
   }
   for(i = 0; i < M; i++)
   {
      printf("%d", 10);
      for(j = 1; j <= 10; j++)
         printf(" %d", j); printf("\n");
   }
}
*/

int myin[MC], o[MC], amin[2*MV];

bool cmp( int x, int y ){
     return ss[x] < ss[y];
}

int baga_mare_la_scandal( int n, int n_l, int n_r, int l, int r )
{
    int m = ( n_l + n_r ) >> 1;

    if( l <= n_l && n_r <= r ) return amin[n];

    int val[2]; val[0] = val[1] = 1000111222;

    if( l <= m ) val[0] = baga_mare_la_scandal(2*n,n_l,m,l,r);
    if( r > m ) val[1] = baga_mare_la_scandal(2*n+1,m+1,n_r,l,r);

    return min( val[0], val[1] );
}

int main()
{
//      gen();

      FILE * fin = fopen("ratina.in", "r");
      FILE * fout = fopen("ratina.out", "w");

      char buf[3010];
      int i, j, t, v[12], max_v, min_v, x, y;

      fscanf(fin, "%d %d\n " , &N, &M);

      for(i = 0; i < N; i++)
      {
          fgets(buf, 2010, fin);
          ss[i] = string(buf);
          ss[i].erase( ss[i].begin() + ss[i].length() - 1 );
      }

      for(i = 0; i < N; i++)
          myin[i] = i;

      sort( myin, myin + N , cmp );
/*
      for(i = 0; i < N; i++)
          printf("%s\n", ss[ myin[i] ].c_str() );
*/
      for(i = 0; i < N; i++)
          o[ myin[i] ] = i;
/*
      for(i = 0; i < N; i++)
         printf("o[%d] = %d\n", i, o[i] );
*/

      for(i = MV; i < 2*MV; i++)
         amin[i] = 1000111222;

      for(i = 1; i < N; i++)
      {
          x = myin[i-1], y = myin[i];
          for( j = 0; j < ss[x].size() && j < ss[y].size() &&
                          ss[x][j] == ss[y][j]; j++);
//          printf("lcp(%d,%d) = %d\n", x, y, j);
          amin[MV+i-1] = j;
      }

      for(i = MV - 1; i >= 1; i--)
          amin[i] = min( amin[2*i], amin[2*i+1] );

      for(i = 0; i < M; i++)
      {
          fscanf(fin, "%d", &t);
          for(j = 0; j < t; j++)
             fscanf(fin, "%d", v + j );

         max_v = -1, min_v = N + 1;

         for(j = 0; j < t; j++)
            max_v = max( max_v, o[ v[j]-1 ] ),
            min_v = min( min_v, o[ v[j]-1 ] );

         if( min_v <= max_v - 1 ) fprintf(fout, "%d\n", baga_mare_la_scandal(1,0,MV-1,min_v, max_v-1) );
         else fprintf(fout, "%d\n", ss[ o[ min_v ] ].size() );
//
      }

      fclose( fin );
      fclose( fout );
      
      return 0;
}
