#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <vector>
using namespace std;

#define NMAX 1024
int a[NMAX][NMAX], e[NMAX][NMAX];
int N, M, i, j, k;
int Ans, l1, c1, l2, c2;

pair<int, int> v[NMAX];
int lef[NMAX], rig[NMAX];

void read(void)
{
    freopen("matrice.in", "r", stdin);
    freopen("matrice.out", "w", stdout);
    scanf("%d %d", &N, &M);
    for (i = 0; i < N; i ++)
        for (j = 0; j < M; j ++)
            scanf("%d", &a[i][j]);
}

inline char getsgn(int i, int j)
{
    return a[i][j] > a[i][j - 1] ? '+' : '-';
}

void build(void)
{
    char csgn, sgn, nsgn;
    
    for (i = 0; i < N; i ++)
    {
        e[i][0] = 1, e[i][1] = 2;
        sgn = getsgn(i, 1);
        nsgn = 1, k = 0;
        //un singur semn, sirul porneste de la pozitia 0

        for (j = 2; j < M; j ++)
        {
            csgn = getsgn(i, j);
            if (csgn == sgn)
               e[i][j] = e[i][j - 1] + 1;
            else
            {
                if (nsgn == 1)
                    e[i][j] = e[i][j - 1] + 1, ++ nsgn;
                else
                {
                    while (getsgn(i, k + 1) == getsgn(i, j))
                          ++ k;
                    e[i][j] = j - k + 1;
                }
                sgn = csgn;
            }
        }
        
    }
}

void solve(void)
{
    Ans = 0;

    for (i = 0; i < M; i ++)    //coloana
    {
        for (j = 0; j < N; j ++)
        {
            v[j] = make_pair(e[j][i], j), lef[j] = rig[j] = j;
            if (e[j][i] > Ans)
               Ans = e[j][i], l1 = l2 = j, c2 = i, c1 = c2 - e[j][i] + 1;
        }
        sort(v, v + N);

        for (j = N - 1; j >= 0; j --)
        {
            int p = v[j].second, h = v[j].first, sz;
            // uneste
            if (p < N - 1 && e[p + 1][i] >= h && lef[p + 1] == p + 1)
            {
                rig[lef[p]] = rig[p + 1], lef[rig[p + 1]] = lef[p];
                sz = rig[p + 1] - lef[p] + 1;

                if (sz * h > Ans)
                   Ans = sz * h, l1 = lef[p], l2 = rig[p + 1], c1 = i - h + 1, c2 = i;
            }

            if (p >     0 && e[p - 1][i] >= h && rig[p - 1] == p - 1)
            {
                lef[rig[p]] = lef[p - 1], rig[lef[p - 1]] = rig[p];
                sz = rig[p] - lef[p - 1] + 1;
                
                if (sz * h > Ans)
                   Ans = sz * h, l1 = lef[p - 1], l2 = rig[p], c1 = i - h + 1, c2 = i;
            }
        }
    }

//    printf("%d\n", Ans);
    printf("%d %d %d %d\n", l1 + 1, c1 + 1, l2 + 1, c2 + 1);
}

void gen(void)
{
    freopen("matrice.in", "w", stdout);
    N = 203, M = 205;
    srand(666);
    printf("%d %d\n", N, M);
    for (i = 0; i < N; i ++)
    {
        for (j = 0; j < M;j ++)
            printf("%d ", rand() % 30000);
        printf("\n");
    }
}

int main(void)
{
// gen();
// return 0;
    read();
    build();
    solve();
    return 0;
}
