#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#define MAXN 1201
int N, M;
int A[MAXN][MAXN];
int MX[MAXN][MAXN];
int BC[MAXN], BD[MAXN];
int ARB[2048], ARBI[2048];
const int INF = 2048;

void read(){
 freopen("matrice.in", "r", stdin);
 scanf("%d %d", &N, &M);
 for(int i = 1; i <= N; i++)
  for(int j = 1; j <= M; j++)
   scanf("%d", &A[i][j]);
}
void proc1(){
 int i, l, mx1, mx2;
 for(l = 1; l <= N; l++){
   for(i = 1; i <= M; i++) BC[i] = BD[i] = 0;
   BC[M]=BD[M] = 1;
   for(i = M - 1; i >= 1; i--)
    if(A[l][i] < A[l][i+1])
     BC[i] = 1 + BC[i+1], BD[i] = 1;
    else
     BD[i] = 1 + BD[i+1], BC[i] = 1;
   for(i = 1; i <= M; i++){
    mx1 = BC[i] + BD[i+BC[i]], mx2 = BD[i] + BC[i+BD[i]];
    if(mx1 > mx2)
     MX[l][i] = mx1;
    else
     MX[l][i] = mx2;
   }
 }
}
void init_arb(){
 int i;
 for(i = 1; i < 2048; i++)
  ARB[i] = INF;
}
void arb_in(int nd, int lf, int rt, int i, int val){
 if(i >= lf && i <= rt){
  if(ARB[nd] > val)
   ARB[nd] = val, ARBI[nd] = i;
 }
 if(lf >= rt)
  return;
 int m = (lf + rt) >> 1;
 if(i <= m)
  arb_in((nd<<1), lf, m, i, val);
 else
  arb_in((nd<<1) + 1, m + 1, rt, i, val);
}
int arb_ou(int nd, int lf, int rt, int a, int b, int &oi){
 if(a <= lf && b >= rt)
  {
   oi = ARBI[nd];
   return ARB[nd];
  }
 if(lf >= rt){
  oi = 0;
  return INF;
 }
 int p1, p2;
 int m1 = INF, m2 = INF;
 int m = (lf + rt) >> 1;
 if(a <= m)
  m1 = arb_ou(nd<<1, lf, m, a, b, p1);
 if(b > m)
  m2 = arb_ou((nd<<1)+1, m + 1, rt, a, b, p2);
 if(m1 < m2){
  oi = p1;
  return m1;
 }
 else{
  oi = p2;
  return m2;
 }
}
int COL;
int gmx(int i, int j, int &l1, int &c1, int &l2, int &c2){
 if(i > j){
  l1=l2=c2=c1=0;
  return 0;
  }
 int p;
 int mm = arb_ou(1, 1, N, i, j, p);
 l1 = i, l2 = j;
 c1 = COL;
 c2 = c1 + mm - 1;
 mm *= (j - i + 1);
 int m2l1, m2l2, m2c1, m2c2, m3l1, m3l2, m3c1, m3c2;
 int m2 = gmx(i, p - 1, m2l1, m2c1, m2l2, m2c2), m3 = gmx(p + 1, j, m3l1, m3c1, m3l2, m3c2);

 if(mm < m2)
  mm = m2, l1 = m2l1, l2 = m2l2, c1 = m2c1, c2 = m2c2;
 if(mm < m3)
  mm = m3, l1 = m3l1, l2 = m3l2, c1 = m3c1, c2 = m3c2;
 return mm;
}
int l1, l2, c1, c2;
int proc2(){
 int col, i;
 int MXX = 0, mx;
 int al1,al2,ac2,ac1;
 for(col = 1; col <= M; col++){
  COL = col;
  init_arb();
  for(i = 1; i <= N; i++){
   arb_in(1, 1, N, i, MX[i][col]);
  }
  mx = gmx(1, N, al1, ac1, al2, ac2);
//  printf("AA %d\n", l2);
  if(mx > MXX)
   MXX = mx, l1 = al1, l2 = al2, c2 = ac2, c1 = ac1;
 }
 return MXX;
}
int bl1, bl2, bc1, bc2;
int bf(){
 int i1, j1, i2, j2, i, j;
 int MXX = 0;
 for(i1 = 1; i1 <= N; i1++)
  for(j1 = 1; j1 <= M; j1++)
   for(i2 = i1; i2 <= N; i2++)
    for(j2 = j1; j2 <= M; j2++){
     bool ok = 1;
     for(i = i1; i <= i2; i++){
      if(A[i][j1] < A[i][j1 + 1]){
       j = j1 + 1;
       while(j <= j2 && A[i][j] > A[i][j-1]) j++;
       while(j <= j2 && A[i][j] < A[i][j-1]) j++;
       if(j <= j2) ok = 0;
      }
      if(A[i][j1] > A[i][j1 + 1]){
       j = j1 + 1;
       while(j <= j2 && A[i][j] < A[i][j-1]) j++;
       while(j <= j2 && A[i][j] > A[i][j-1]) j++;
       if(j <= j2) ok = 0;
      }
      if(!ok){
      // printf("HERE");
       break;
       }
     }
//     printf("here : %d %d\n", i, i2);
     if(i > i2){
  //   printf("HERE");
      if(MXX < (i2 - i1 + 1) * (j2 - j1 + 1))
       MXX = (i2 - i1 + 1) * (j2 - j1 + 1), bl1=i1, bl2=i2, bc1=j1, bc2=j2;
     }
     }
   return MXX;
}
void gen(){
 int N = 1000, M = 1000;
 srand(2*time(0));
 FILE *fo = fopen("matrice.in", "w");
 fprintf(fo, "%d %d\n", N, M);
 int TT[100][100];
 for(int i = 1; i <= N; i++){
  for(int j =1; j <= M; j++){
   while((TT[i][j] = rand()%41) == TT[i][j-1]);
   fprintf(fo, "%d ", TT[i][j]);
   }
   fprintf(fo, "\n");
  }
  exit(0);
}
int main(){
 read();
 proc1();
 FILE *fo = fopen("matrice.out", "w");
 proc2();
 fprintf(fo, "%d %d %d %d", l1, c1, l2, c2);
 fclose(fo);
 return 0;
}
