#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define MAXN 10200
#define MAXL 2002

char S[MAXN][MAXL];
int L[MAXN];
int SI[MAXN], SIX[MAXN];
int PL[MAXN];
int ARB[256000];
const int INF = 5000;
int N, M;
int cmp(const void *a, const void *b){
 int i1 = *(int*)a, i2 = *(int*)b;
 int j = 0;
 while(j < L[i1] && j < L[i2] && S[i1][j] == S[i2][j]) j++;
 if(j < L[i1] && j >= L[i2])
  return 1;
 if(j >= L[i1] && j < L[i2])
  return -1;
  if(j >= L[i1] && j >= L[i2])
   return 0;
 if(S[i1][j] < S[i2][j]) return -1;
 else return 1;
}

void read(){
 int i;
 freopen("ratina.in", "r", stdin);
 scanf("%d %d", &N, &M);
 for(i = 1; i <= N; i++){
  SI[i] = i;
  scanf("%s", S[i]);
  L[i] = strlen(S[i]);
 }
 qsort(SI + 1, N, sizeof(SI[1]), cmp);
 for(i = 1; i <= N; i++)
  SIX[SI[i]] = i;

}
void proc1(){
 for(int i = 1; i < N; i++){
  int j = 0;
  while(j < L[SI[i]] && j < L[SI[i+1]] && S[SI[i]][j] == S[SI[i+1]][j]) j++;
  PL[i] = j;
 }
}
void init_arb(){
 for(int i = 0; i < 256000; i++)
  ARB[i] = INF;
}
void arb_in(int nd, int lf, int rt, int i, int val){
 if(i >= lf && i <= rt){
  if(ARB[nd] > val)
   ARB[nd] = val;
 }
 if(lf >= rt)
  return;
 int m = (lf + rt) >> 1;
 if(i <= m)
  arb_in(nd << 1, lf, m, i, val);
 else
  arb_in((nd<<1)+1, m + 1, rt, i, val);
}
int arb_ou(int nd, int lf, int rt, int a, int b){
 if(a <= lf && b >= rt)
  return ARB[nd];

 if(lf >= rt)
  return INF;

 int m = (lf+rt) >> 1;
 int m1 = INF, m2 = INF;
 if(a <= m)
  m1 = arb_ou(nd << 1, lf, m, a, b);
 if(b > m)
  m2 = arb_ou((nd<<1) + 1, m + 1, rt, a, b);
 if(m1 < m2)
  return m1;
 else return m2;
}
int X[21], T;
int x[21];
void bf(){
 int t, j, k1, k2;
 FILE * fo = fopen("a.1", "w");
 for(int i = 1; i <= M; i++){
  scanf("%d", &t);
  for(j=1;j<=t;j++) scanf("%d", &x[j]);
  int MM = INF;
  if(t == 1) MM = L[x[1]];
  for(k1 = 1; k1 <= t; k1++)
   for(k2 = k1+1; k2 <= t; k2++)
    {
     int mm = 0;
     if(x[k1] == x[k2])
      mm = L[x[k1]];
      else
     while(mm < L[x[k1]] && mm < L[x[k2]] && S[x[k1]][mm] == S[x[k2]][mm])mm++;
//     printf("%d\n", mm);
     if(mm < MM) MM = mm;
    }
    fprintf(fo, "%d\n", MM);
 }
 fclose(fo);
}

void gen(){
 FILE *fo = fopen("ratina.in", "w");
 int N =10000, M = 100000;
 srand(time(0));
 int L;
 fprintf(fo, "%d %d\n", N, M);
 for(int i = 0; i < N; i++){
   L = rand() % 2000 + 1;
   for(int j = 0; j < L; j++)
    fprintf(fo, "%c", 'a');
    fprintf(fo, "\n");
 }
 for(int i = 0; i < M; i++){
  L = rand() % 10 + 1;
  fprintf(fo, "%d ", L);
  for(int j = 0; j < L; j++)
   fprintf(fo, "%d ", rand() % N + 1);
  fprintf(fo, "\n");
 }
 fclose(fo);
 exit(0);
}

int main(){
 read();
 proc1();
 init_arb();
 int i, j, k;
 for(i = 1; i <= N; i++)
  arb_in(1, 1, N, i, PL[i]);
 FILE *fo = fopen("ratina.out", "w");
 for(i = 1; i <= M; i++){
  scanf("%d", &T);
  for(j = 1; j <= T; j++) scanf("%d", &X[j]), X[j] = SIX[X[j]];
  int mm = INF;
  int m2;
  if(T == 1)
   mm = L[SI[X[1]]];
  for(j = 1; j <= T; j++)
   for(k = j + 1; k <= T; k++){
    int a1, a2;
    if(X[j] > X[k]) a1 = X[k], a2 = X[j];
    else a1 = X[j], a2 = X[k];
    if(a1 == a2) m2 = L[SI[a1]];
    else
      m2 = arb_ou(1, 1, N, a1, a2 - 1);
    if(m2 < mm)
     mm = m2;
   }
   fprintf(fo, "%d\n", mm);
 }
 fclose(fo);
 return 0;
}
