/*
	petrom

	dinamikus programozas (mi mas lehetne ??!)

	O(n^4)
*/
#include <stdio.h>

#define MAXN 200

int n,k,
	tav[MAXN],
	ar[MAXN][MAXN][MAXN];	// ezen meg javitani kell !
	
void beolv(void){
	FILE *fi;
	int i;
	fi = fopen("petrom.in", "r");
	fscanf(fi, "%i %i", &n, &k);
	for( i=1; i<=n; i++)
		fscanf(fi, "%i ", &tav[i]);
    fclose(fi);
}

void rendez(void){
	// N.I.
	int d,i,j;
	d = (n+1)/2;
	while( d>0){
		for(i=1; i+d<=n; i++)
			if( tav[i]>tav[i+d]){
				j = tav[i]; tav[i] = tav[i+d]; tav[i+d] = j;
            }
        if( d>1)
			d = (d+1)/2;
        else
			d = 0;
	}
}

void szamol(void){
	int nn,kk,bb,jj;
	for( nn=1; nn<=n; nn++){
		for( kk=1; kk<=k; kk++){
			// az  utolsot az utolso kuthoz kotjuk
			for( bb=kk; bb<=nn; bb++)
 				ar[nn][kk][bb] = ar[nn-1][kk][bb] + tav[nn]-tav[bb];
            // uj benzinkut, bb==nn
			if( kk==1)	// egyeduli kut
				for( jj=1; jj<nn;jj++)
					ar[nn][1][nn] += tav[nn] - tav[jj];
            else	// meg volt elozo
//				for( jj=kk-1; jj<nn; jj++)
				if( ar[nn-1][kk-1][nn-2]+tav[nn]-tav[nn-1]<ar[nn-1][kk-1][nn-1])
					ar[nn][kk][nn] = ar[nn-1][kk-1][nn-2]+tav[nn]+tav[nn-1];
                else
					ar[nn][kk][nn] = ar[nn-1][kk-1][nn-1];
        } // for kk
		/*
	    printf("ar[%i] = \n", nn);
		for( bb = 1; bb<=nn; bb++){
			for( kk=1; kk<=k; kk++)
				printf("%3i", ar[nn][kk][bb]);
        	printf("\n");
	    }
		*/
    } // for nn
}


int main(void){
	FILE *fo;
//	printf("\n--Start--\n");
	beolv();
	rendez();
	szamol();
	int i,min;
	min = ar[n][k][n];
	for(i=k; i<n; i++)
		if( ar[n][k][i]<min)
			min = ar[n][k][i];
	fo =fopen("petrom.out", "w");
	fprintf(fo, "%i\n\n", min);
	fclose(fo);
	return 0;
}

