#include <stdio.h>

#define MAX_N 405
#define MAX_K 305
#define INF 1000000666
#define FIN "petrom.in"
#define FOUT "petrom.out"
#define FOR(i, a, b) for (i = (a); i < (b); i++)

int N, K, S[MAX_N], D[MAX_N], C[MAX_N][MAX_N], bst[MAX_K][MAX_N], up[MAX_K][MAX_N];

void trace(int k, int n)
{
    if (!k) return;
    trace(k-1, up[k][n]);
    printf("%d\n", (up[k][n]+n+1)>>1);
}

int main(void)
{
    int i, j, k, t, m;
    
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d %d", &N, &K);
    FOR (i, 1, N+1)
    {
        scanf("%d", D+i);
        S[i] = S[i-1]+D[i];
    }

    FOR (i, 1, N+1) FOR (j, i, N+1)
    {
        m = (i+j)>>1;
        C[i][j] = (m-i+1)*D[m]-(S[m]-S[i-1]) + (S[j]-S[m])-(j-m)*D[m];
    }

    FOR (k, 0, K+1) FOR (i, 0, N+1) bst[k][i] = INF;
    bst[0][0] = 0;

    FOR (k, 1, K+1) FOR (i, 1, N+1) FOR (j, up[k][i-1], i)
    {
        t = bst[k-1][j] + C[j+1][i];
        if (bst[k][i] > t) bst[k][i] = t, up[k][i] = j;
    }

    printf("%d\n", bst[K][N]);
    trace(K, N);
    
    return 0;
}
