#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define FIN "ratina.in"
#define FOUT "ratina.out"

#define MOD 666073
#define MAX_L 2200
#define MAX_N 10001

char str[MAX_L];
int *H[MAX_N], p[MAX_N], N, M;

int try(int L, int l, int r)
{
    int i;

    for (i = 1; i <= H[l][0] && i <= H[r][0] && i <= L; i++)
        if (H[l][i] != H[r][i]) return i - 1;
    return i - 1;
}

int Ok(int L)
{
    int i, sb;

    if (H[p[0]][0] < L) return 0;
    sb = H[p[0]][L];
    for (i = 1; i < M; i++)
        if (H[p[i]][0] < L || H[p[i]][L] != sb) return 0;

    return 1;
}

int main(void)
{
    int i, l, s, max, tests, qstep, step, j;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d %d\n", &N, &tests);
    for (i = max = 0; i < N; i++)
    {
        scanf("%s\n", str);
        l = strlen(str) + 1;
        H[i] = malloc(sizeof(int) * l);
        H[i][0] = l - 1, max = max > l ? max : l;
        for (j = 1, s = 0; j < l; j++)
            H[i][j] = (s = s * 26 + str[j - 1] - 'a') % MOD;
    }
    for (qstep = 1; qstep < max; qstep <<= 1) ;
    if (M < 10000)
    {
        while (tests--)
        {
            scanf("%d", &M);
            for (i = 0; i < M; i++)
                scanf("%d", &p[i]), p[i]--;

            for (i = 1, l = H[p[0]][0]; i < M; i++)
                l = try(l, p[0], p[i]);
            printf("%d\n", l);
        }
    }
    else
    {
        while (tests--)
        {
            scanf("%d", &M);
            for (i = 0; i < M; i++)
                scanf("%d", &p[i]), p[i]--;

            for (i = 1, l = 0, step = qstep; step; step >>= 1)
                if (Ok(l + step)) l += step;
            printf("%d\n", l);
        }
    }

    return 0;
}
