#include <stdio.h>

#define MAXN 512
#define INF 999999999
#define MAX(a, b) ((a) > (b) ? (a) : (b))

void read(void);
void afis(int i, int j);

int N, K, D[MAXN], V[MAXN][MAXN], R[MAXN][MAXN], Pl[MAXN][MAXN], D1[MAXN][MAXN],
	D2[MAXN][MAXN], PI;

int main(void)
{
	int i, j, k, sum, l, p, lim;

	freopen("petrom.in", "r", stdin);
    freopen("petrom.out", "w", stdout);

    read();

    if (K <= 50)
	    PI = 150;
    else
    	if (K <= 100)
        	PI = 100;
		else
		  	if (K <= 200)
		      	PI = 70;
			else
	           	PI = 40;

    for (l = 2; l <= N; l++)
    	for (i = 1; i + l - 1 <= N; i++)
        {
        	j = i + l - 1;
            D1[i][j] = D1[i + 1][j] + D[j] - D[i];
            D2[i][j] = D2[i][j - 1] + D[j] - D[i];
        }

	for (i = 1; i <= N; i++)
    	V[i][0] = INF;

    for (i = 1; i <= N; i++)
    	for (j = 1; j <= i && j <= K; j++)
        	if (i == j)
            	V[i][j] = 0, R[i][j] = i, Pl[i][j] = i;
			else
            {
            	V[i][j] = INF;
            	sum = 0, p = i;
				lim = Pl[i - 1][j] - PI;
                if (lim < 1 || j == 1) lim = 1;
            	for (k = i; 1;)
                {
	              	if (V[i][j] > V[k - 1][j - 1] + sum)
	                  	V[i][j] = V[k - 1][j - 1] + sum, R[i][j] = k, Pl[i][j] = p;
					if (k > lim && k >= j - 1)
                    {
                    	k--;
                        sum += D[p] - D[k];
                        while (p > k && D1[k][p - 1] + D2[p - 1][i] <= sum)
                        {
                        	p--;
                            sum = D1[k][p] + D2[p][i];
						}
                    }
                    else
                    	break;
                }
			}

	printf("%d\n", V[N][K]);
    afis(N, K);

    return 0;
}

void read(void)
{
	int i;

	scanf("%d %d", &N, &K);

    for (i = 1; i <= N; i++)
    	scanf("%d", D + i);
}

void afis(int i, int j)
{
    if (j > 1)
	    afis(R[i][j] - 1, j - 1);
	printf("%d\n", Pl[i][j]);        
}
