#include <stdio.h>
#include <stdlib.h>
#include <string.h>

FILE *f = fopen("ratina.in", "r");
FILE *g = fopen("ratina.out", "w");

long const nmax = 310; //310
long const lmax = 2010;  //2010

long n, m;
long s[nmax], inv[nmax], l[nmax][nmax];
long lun[nmax];
char cuv[nmax][lmax];
long x[12];

void citeste();
int fcmp(const void *a, const void *b);
void solve();
int asem(long i, long j);
long minim(long a, long b);
int asemtot();

int main() {
	citeste();
	solve();
	fclose(f);
	fclose(g);
	return 0;
}

void citeste() {
	long i;

	fscanf(f, "%d%d", &n, &m);
	fgets(cuv[1], lmax, f);
	for(i=1; i<=n; i++) {
		fgets(cuv[i], lmax, f);
		lun[i] = strlen(cuv[i]) - 1;
		cuv[i][lun[i]] = NULL;
		l[i][i] = lun[i];
		s[i] = i;
	}
}

int fcmp(const void *a, const void *b) {
	long ia = *( (long*) a);
	long ib = *( (long*) b);

	return strcmp(cuv[ia], cuv[ib]);

}

void solve() {
	long i, j, t;

	qsort(s+1, n, sizeof(s[1]), fcmp);
	for(i=1; i<=n; i++) inv[s[i]] = i;

/*	for(i=1; i<=n; i++) {
		for(j=0; j<lun[s[i]]; j++) fprintf(g, "%c", cuv[s[i]][j]);
		fprintf(g, "\n");
	}*/
	for(i=2; i<=n; i++) {
		t = asem(s[i], s[i-1]);
		for(j=1; j<i; j++) {
			l[s[i]][s[j]] = minim(t, l[s[i-1]][s[j]]);
			l[s[j]][s[i]] = l[s[i]][s[j]];
		}
	}

	for(i=1; i<=m; i++) {
		fscanf(f, "%d", &(x[0]));
		for(j=1; j<=x[0]; j++) fscanf(f, "%d", &(x[j]));
		t = asemtot();
		fprintf(g, "%d\n", t);
	}
}


int asem(long i, long j) {
	long k, lungime;

	lungime = minim(lun[i], lun[j]);
	for(k=0; k<lungime; k++) if( cuv[i][k] != cuv[j][k]) return k;
	return lungime;
}


long minim(long a, long b) {
	if(a<b) return a;
	return b;
}

int asemtot() {
	long i, rezmin, tri;

	rezmin = lun[x[1]];
	for(i=1; i<x[0]; i++) {
		tri = minim(rezmin, l[x[i]][x[i+1]]);
		rezmin = tri;
	}
	return rezmin;
}

