{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program MARBLES;

const filein='MARBLES.IN';
      fileout='MARBLES.OUT';
      MAXN=100;

type fluxarray=array[0..2*MAXN+1] of integer;
     coadaarray=array[1..MAXN*MAXN+1] of integer;

var fin,fout:text;
    flux,cap,cost:array[0..2*MAXN+1] of ^fluxarray;
    marb,marc,asoc:array[1..MAXN] of byte;
    i,j,k,m,n,p,q,start,last,po,nel:integer;
    fmax,costt:integer;
    incoada:array[0..2*MAXN+1] of boolean;
    tata,cmin,tip:array[0..2*MAXN+1] of integer;
    coada:coadaarray;

function min(a,b:integer):integer;
begin
if (a<b) then min:=a
else min:=b;
end;

procedure citestedate;
begin
assign(fin,filein);
reset(fin);

readln(fin,n);

for i:=1 to n do
  read(fin,marb[i]);

close(fin);

end;

procedure prelucreazadate;
begin

p:=0; q:=0;

for i:=1 to n do
  if (marb[i]>1) then
    inc(p)
  else
  if (marb[i]=0) then
    inc(q);

start:=0; last:=p+q+1;

for i:=start to last do
  begin
    new(flux[i]);
    fillchar(flux[i]^,sizeof(flux[i]^),0);
    new(cap[i]);
    fillchar(cap[i]^,sizeof(cap[i]^),0);
    new(cost[i]);
    fillchar(cost[i]^,sizeof(cost[i]^),0);
  end;

fillchar(marc,sizeof(marc),0);

q:=p; p:=0;
for i:=1 to n do
  if (marb[i]>1) then
    begin
      inc(p);
      marc[i]:=p;
      asoc[p]:=i;
    end
  else
  if (marb[i]=0) then
    begin
      inc(q);
      marc[i]:=q;
      asoc[q]:=i;
    end;

for i:=1 to n do
  if (marc[i]>0) then
    begin
      if (marc[i]<=p) then
        begin
          cap[0]^[marc[i]]:=marb[i]-1;
        end
      else
        begin
          cap[marc[i]]^[last]:=1;
        end;
    end;

for i:=1 to n do
  if (marc[i]>0) and (marc[i]<=p) then
    for j:=1 to n do
      if (marc[j]>p) then
        begin
          cap[marc[i]]^[marc[j]]:=1;
          cost[marc[i]]^[marc[j]]:=min(abs(j-i),n-abs(j-i));
          cost[marc[j]]^[marc[i]]:=-cost[marc[i]]^[marc[j]];
        end;

end;

procedure MINFLUX;
begin

fmax:=0;
costt:=0;

repeat

fillchar(tata,sizeof(tata),0);
fillchar(incoada,sizeof(incoada),false);

fillchar(cmin,sizeof(cmin),126);
cmin[0]:=0;

po:=1; nel:=1;
coada[1]:=0;
incoada[0]:=true;

while (po<=nel) do
  begin
    i:=coada[po];

    if (i=0) then
      begin
        for k:=1 to p do
          if (flux[0]^[k]<cap[0]^[k]) then
            begin
              tip[k]:=1;
              tata[k]:=0;
              incoada[k]:=true;

              inc(nel);
              coada[nel]:=k;

              cmin[k]:=0;
            end;
      end
    else
    if (i<=p) then
      begin
        for k:=p+1 to q do
          if (cmin[i]+cost[i]^[k]<cmin[k]) and
             (flux[i]^[k]=0)
          then
            begin
              cmin[k]:=cmin[i]+cost[i]^[k];
              tata[k]:=i;
              tip[k]:=1;

              if (not incoada[k]) then
                begin
                  inc(nel);
                  coada[nel]:=k;
                  incoada[k]:=true;
                end;

            end;
      end
    else
      begin
        for k:=1 to p do
          if (cmin[i]+cost[i]^[k]<cmin[k]) and
             (flux[k]^[i]=1)
          then
            begin
              cmin[k]:=cmin[i]+cost[i]^[k];
              tata[k]:=i;
              tip[k]:=2;

              if (not incoada[k]) then
                begin
                  inc(nel);
                  coada[nel]:=k;
                  incoada[k]:=true;
                end;
            end;

        if (cmin[last]>cmin[i]+cost[i]^[last]) and
           (flux[i]^[last]<cap[i]^[last])
        then
          begin
            cmin[last]:=cmin[i]+cost[i]^[last];
            tata[last]:=i;
            tip[last]:=1;
          end;

      end;

    incoada[i]:=true;
    inc(po);

  end;


if (cmin[last]<32382) then
  begin
    fmax:=fmax+1;
    costt:=costt+cmin[last];

    k:=last;

    while (k>0) do
      begin
        case tip[k] of
        1:inc(flux[tata[k]]^[k]);
        2:dec(flux[k]^[tata[k]]);
        end;

      k:=tata[k];
      end;

  end;


until (cmin[last]=32382);

end;

function dist(ii,jj:integer):integer;
begin
if (ii<=jj) then
  dist:=jj-ii
else
  dist:=n-dist(jj,ii);
end;


procedure afisazamutari;
begin
for i:=1 to p do
  for j:=p+1 to q do
    if (flux[i]^[j]=1) then
      begin
        k:=asoc[i];
        m:=asoc[j];

        if (dist(k,m)<dist(m,k)) then
          begin

            while (k<>m) do
              begin
                po:=k+1;
                if (po>n) then po:=1;

                writeln(fout,k,' ',po);
                k:=po;
              end;
          end
        else
          begin

            while (k<>m) do
              begin
                po:=k-1;
                if (po<1) then po:=n;

                writeln(fout,k,' ',po);
                k:=po;
              end;
          end;
      end;
end;

procedure afisazadate;
begin
assign(fout,fileout);
rewrite(fout);
writeln(fout,costt);

afisazamutari;

close(fout);
end;


begin

citestedate;
prelucreazadate;
minflux;
afisazadate;

end.