#include <fstream.h>

#define IN  "1.in"
#define OUT "1.out"


long int x[3];       // elementele X (numerele) asociate  fetitelor
long int r[50];      // elementele X (numerele) asociate raufacatorilor
int n;               // numarul de raufacatori
int fp[10], fr[10];  // frecventele cifrelor in elmentele X
                     // corespunzatoare fetitelor  si raufacatorilor
                     // fp[i] = j  => cifra i se repeta de j ori in numarul X
                     // al fetitei Powerpuff

ifstream fin(IN);
ofstream fout(OUT);
int i, j, k;

int main()
{
	fin >> x[0] >> x[1] >> x[2] >> n;
	for ( i = 0; i < n; i++ )
 		fin >> r[i];

    for ( i = 0; i < 3; i++ )       // fiecare fetita
    {
        for ( j = 0; j < n; j++ )   // lupta cu toti raufacatorii
        {
        	for ( k = 0; k < 10; k++ )
           		fp[k] = 0;

        	long int X = x[i];
        	while ( X )             // frecventele cifrelor pentru fetita i
        	{                       // se modifica dupa fiecare lupta
        		fp[X%10]++;
        		X /= 10;
       		}

            for ( k = 0; k < 10; k++ )
                fr[k] = 0;

           	long int nr = r[j];
		    while ( nr )            // frecventele cifrelor pentru raufacatorul j
		    {                       // raman aceleasi dupa fiecare lupta
                fr[nr % 10]++;
                nr /= 10;
            }

            int plus = 0, minus = 0;
            for ( int c = 0; c < 10; c++ )
                if ( fp[c] != 0 && fr[c] == 0 )     // fetita are cifra c si raufacatorul nu o are
                    plus += fp[c] * c;
                else
                    if ( fp[c] == 0 && fr[c] != 0 ) // fetita nu are cifra c iar raufacatorul o are
                        minus += fr[c] * c;

            x[i] += plus;           // adunam suma cifrelor fetitei pe care nu le are raufacatorul
            x[i] -= minus;          // scadem suma cifrelor raufacatorului pe care nu le are fetita
        }
        fout << x[i] << '\n';
    }

	fin.close();
	fout.close();
	return 0;
}


