# include <stdio.h>

# define Fin  "joc.in"
# define Fout "joc.out"

# define Max 1001

FILE *in=fopen(Fin, "rt");
FILE *out=fopen(Fout, "w");

int Valc[Max];
int Vtemp[Max];
int maxs;


// joc returneaza numarul de runde
int Joc(int Jdim)
{
   int max, min, runda, i;

   runda = 0;
   max = min = Valc[0];
   for(i=1; i<Jdim ; i++)
   {
       if(Valc[i] > max) max = Valc[i];
       else if(Valc[i] < min) min = Valc[i];
   }
   while(min < max)
   {
       runda++;
       i = min;
       min = max;
       max = i;
       // trecere spre dreapta a jumatate din cantitate
       Vtemp[0] = Valc[Jdim - 1]/2 + Valc[0]/2;
       for(i=1; i<Jdim; i++)
	  Vtemp[i] = Valc[i - 1]/2 + Valc[i]/2;
       // se aduga 1 nr impare
       for(i=0; i<Jdim ; i++)
       {
	  if((Vtemp[i] & 1) != 0) Valc[i] = Vtemp[i] + 1;
	  else Valc[i] = Vtemp[i];
	  if(Valc[i] > max) max = Valc[i];
	  if(Valc[i] < min) min = Valc[i];
       }
   }
   return runda;
}

int main()
{
   int contc, contjoc, i, valC, RundaJoc;

   maxs = 256;
   // primul joc

   fscanf(in,"%d",&contc);
   contjoc = 0;
   while(contc > 0)
   {
       // citire
       for(i=0; i<contc ; i++)
	   fscanf(in, "%d", &Valc[i]);

       // joc
       RundaJoc = Joc(contc);
       fprintf(out, "%d %d\n", RundaJoc, Valc[0]);
       contjoc++;
       fscanf(in, "%d", &contc);
   }
   fprintf(out, "%d\n",contjoc);
   return 0;
}