#include <cstdio>
using namespace std;

const int mod=10000;

int sum[ 21 ][ 421 ];

void precalc() {
	sum[ 1 ][ -1+210 ]=1;
	sum[ 1 ][ 1 + 210 ]=1;
	sum[ 1 ][ 0+210 ]=1;
	int i,j;
	for (i=1; i < 20; ++i)
		for (j=-( i*(i+1)/2 ); j <= i*(i+1)/2; ++j)
			if (sum[ i ][ j+210 ]) {
				sum[ i+1 ][ j+210 ]+=sum[ i ][ j+210 ];
				sum[ i+1 ][ j+210 ]%=mod;
				sum[ i+1 ][ j-(i+1)+210 ]+=sum[ i ][ j+210 ];
				sum[ i+1 ][ j-(i+1)+210 ]%=mod;
				sum[ i+1 ][ j+(i+1)+210 ]+=sum[ i ][ j+210 ];
				sum[ i+1 ][ j+(i+1)+210 ]%=mod;
			}
}


const int delta=44100;

int count[ 21 ][ 2*delta + 1 ],n,m,x;


int calc() {
	int i,j,k;
	int aux=n*(n+1)/2;
	for (i=-(n*(n+1)/2 ); i <= n*(n+1)/2; ++i)
		count[ 1 ][ i+delta ]=sum[ n ][ i+210 ];

	for (i=1; i < m; ++i) {
		int ss=i*(i+1)/2; 
		ss*=210;
		for (j=-ss; j <= ss; ++j) 
			if (count[ i ][ j + delta ]) {
				int bla=count[ i ][ j+delta ];
				//printf ("Count[ %d ][ %d ]=%d\n",i,j,bla);
				for (k=-aux; k <= aux; ++k) {
					int kk=sum[ n ][ k+210 ];
					//printf ("KK=%d\n",kk);
					count[ i+1 ][ j+(k*(i+1) ) + delta ]+=bla * kk;
					count[ i+1 ][ j+(k*(i+1) ) + delta ]%=mod;
					//printf ("Exp count[ %d ][ %d ]=%d\n",i+1, j+(k*(i+1) ) ,count[ i+1 ][ j+(k*(i+1) ) + delta ]);
				}
			}
	}
	if ( x > delta || x < -delta) return 0;
	//printf ("Aici m=%d x=%d %d\n",m,x,count[ m ][ x+delta ]);
	return count[ m ][ x+delta ];
}  

int main() {
	FILE *fin=fopen ("diamant.in","r");
	FILE *fout=fopen ("diamant.out","w");
	fscanf (fin,"%d %d %d",&m,&n,&x);	
	precalc();
	fprintf (fout,"%d",calc() );
	fclose(fout);
	return 0;
}
 