# ifdef __BORLANDC__
	# define MMAX 1000
	# define NMAX 1000
# else
	using namespace std;
	# define NMAX 50001
	# define MMAX 100001
# endif


# include <fstream.h>
# include <stdlib.h>
# include <stdio.h>

// atentie la suma costurilor o bagam in long long .....

struct muchie {int n1,n2,c;};

muchie muchii[MMAX];int n,m;

muchie apm[NMAX];int nrm;
int ind[NMAX];

muchie mvit[NMAX];int nmvit;

void read()
{
	FILE * fin;fin=fopen("vitale.in","r");
	fscanf(fin,"%d %d",&n,&m);
	for (int i=1;i<=m;i++)
	 //fin>>muchie[i][0]>>muchie[i][1]>>muchie[i][2];
	 fscanf(fin,"%d %d %d",&muchii[i].n1,&muchii[i].n2,&muchii[i].c);
	fclose(fin);
}

int MuchieCmp(const void *a, const void *b)
{
	if (((muchie*) a)->c == ((muchie*) b)->c)
	 {
	  if (((muchie*) a)->n1 == ((muchie*) b)->n1)
	   {
	    return ((muchie*) a)->n2 - ((muchie*) b)->n2;
	   }
	  return ((muchie*) a)->n1 - ((muchie*) b)->n1;
	 }
	return ((muchie*) a)->c-((muchie*) b)->c;
}

int MuchieCmp2(const void *a, const void *b)
{
	if (((muchie*) a)->n1 == ((muchie*) b)->n1)
	 return ((muchie*) a)->n2 - ((muchie*) b)->n2;
	return ((muchie*) a)->n1 - ((muchie*) b)->n1;
}

struct nod {int nr,rang;nod * up;};
nod * noduri[NMAX];

void init()
{
	int i;nod * aux;
	for (i=1;i<=n;i++)
	 {
	  aux=new nod;aux->nr=i;aux->rang=0;aux->up=aux;
	  noduri[i]=aux;
	 }
}

nod * gasestem(nod * poz)  // apel cu noduri[i]
{
	if (poz->up==poz) return poz;
	 else
	  return poz->up=gasestem(poz->up);

}

int inline minim(int a,int b)
{	return a>b ? b :a;}
int inline maxim(int a,int b)
{	return a>b ? a:b;}

void uneste(nod * poz1, nod * poz2)
{
	if (poz1->rang  > poz2->rang)
	 {
	  poz2->up = poz1;
	 }
	 else if (poz1->rang != poz2->rang)
	  {
	   poz1->up=poz2;
	  }
	 else
	  {
	   poz1->up=poz2;poz2->rang++;
	  }
}

void reuneste(int nr1, int nr2)
{
	if (gasestem(noduri[nr1]) !=  gasestem(noduri[nr2]))
	 uneste(gasestem(noduri[nr1]),gasestem(noduri[nr2]));
}



void solve()
{
	// sortam muchiile dupa cost
	qsort(muchii+1,m,sizeof(muchie),MuchieCmp);
	init();
	int nr1,nr2,i,j;
# ifdef __BORLANDC__
	long sumapm=0,sumapm1;
# else
	long long sumapm=0,sumapm1;
# endif

	for (i=1;i<=m;i++)
	 {
	  nr1=muchii[i].n1;nr2=muchii[i].n2;
	  if (gasestem(noduri[nr1]) !=gasestem(noduri[nr2]))
	   {
	    apm[++nrm]=muchii[i];
	    ind[nrm]=i;
	    sumapm+=muchii[i].c;
	    reuneste(nr1,nr2);
	   }
	  if (nrm==n-1) break;
	 }
	// avem cele n-1 muchii in apm[NMAX];
	// eliminam pe fiecare pe rand
	for (i=1;i<=n-1;i++)
	 {
	  // o dam afara;
	  //muchii[ind[i]]=muchii[m];m--;

	  // gata acum facem apm
	  sumapm1=0;
	  nrm=0;


	  //qsort(muchii+1,m,sizeof(muchie),MuchieCmp);

	  init();
	  for (j=1;j<=m;j++)
	   {
	     if (j==ind[i]) j++;// o sarim

	     nr1=muchii[j].n1;nr2=muchii[j].n2;
	     if (gasestem(noduri[nr1]) !=gasestem(noduri[nr2]))
	      {
	       sumapm1+=muchii[j].c;
	       reuneste(nr1,nr2);
	      }
	     if (nrm==n-1) break;
	   }
	  // .....
	   if (sumapm1 != sumapm)

	    mvit[++nmvit]=apm[i];

	 }
	for (i=1;i<=nmvit;i++)
	 {
	  int a,b;a=mvit[i].n1;b=mvit[i].n2;
	  mvit[i].n1=minim(a,b);
	  mvit[i].n2=maxim(a,b);
	 }

	// sortare muchii vitale
	qsort(mvit+1,nmvit,sizeof(muchie),MuchieCmp2);

/*

// var 1

	// eliminam pe fiecare pe rand
	for (i=1;i<=n-1;i++)
	 {
	  // o dam afara;
	  muchii[ind[i]]=muchii[m];m--;

	  // gata acum facem apm
	  sumapm1=0;
	  nrm=0;


	  qsort(muchii+1,m,sizeof(muchie),MuchieCmp);

	  init();
	  for (j=1;j<=m;j++)
	   {
	     nr1=muchii[j].n1;nr2=muchii[j].n2;
	     if (gasestem(noduri[nr1]) !=gasestem(noduri[nr2]))
	      {
	       sumapm1+=muchii[j].c;
	       reuneste(nr1,nr2);
	      }
	     if (nrm==n-1) break;
	   }
	  // .....
	   if (sumapm1 != sumapm)
	   {
	    mvit[++nmvit]=apm[i];
	    // o bagam la loc
	    m++;muchii[m]=apm[i];
	    qsort(muchii+1,m,sizeof(muchie),MuchieCmp);
	   }

	 }
	for (i=1;i<=nmvit;i++)
	 {
	  int a,b;a=mvit[i].n1;b=mvit[i].n2;
	  mvit[i].n1=minim(a,b);
	  mvit[i].n2=maxim(a,b);
	 }

	// sortare muchii vitale
	qsort(mvit+1,nmvit,sizeof(muchie),MuchieCmp2);
*/
}

void print()
{
	FILE * fout;fout=fopen("vitale.out","w");
	int i;

	fprintf(fout,"%d\n",nmvit);
	for (i=1;i<=nmvit;i++)
	 fprintf(fout,"%d %d\n",mvit[i].n1,mvit[i].n2);

	fclose(fout);
}

int main()
{
	read();
	solve();
	print();
	return 0;
}
