#include <stdio.h>
#include <stdlib.h>

struct arc {
	int a, b;
	int cost;
	char vit;
};

struct arc arcs[100000];

int n, m;

int comp[50001];

FILE *in, *out;

int compare (const struct arc *a, const struct arc *b) {
	return a->cost - b->cost;
}

int compare2 (const struct arc *a, const struct arc *b) {
	if (a->a == b->a) return a->b - b->b;
	else return a->a - b->a;
}

int main () {
	int i, j, old, cnt, cntn;

	in = fopen ("vitale.in", "r");
	out = fopen ("vitale.out", "w");

	fscanf (in, "%d %d", &n, &m);
	for (i=0;i<m;i++) {
		fscanf (in, "%d %d %d", &arcs[i].a, &arcs[i].b, &arcs[i].cost);
		if (arcs[i].b < arcs[i].a) {
			old = arcs[i].b;
			arcs[i].b = arcs[i].a;
			arcs[i].a = old;
		}
		arcs[i].vit = 1;
	}
	qsort (arcs, m, sizeof (struct arc), (int (*)(const void*,const void*)) compare);
	for (i=0;i<n;i++) {
		comp[i] = i;
	}
	cnt=0;
	for (i=0;i<m && cnt < n-1;i++) {
		if (comp[arcs[i].a] == comp[arcs[i].b]) {
			arcs[i].vit = 0;
			continue;
		}
		if (arcs[i].vit == 0) continue;
		for (j=i+1;j<m && arcs[j].cost == arcs[i].cost;j++) {
			if ((comp[arcs[i].a] == comp[arcs[j].a] && comp[arcs[i].b] == comp[arcs[j].b]) || (comp[arcs[i].a] == comp[arcs[j].b] && comp[arcs[i].b] == comp[arcs[j].a])) {
				arcs[i].vit = 0;
				arcs[j].vit = 0;
			}
		}
		old = comp[arcs[i].a];
		for (j=1;j<=n;j++) {
			if (comp[j] == old) comp[j] = comp[arcs[i].b];
		}
		cnt++;
	}
	for (;i<m;i++) arcs[i].vit = 0;
	qsort (arcs, m, sizeof (struct arc), (int (*)(const void*,const void*)) compare2);

	cntn=0;
	for (i=0;i<m;i++) {
		if (arcs[i].vit == 1) {
			cntn++;
		}
	}
	fprintf (out, "%d\n", cntn);
	for (i=0;i<m;i++) {
		if (arcs[i].vit == 1) {
			fprintf (out, "%d %d\n", arcs[i].a, arcs[i].b);
		}
	}

	fclose (in);
	fclose (out);
	
	return 0;
}
