#include<stdio.h>
#include<stdlib.h>

#define NMAX 50010
#define nd(a) (*(t_E *)(a))

typedef struct
{
	int a, b, c;
}t_E;

void read();
void solve();
int gaseste(int x);
void uneste(int x, int y);
int cmp(const void *a, const void *b);


int N, M, seen[NMAX], sol[NMAX * 2], limd, T[NMAX], rang[NMAX];
t_E edge[NMAX * 2], tmp[NMAX];

int main(void)
{
	freopen("vitale.in", "r", stdin);
     freopen("vitale.out", "w", stdout);

     read();
     solve();
	return 0;
}

void read()
{
	int i;
     
	scanf("%d %d ", &N, &M);
     for(i = 0; i < M; i++)
     	scanf("%d %d %d ", &edge[i].a, &edge[i].b, &edge[i].c);
	qsort(edge, M, sizeof(t_E), cmp);
}

int cmp(const void *a, const void *b)
{
	return nd(a).c - nd(b).c;
}

void solve()
{
	int i, ok, j;

     seen[edge[0].a] = 1;

     for(i = 1; i <= N; i++)
     	T[i] = i;
          
     for(i = 0; i < M;)
     {
           ok = 0;
		for(j = i; edge[j].c == edge[i].c && j < M; j++)
          {
          tmp[j].c = gaseste(edge[j].a);
          tmp[j].a = gaseste(edge[j].b);
		tmp[j].b = j;
          }
		qsort(tmp + i, j - i, sizeof(t_E), cmp);

          if(tmp[i].c != tmp[i].a)
          	uneste(tmp[i].c, tmp[i].a);
          for(++i ;i < j; i++)
          {
			if(tmp[i].c != tmp[i - 1].c || tmp[i].a != tmp[i - 1].a)
               sol[limd++] = tmp[i - 1].b;
               if(tmp[i].c != tmp[i].a)
               	uneste(tmp[i].c, tmp[i].a);
          }
          if(tmp[i - 1].c != tmp[i - 2].c || tmp[i - 1].a != tmp[i - 2].a)
          	sol[limd++] = tmp[i - 1].b;
	}
     printf("%d\n", limd - 1);
     for(i = 0; i < limd - 1; i++)
     printf("%d %d\n", edge[i].a, edge[i].b);
}

int gaseste(int x)
{
	if(T[x] == x)
     	return x;
     return T[x] = gaseste(T[x]);
}

void uneste(int x, int y)
{
	if(rang[x] < rang[y])
     	T[x] = y;
     else
     {
     	T[y] = x;
          if(rang[x] == rang[y])
          	rang[x]++;
     }
}
