#include <stdio.h>

#define MAX 100000
#define MAXN 50000

int n,m,nr_sol;

struct muchie
{
    int u,v;
    int cost;
    int dis;
} muchii[MAX],aux[MAX];

int arbore[MAXN];
int noduri[MAXN+1];
int rez[MAXN];


void citire();
void sort(int,int);
void kruskal();
inline int cmp(int,int);

int main()
{
    int i,k;
    FILE *f_out;
    citire();
    sort(0,m-1);
/*    for (i=0; i<m; i++)
	printf ("%d %d %d\n",muchii[i].u,muchii[i].v,muchii[i].cost);*/
    for (i=1; i<=n; i++)
	noduri[i]=i;	
    kruskal();
/*    for (i=0; i<=n-2; i++)
    {	k=arbore[i];
	printf ("%d %d %d\n",muchii[k].u,muchii[k].v,muchii[k].cost);
    }*/
    f_out=fopen ("vitale.out","w");
    fprintf (f_out,"%d\n",nr_sol);
    for (i=0; i<nr_sol; i++)
	fprintf (f_out,"%d %d\n",muchii[rez[i]].u,muchii[rez[i]].v);
    fclose(f_out);	
    return 0;
}

void citire()
{
    FILE *f;
    int i,a,b;
    f=fopen ("vitale.in","r");
    fscanf(f,"%d %d",&n,&m);
    for (i=0; i<m; i++)
    {
	fscanf(f,"%d %d %d",&a,&b,&muchii[i].cost);
	if (a<b)
	{	
	    muchii[i].u=a;
	    muchii[i].v=b;
	}
	else
	{
	    muchii[i].u=b;
	    muchii[i].v=a;
	}
    }
    fclose(f);
}

void sort(int a, int b)
{
    int i,j,p,temp;
    muchie t;
    if (b-a<=6)
	{
	    for (i=a; i<b; i++)
		for (j=i+1; j<=b; j++)
		    if (cmp(i,j)==j)//muchii[i].cost>muchii[j].cost)
		    {
			t=muchii[i];
			muchii[i]=muchii[j];
			muchii[j]=t;
		    }
	    return;
	}
    i=a;
    j=(a+b)/2+1;
    sort (a,j-1);
    sort (j,b);
    p=i;
    temp=j;
    while (p<=b)
    {
	if (i>=temp)
	{
	    while (j<=b)
		aux[p++]=muchii[j++];
	    break;
	}
	
	if (j>b)
	{
	    while (i<=temp)
		aux[p++]=muchii[i++];
	    break;	
	}
	
	if (cmp(i,j)==i) //muchii[i].cost<muchii[j].cost)
	    aux[p++]=muchii[i++];
	else
            aux[p++]=muchii[j++];
    }
    for (i=a; i<=b; i++)
	muchii[i]=aux[i];
}

inline int cmp(int a,int b)
{
    if (muchii[a].cost<muchii[b].cost)
	return a;
    if (muchii[a].cost>muchii[b].cost)
	return b;
    if (muchii[a].u<muchii[b].u)
	return a;
    if (muchii[a].u>muchii[b].u)
	return b;
    if (muchii[a].v<muchii[b].v)
	return a;
    return b;
}

void kruskal()
{
    int p,k,s,i,smax;
    p=0;
    k=0;
    s=0;
    while (p<=(n-2))
	if (noduri[muchii[k].u]!=noduri[muchii[k].v])
	{
	    arbore[p++]=k;
	    if (noduri[muchii[k].u]<noduri[muchii[k].v])
		noduri[muchii[k].v]=noduri[muchii[k].u];
	    else
		noduri[muchii[k].u]=noduri[muchii[k].v];
	    s+=muchii[k].cost;
	    k++;
	}
	else
	    k++;

    smax=s;
    for (i=0; i<=(n-2); i++)
    {
	muchii[arbore[i]].dis=1;
	for (p=1; p<=n; p++)
	    noduri[p]=p;
	p=0;
	s=0;
	k=0;
        while (p<=(n-2))
	if (noduri[muchii[k].u]!=noduri[muchii[k].v])
	{
	    if (muchii[k].dis==1)
	    	goto next_k;
	    
	    s+=muchii[k].cost;
	    if (s>smax)
	    {	rez[nr_sol]=arbore[i];
		nr_sol++;
		goto next_m;
	    }
	    
	    if (noduri[muchii[k].u]<noduri[muchii[k].v])
		noduri[muchii[k].v]=noduri[muchii[k].u];
	    else
		noduri[muchii[k].u]=noduri[muchii[k].v];
	
	    p++;
next_k:		
	    k++;
	    
	}
	else
	    k++;
next_m:
	muchii[arbore[i]].dis=0;
    }
}
