
#include<stdio.h>
#include<stdlib.h>

#define Nmax 501   // 50.001
#define Mmax 1001  // 100.001


FILE *fin=fopen("vitale.in","r"), *fout=fopen("vitale.out","r");

long N,M;

struct graf{
long x,y,c; } m[Mmax*2], mcost[Mmax];


long tata[Nmax], poz[Nmax];
long muchiiutil[Mmax],muchiicritice[Mmax],util[Mmax];

int sort_function( const void *a, const void *b)
{
   graf v1,v2;

   v1=*(graf *) a;
   v2=*(graf *) b;

   if( v1.x-v2.x )
    return v1.x-v2.x;

  return v1.y-v2.y;
}


int sort_function1( const void *a, const void *b)
{
   graf v1,v2;

   v1=*(graf *) a;
   v2=*(graf *) b;

  return v1.c-v2.c;
}


  void read_data()
   {
long i,x1,y1,c1;

  fscanf(fin,"%ld %ld",&N,&M);

  M*=2;

  for(i=1;i<=M;i++)
   {
   fscanf(fin,"%ld %ld %ld",&x1,&y1,&c1);

   m[i].x=x1;   m[i].y=y1;   m[i].c=c1;
   m[++i].x=y1;   m[i].y=x1;   m[i].c=c1;

   mcost[i/2]=m[i-1];
    }
  fclose(fin);

    qsort( (void *)(m+1),     M,   sizeof(m[0]),     sort_function );
    M/=2;
    qsort( (void *)(mcost+1), M, sizeof(mcost[0]), sort_function1);

    poz[1]=1;
  for( i=2; i<= M;i++)
   if( m[i].x!=m[i-1].x ) poz[ m[i].x ] =i;

  for(i=1;i<=N;i++)
   tata[i]=-1;

   }

   void unite( long v1, long v2 )
    {
    if(  tata[v1] < tata[v2] )
      {
      tata[v1]+=tata[v2];
      tata[v2]=v1;
      }
    else
     {
      tata[v2]+=tata[v1];
      tata[v1]=v2;
      }

    }

   void kruskalmlogn()
    {
    long vinit,i,v1,v2,k,nrmuchii=0,poztemp,poz1;

    for( i=1 ; i<= M ; i++ )
     {
      v1=mcost[i].x;
      v2=mcost[i].y;

    while( tata[v1]>0 ) v1=tata[v1];
    while( tata[v2]>0 ) v2=tata[v2];

     if ( v1!=v2 )
      {
      muchiicritice[i]=1;
      muchiiutil[++nrmuchii]=i;
      util[i]=1;
      unite(v1,v2);
       }
    }


   // tata[ mcost[muchiiutil[1]].x ]=0;
   // tata[ mcost[muchiiutil[1]].y ]=mcost[muchiiutil[1]].x;



  for( k=1; k<= nrmuchii; k++)
   {
    poztemp=muchiiutil[k];

    v1=mcost[poztemp].x;
    v2=mcost[poztemp].y;

    tata[v1]*=-1;
     vinit=v1;

    for( poz1=poztemp+1 ; muchiicritice[poztemp] && mcost[poz1].c==mcost[poztemp].c ; poz1++)
       if( !util[poz1] )
	{
     v1=mcost[poz1].x;
     v2=mcost[poz1].y;

  while( tata[v1]>0 ) v1=tata[v1];
  while( tata[v2]>0 ) v2=tata[v2];

   if( v1!=v2 )
     muchiicritice[poztemp]=0;

       }

    for( poz1=poztemp-1; muchiicritice[poztemp] && mcost[poz1].c==mcost[poztemp].c; poz1-- )
       if( !util[poz1] )
	{
     v1=mcost[poz1].x;
     v2=mcost[poz1].y;

  while( tata[v1]>0 ) v1=tata[v1];
  while( tata[v2]>0 ) v2=tata[v2];

   if( v1!=v2 )
     muchiicritice[poztemp]=0;

       }

       tata[vinit]*=-1;
      }

    }


   void printsol()
    {
    graf sol[Nmax];
    long i,k=0,aux;

    for(i=1;i<N;i++)
     if( muchiicritice[ muchiiutil[i] ] )
       {
      sol[++k]=mcost[muchiiutil[i]];
      if( sol[k].x>sol[k].y) {
	    aux=sol[k].x;
	    sol[k].x=sol[k].y;
	    sol[k].y=aux;    }
      }


    qsort((void *)(sol+1), k, sizeof(sol[0]), sort_function);


 FILE *fout=fopen("vitale.out","w");
   fprintf(fout,"%ld\n",k);
    for(i=1;i<=k;i++)
     fprintf( fout,"%ld %ld\n",sol[i].x,sol[i].y);
      fclose(fout);
	}

int main()
{

  read_data();

  kruskalmlogn();


  printsol();

return 0;
}