#include <stdio.h>
#include <string.h>
#define Nmax 50001
#define INF 0x3f3f3f3f
struct list
{
	int info, c;
	struct list *next;
}*add, *a[Nmax], *b[Nmax];
struct xy
{
	int x, y;
}sol[2 * Nmax];
typedef struct list list;
typedef struct xy xy;
int n, m, ns, xn, yn, l[Nmax], f[Nmax];
char got[Nmax];
long long cost, now, d[Nmax];
FILE *fi, *fo;

void read_data()
{
	int i, j, k, l;
	fscanf(fi, "%d %d", &n, &m);
	l = m;
	for (; m; --m)
	{
		fscanf(fi, "%d %d %d", &i, &j, &k);
		add = (list*)malloc(sizeof(list));
		add -> info = j, add -> c = k;
		add -> next = a[i]; a[i] = add;
		add = (list*)malloc(sizeof(list));
		add -> info = i; add -> c = k;
		add -> next = a[j]; a[j] = add;
	}
	m = l;
}

int cmp(xy *a, xy *b)
{
	if (a -> x - b -> x)
		return a -> x - b -> x;
	return a -> y - b -> y;
}

void kkt(int pos)
{
	list *i;
	int j, pmin;
	long long k, min;
	got[pos] = 1;
	for (i = a[pos]; i; i = i -> next)
		if ((pos != xn || i -> info != yn) && d[pos] + i -> c < d[i -> info])
			d[i -> info] = d[pos] + i -> c, f[i -> info] = i -> c;
	min = INF, min *= Nmax, pmin = 0;
	for (j = 1; j <= n; ++j)
		if (!got[j] && d[j] < min)
			min = d[j], pmin = j, k = f[j];
	if (pmin)
	{
		now += k;
		kkt(pmin);
	}
}

void solve()
{
	int i, j, min;
	list *k, *l2;
	now = 0;
	for (i = 1; i <= n; ++i)
		d[i] = INF, d[i] *= Nmax;
	memset(got, 0, sizeof(got));
	got[1] = 1, d[1] = 0;
	kkt(1);
	cost = now;
	for (i = 1; i <= n; ++i)
	{
		min = INF;
		for (k = a[i]; k; k = k -> next)
			if (k -> c < min)
				min = k -> c;
		for (k = a[i]; k; k = k -> next)
			if (k -> c == min)
			{
				add = (list*)malloc(sizeof(list));
				add -> info = k -> info;
				add -> c = k -> c;
				add -> next = b[i];
				b[i] = add;
				++l[i];
			}
		if (l[i] == 1)
		{
			if (i < b[i] -> info)
				sol[ns].x = i, sol[ns].y = b[i] -> info;
			else
				sol[ns].x = b[i] -> info, sol[ns].y = i;
			++ns;
		}
		else
			if (n * m < 60000000)
			for (k = b[i]; k; k = k -> next)
			{
				memset(got, 0, sizeof(got));
				xn = i, yn = k -> info;
				got[i] = got[k -> info] = 1;
				for (j = 1; j <= n; ++j)
					d[j] = INF, d[j] *= Nmax;
				for (l2 = a[i]; l2; l2 = l2 -> next)
					if (l2 -> c < d[l2 -> info])
						d[l2 -> info] = l2 -> c, f[l2 -> info] = l2 -> c;
				d[i] = 0, d[k -> info] = k -> c, f[k -> info] = k -> c;
				now = k -> c;
				kkt(k -> info);
				if (now > cost)
				{
					if (i < b[i] -> info)
						sol[ns].x = i, sol[ns].y = k -> info;
					else
						sol[ns].x = k -> info, sol[ns].y = i;
					++ns;
				}
			}
	}
	qsort(sol, ns, sizeof(xy),(int(*)(const void*, const void*))cmp);
	for (i = j = 0; i < ns; ++i)
		if (!i || sol[i].x != sol[i - 1].x || sol[i].y != sol[i - 1].y)
			++j;
	fprintf(fo, "%d\n",j);
	for (i = j = 0; i < ns; ++i)
		if (!i || sol[i].x != sol[i - 1].x || sol[i].y != sol[i - 1].y)
			fprintf(fo, "%d %d\n", sol[i].x, sol[i].y);
}

int main()
{
	fi = fopen("vitale.in","r");
	fo = fopen("vitale.out","w");
	read_data();
	solve();
	fclose(fi);
	fclose(fo);
	return 0;
}
