#include <fstream.h>
#define INFILE "vitale.in"
#define OUTFILE "vitale.out"
#define MAX 100002

struct edge{
	long int i, j, c;
}a[MAX];

long int n, m, t[MAX], cost, h[MAX], s[MAX], k, x, y, nrm;
void LoadData();
void Solve();
void Qsort( long int l,long int r);
void Print();
void Union( long int i, long int j );
long int Find(long int i);
void Qsort2( long int l,long int r);

int main()
{
    LoadData();
    Solve();
    Print();
    return 0;
}

void Union( long int a, long int b )
{
	if( h[a] > h[b] )
	{
		t[b] = a;
	}
	else if( h[a] < h[b] )
	     {
		t[a] = b;
	     }
	     else
	     {
		t[a] = b;
		h[a]++;
	     }
}

void Print()
{
 //   ofstream fout(OUTFILE);
 ofstream fout(OUTFILE);
 long int i;
   // for( i = 1; i <= k; i++ )
     //	 fout << a[s[i]].c << " " << a[s[i]].i << " " << a[s[i]].j << "\n";
    fout << k - nrm << "\n";
    Qsort2( 1, k );
    for( i = 1; i <= k; i++ )
	     if( s[i] )
		     fout <<  a[s[i]].i << " " << a[s[i]].j << "\n";
    fout.close();
}

void LoadData()
{
    long int i;
    ifstream fin(INFILE);
    fin >> n >> m;
    for( i = 1; i <= m; i++ )
    {
	 fin >> x >> y >> a[i].c;
	if( x > y )
	{
		a[i].i = y;
		a[i].j = x;
	}
	else
	{
		a[i].i = x;
		a[i].j = y;
	}
    }
    fin.close();
}

void Qsort( long int st, long int dr )
{
    int i = st - 1, j = dr + 1, piv = a[st].c;
    do
    {
	do{ i++; } while( a[i].c < piv );
	do{ j--; } while( a[j].c > piv );
	if( i <= j )
	{
	    edge aux = a[i];
	    a[i] = a[j];
	    a[j] = aux;
	}
    } while( i <= j );
    if( dr > i ) Qsort( i, dr );
    if( j > st ) Qsort( st, j );
}

void Qsort2( long int st, long int dr )
{
    int i = st - 1, j = dr + 1, piv = s[st];
    do
    {
	do{ i++; } while( a[s[i]].i < a[piv].i || ( a[s[i]].i == a[piv].i && a[s[i]].j > a[piv].j)  );
	do{ j--; } while( a[s[j]].i > a[piv].i || ( a[s[j]].i == a[piv].i && a[s[j]].j > a[piv].j) );
	if( i <= j )
	{
	     long int aux = s[i];
	    s[i] = s[j];
	    s[j] = aux;
	}
    } while( i <= j );
    if( dr > i ) Qsort2( i, dr );
    if( j > st ) Qsort2( st, j );
}

void Solve()
{
    Qsort( 1, m );
    long int i, x, y, l, cost2 = 0;
    for( i = 1; i <= n; i++ )
    {
	t[i] = i; h[i] = 1;
    }
    for( i = 1; i <= m; i++ )
    {
	x = Find( a[i].i );
	y = Find( a[i].j );
	if ( x != y )
	{
		cost += a[i].c;
		s[++k] = i;
		Union( x, y );
	}
    }
    for( l = 1; l <= k; l++ )
    {
	cost2 = 0;
	for( i = 1; i <= n; i++ )
	{
		t[i] = i; h[i] = 1;
	}
	for( i = 1; i <= m; i++ )
	if( i != s[l] )
	{
		x = Find( a[i].i );
		y = Find( a[i].j );
		if ( x != y )
		{
			cost2 += a[i].c;
		       //	s[++k] = i;
			Union( x, y );
		}
	}
	if( cost2 == cost ){  s[l] = 0; nrm ++; }


    }
}

long int Find( long int x )
{
	if( x != t[x] ) x = Find( t[x] );
	return x;
}




