#include <stdio.h>
#define MOD 30103
#define MAX(x,y) ((x)>(y)?(x):(y))
#define MIN(x,y) ((x)<(y)?(x):(y))

int N, M, H, P;
int sol;

void sw(int *a, int *b) {
  int aux;
  aux = *a; *a = *b; *b = aux;
}

int putere(int a, int b)
{
  int ret = 1;
  while(b) {
    ret = (ret * a) % MOD;
    b--;
  }
  return ret;
}

int factorial(int a)
{
  int ret = 1;
  while(a) {
    ret = (ret * a) % MOD;
    a--;
  }
  return ret;
}

int c[408][408];

int combinari(int n, int k)
{
  int ret = 0;
  if(k == 0 || k == n)
    return 1;
  if(c[n][k])
    return c[n][k];
  ret = (combinari(n-1, k) + combinari(n-1, k-1)) % MOD;
  c[n][k] = ret;
  return ret;
}

void sortdim() {
  if(N < M)
    sw(&N, &M);
  if(N < H)
    sw(&N, &H);
  if(M < H)
    sw(&M, &H);
}

void mul2sol(int a) {
  sol = (sol * a) % MOD;
}

void solve()
{
  sol = 1;
  mul2sol(factorial(H));
  mul2sol(putere(H, M-H));
  mul2sol(factorial(M));
  mul2sol(putere(M*H, N-M));
  mul2sol(combinari(N*M*H - N, P-N));
}

int main()
{
  freopen("borg.in", "r", stdin);
  freopen("borg.out", "w", stdout);
  scanf("%d%d%d%d", &N, &M, &H, &P);
  sortdim();
  if(P < N)
    printf("0\n");
  else
  {
    solve();
    printf("%d\n", sol);
  }
	return 0;
}
