#include <stdio.h>
#include <stdlib.h>
#define NMAX 50008
#define MMAX 100008
#define MAX(x,y) ((x) > (y) ? (x) : (y))
#define MIN(x,y) ((x) < (y) ? (x) : (y))

typedef struct muchie { int n1, n2, c; } muchie;
typedef struct strsol { int n1, n2; } strsol;
int n, m;
muchie lm[MMAX];
char u[MMAX];
strsol sol[NMAX];
int soln;
int mul[NMAX], mulh[NMAX];
int mulm[NMAX];

int getmul(int nod)
{
  int t;
  if(mul[nod] == 0)
    return nod;
  t = getmul(mul[nod]);
  mul[nod] = t;
  return t;
}

void reuneste(int n1, int n2, int mm)
{
  int m1 = getmul(n1), m2 = getmul(n2);
  if(mulh[m1] > mulh[m2])
  {
    mul[m2] = m1;
    mulm[m1] = mm;
  }
  else
  {
    if(mulh[m1] == mulh[m2])
      mulh[m2]++;
    mul[m1] = m2;
    mulm[m2] = mm;
  }
}

int sortf2(const void *a, const void *b) {
  strsol *aa = (strsol *)a, *bb = (strsol *)b;
  if(aa->n1 == bb->n1)
    return aa->n2 - bb->n2;
  return aa->n1 - bb->n1;
}

void solve()
{
  int i, n1, n2, cost, m1, m2;
  for(i = 1; i <= m; i++)
  {
    n1 = lm[i].n1; n2 = lm[i].n2; cost = lm[i].c;
    m1 = getmul(n1); m2 = getmul(n2);
    if(m1 == m2)
    {
      u[i] = 1;
      if(lm[mulm[m1]].c == cost)
        u[mulm[m1]] = 1;
    } else {
      reuneste(n1, n2, i);
    }
  }
  for(i = 1; i <= m; i++)
    if(!u[i])
    {
      soln++;
      sol[soln].n1 = MIN(lm[i].n1, lm[i].n2);
      sol[soln].n2 = MAX(lm[i].n1, lm[i].n2);
    }
  qsort(sol+1, soln, sizeof(strsol), sortf2);
}

int sortf1(const void *a, const void *b) {
  muchie *aa = (muchie *)a, *bb = (muchie *)b;
  return aa->c - bb->c;
}

int main()
{
  int i, v1, v2, v3;
  freopen("vitale.in", "r", stdin);
  freopen("vitale.out", "w", stdout);
  scanf("%d%d", &n, &m);
  for(i = 1; i <= m; i++)
  {
    scanf("%d%d%d", &v1, &v2, &v3);
    lm[i].n1 = v1; lm[i].n2 = v2; lm[i].c = v3;
  }
  qsort(lm+1, m, sizeof(muchie), sortf1);
  solve();
  printf("%d\n", soln);
  for(i = 1; i <= soln; i++)
    printf("%d %d\n", sol[i].n1, sol[i].n2);
  return 0;
}
