#include <cstdio>
#include <algorithm>
#define mmax 200111
#define nmax 50111
#define inf 1000111000
#define sch(x,y) (x^=y^=x^=y)
#define pt(i) (1<<(i))
#define left (i<<1)
#define right ((i<<1)+1)
#define mij ((a+b)>>1)
#define MIN(x,y) (x<y?x:y)

using namespace std;

int n,m,par[nmax],z,v[nmax],ct[2*nmax],nr[2*nmax],urm[2*nmax],gg;
int ui[nmax],ndf[nmax],st[2*nmax],first[nmax],last[nmax],H[mmax];

void Vadd(int i,int j,int cc)
{
  urm[++z]=v[i];
  v[i]=z, nr[z]=j, ct[z]=cc;
}

struct mch
{
  int a,b;
}A[mmax];

void Add(int i,int j)
{
  if(i>j)
    sch(i,j);
  ++gg;
  A[gg].a=i,A[gg].b=j;
}

bool cmp1(const mch i, const mch j)
{
  return(i.a<j.a||(i.a==j.a&&i.b<j.b));
}

struct pct
{
  int x,y,ct;
  char zz;
}P[mmax];

int rep(int i)
{
  if(i!=par[i])
    par[i]=rep(par[i]);
  return(par[i]);
}

bool cmp(const pct i,const pct j)
{
  return(i.ct<j.ct||(i.ct==j.ct&&i.x<j.x)||
    (i.ct==j.ct&&i.x==j.x&&i.y<j.y));
}

bool cmpP(const pct i,const pct j)
{
  return(i.x<j.x||(i.x==j.x&&i.y<j.y)||
    (i.y==j.y&&i.x==j.x&&i.ct<j.ct));
}

void parc(int i)
{
  int j;
  ndf[i]=ndf[par[i]]+1;
  st[++z]=i;
  first[i]=z;
  for(j=v[i];j;j=urm[j])
    if(nr[j]!=par[i])
    {
      par[nr[j]]=i;
      parc(nr[j]);
      st[++z]=i;
    }     
  last[i]=z;
}

void parci(int i)
{
  int j,r;  
  st[++z]=i;
  H[z]=inf;
  for(j=v[i];j;j=urm[j])
    if(nr[j]!=par[i])
      parci(nr[j]);      
  for(j=ui[i];P[j].x==i;++j)
    if(!P[j].zz)
    {
//      r=lca(i,P[j].y);
      for(r=z;r&&(last[st[r]]>first[P[j].y]||first[st[r]]<last[P[j].y]);--r)
        H[r]=MIN(H[r],P[j].ct);
//        H[z]=MIN(H[z],P[j].ct);
      //FA LCA LOG N      
//      Hadd(1,1,n);
    }
//  X=z;
//  r=query(1,1,n);
  r=H[z];
  for(j=v[i];j;j=urm[j])
    if(nr[j]!=par[i])
      if(r>ct[j])
	Add(i,nr[j]);
  st[--z];
}

int main()
{
  FILE *fi=fopen("vitale.in","r"),*fo=fopen("vitale.out","w");
  
  fscanf(fi,"%d %d",&n,&m);
  int i,j,ii,c;
  for(ii=1;ii<=m;++ii)
  {
    fscanf(fi,"%d %d %d",&i,&j,&c);
    ++z;    
    P[z].x=i, P[z].y=j, P[z].ct=c;
    P[z].zz=0;
  }
  for(i=1;i<=n;++i)
    par[i]=i;
  fclose(fi);
  m=z;
  sort(P+1,P+z+1,cmp);
  for(z=0,i=1;i<=m;++i)
  {    
    if(rep(P[i].x)==rep(P[i].y))
      continue;
    par[P[i].x]=par[par[P[i].x]]=par[P[i].y];
    P[i].zz=1;
    Vadd(P[i].x,P[i].y,P[i].ct);
    Vadd(P[i].y,P[i].x,P[i].ct);        
  }
  z=0;
  for(i=1;i<=m;++i)
  {
    P[i+m]=P[i];
    sch(P[i].x,P[i].y);
  }
  m+=m;
  sort(P+1,P+m+1,cmpP);
  for(i=m;i;--i)
    ui[P[i].x]=i;
  memset(par,0,sizeof(par));
  z=0,parc(1);  
  z=0,parci(1);
  
  fprintf(fo,"%d\n",gg);
  sort(A+1,A+gg+1,cmp1);
  for(i=1;i<=gg;++i)
    fprintf(fo,"%d %d\n",A[i].a,A[i].b);
  fclose(fo);
  return(0);
}
