#include <stdio.h>
#include <string.h>

#define FIN "borg.in"
#define FOUT "borg.out"

#define MOD 30103

int N, M, H, K;
int stk[30][3], ans;
int Un[30], Um[30], Uh[30];

int nxt(int &i, int &j, int &k)
{
	if (k < H)
		k++;
	else if (j < M) {
		k = 1;
		j++;
	} else {
		k = j = 1;
		i++;
	}
}

int check()
{
	int i;
	memset(Un, 0, sizeof(Un));
	memset(Um, 0, sizeof(Um));
	memset(Uh, 0, sizeof(Uh));
	for (i = 1; i <= K; ++i) {
		Un[stk[i][0]] = 1;
		Um[stk[i][1]] = 1;
		Uh[stk[i][2]] = 1;
	}
	for (i = 1; i <= N; ++i)
		if (!Un[i])
			return 0;
	for (i = 1; i <= M; ++i)
		if (!Um[i])
			return 0;
	for (i = 1; i <= H; ++i)
		if (!Uh[i])
			return 0;
	return 1;
}

void back(int lev)
{
	int i, j, k;
	if (lev == K+1) {
		(ans += check()) %= MOD;
		return;
	}
	for (i = 0; i < 3; ++i)
		stk[lev][i] = stk[lev-1][i];
	for (nxt(stk[lev][0], stk[lev][1], stk[lev][2]); stk[lev][0] <= N;
			nxt(stk[lev][0], stk[lev][1], stk[lev][2]))
		back(lev+1);
}

int main()
{
	freopen(FIN, "r", stdin);
	freopen(FOUT, "w", stdout);

	scanf("%d%d%d%d", &N, &M, &H, &K);

	stk[0][0] = stk[0][1] = 1, stk[0][2] = 0;
	if (K >= N && K >= M && K >= H)
		back(1);
	printf("%d\n", ans);
	return 0;
}
