#include <stdio.h>
#include <string.h>

#define FIN "diamant.in"
#define FOUT "diamant.out"

#define MAX_S 45000
#define MOD   10000

int N, M, X;
int old[2*MAX_S], cur[2*MAX_S];
#define old(x) old[x+MAX_S]
#define cur(x) cur[x+MAX_S]

void read()
{
	FILE *fi = fopen(FIN, "r");
	fscanf(fi, "%d%d%d", &N, &M, &X);
	fclose(fi);
}

void solve()
{
	int i, j, k, s;
	memset(cur, 0, sizeof(old));
	memset(old, 0, sizeof(cur));
	for (s = 0, i = 1; i <= N; ++i)
		for (j = 1; j <= M; ++j)
			s += i*j;
	if (X < -s || X > +s)
		return;
	for (old(0) = 1, s = 0, i = 1; i <= N; ++i)
		for (j = 1; j <= M; ++j) {
		s += i*j;
		memset(cur, 0, sizeof(cur));
		for (k = -s; k <= +s; ++k) {
			if (k-i*j >=-s)
				(cur(k-i*j) += old(k)) %= MOD;
			(cur(k) += old(k)) %= MOD;
			if (k+i*j <= +s)
				(cur(k+i*j) += old(k)) %= MOD;
		}
		memcpy(old, cur, sizeof(old));
	}
}

void write()
{
	FILE *fo = fopen(FOUT, "w");
	fprintf(fo, "%d\n", cur(X));
	fclose(fo);
}

int main()
{
	read();
	solve();
	write();
	return 0;
}
