#include <stdio.h>

#define DMAX 20
#define KMAX 20
#define maxim(a,b) ((a>b)?(a):(b))
#define minim(a,b) ((a>b)?(b):(a))

FILE *fin,*fout;

int N,M,H;
long K;
long cmod=30103;
long nr1[21][KMAX+1],nr2[21][KMAX+1];

long invm[DMAX*DMAX+1];

long comb(long A,long B)
{long i,pr=1,sub=1;
 if (!B) return 1;
 if (!A) return 0;
 for (i=A;i>A-B;--i) pr=(pr*i)%cmod;
 for (i=2;i<=B;++i) sub=(sub*i)%cmod;
 pr=(pr*invm[sub])%cmod;
 return pr;
}

void euclid(long A,long B,long &x,long &y)
{long xx,yy;
 if (!B) {x=1;y=0;}
 else {euclid(B,A%B,xx,yy);
       x=yy;y=xx-(A/B)*yy;
      }
}

int main()
{long i,j,p,k,l,x,y;
 fin=fopen("borg.in","r");
 fscanf(fin,"%d %d %d",&N,&M,&H);
 fscanf(fin,"%ld",&K);
 if (K<maxim(maxim(N,M),H)) {fout=fopen("borg.out","w");
			     fprintf(fout,"0\n");
			     fclose(fout);
			    }
 else {for (i=1;i<=maxim(maxim(N,M),H);++i)
	  {euclid(i,cmod,x,y);
	   while (x<0) x+=cmod;
	   invm[i]=x;
	  }
       if (N==1) {N=M;M=H;}
       else if (M==1) {M=H;}
       nr1[0][0]=1;
       for (i=1;i<=N;++i)
	   {for (j=1;j<=M;++j)
		for (k=maxim(i,j);k<=K;++k)
		    {for (p=j;p>=1;--p)
			 {nr2[j][k]=(nr2[j][k]+nr1[j][k-p]*comb(j-p,p))%cmod;
			 }
		    }
	    for (j=1;j<=M;++j)
	      for (k=maxim(i,j);k<=K;++k)
		  {nr1[j][k]=nr2[j][k];nr2[j][k]=0;}
	   }
       fout=fopen("borg.out","w");
       fprintf(fout,"%ld\n",nr1[M][K]);
       fclose(fout);
      }
 return 0;
}