#include <stdio.h>

#define NMAX 100
#define MMAX 100
#define FMAX 100
#define maxim(a,b) ((a>b)?(a):(b))
#define minim(a,b) ((a>b)?(b):(a))

long n,m;
FILE *fin,*fout;
struct muchii
{long c1,c2,c3;
 char pus;
}muc[MMAX+1];
long lm,coada[NMAX+1];
struct mdisj
{long tata,rang;
}md[NMAX+1];
struct Nod
{int v;
 Nod *leg;
}*gr[NMAX+1];
long sel[NMAX+1],grad[NMAX+1];

void Combina(long vf,long nn)
{long baza;
 muchii val=muc[vf];
  for (baza=2*vf;baza<=nn;baza<<=1)
      {if (baza<nn&&muc[baza].c3<muc[baza+1].c3) ++baza;
       if (val.c3<muc[baza].c3)
	  {muc[vf]=muc[baza];vf=baza;}
       else break;
      }
 muc[vf]=val;
}
void Heap()
{long i;
 for (i=m/2;i>=1;--i) Combina(i,m);
}
void Heapsort()
{long i;
 muchii aux;
 Heap();
 for (i=m;i>1;--i)
     {aux=muc[i];muc[i]=muc[1];muc[1]=aux;
      Combina(1,i-1);
     }
}
int comp(muchii A,muchii B)
{return ((A.c1<B.c1)||(A.c1==B.c1&&A.c2<B.c2));
}
void Combina2(long vf,long nn)
{long baza;
 muchii val=muc[vf];
  for (baza=2*vf;baza<=nn;baza<<=1)
      {if (baza<nn&&comp(muc[baza],muc[baza+1])) ++baza;
       if (comp(val,muc[baza]))
	  {muc[vf]=muc[baza];vf=baza;}
       else break;
      }
 muc[vf]=val;
}
void Heap2()
{long i;
 for (i=m/2;i>=1;--i) Combina2(i,m);
}
void Heapsort2()
{long i;
 muchii aux;
 Heap2();
 for (i=m;i>1;--i)
     {aux=muc[i];muc[i]=muc[1];muc[1]=aux;
      Combina2(1,i-1);
     }
}

int find(long pp)
{long rad,i,next;
 for (i=pp;md[i].tata;i=md[i].tata);
 rad=i;
 for (i=pp;i!=rad;i=next) {next=md[i].tata;md[i].tata=rad;}
 return rad;
}
void uneste(long p1,long p2)
{if (md[p1].rang<md[p2].rang)
    md[p1].tata=p2;
 else {md[p2].tata=p1;
       md[p1].rang=maxim(md[p1].rang,md[p2].rang+1);
      }
}

void add_edge(int x1,int x2)
{Nod *p;
 p=new Nod;p->v=x2;p->leg=gr[x1];gr[x1]=p;
}
int main()
{long i,a,b,c,j,k,parc,i_c,sf_c,salt;
 Nod *p;
 fin=fopen("vitale.in","r");
 fscanf(fin,"%ld %ld",&n,&m);
 for (i=1;i<=n;++i) {md[i].tata=0;md[i].rang=1;}
 for (i=1;i<=m;++i)
     {fscanf(fin,"%ld %ld %ld",&a,&b,&c);
      muc[i].c1=a;muc[i].c2=b;muc[i].c3=c;
     }
 fclose(fin);
 Heapsort();
 parc=0;
 for (i=1;i<=m;++i)
     {for (j=i;j<=m&&muc[j].c3==muc[i].c3;++j);
      for (k=i;k<j;++k)
	  {a=find(muc[i].c1);
	   b=find(muc[i].c2);
	   if (a!=b)
	      {add_edge(a,b);
	       add_edge(b,a);
	       grad[a]++;grad[b]++;
	      }
	  }
      i_c=sf_c=0;
      ++parc;
      for (k=i;k<j;++k)
	 {a=find(muc[i].c1);
	  b=find(muc[i].c2);
	  if (a!=b)
	     {if (grad[a]==1) {coada[++sf_c]=a;sel[a]=parc;}
	      if (grad[b]==1) {coada[++sf_c]=b;sel[b]=parc;}
	     }
	 }
      i_c=1;
      for (;i_c>=sf_c;++i_c)
	 for (p=gr[coada[i_c]];p;p=p->leg)
	     {grad[p->v]--;
	      if (grad[p->v]==1&&sel[p->v]!=parc) coada[++sf_c]=p->v;
	     }
      for (k=i;k<j;++k)
	  {a=find(muc[i].c1);
	   b=find(muc[i].c2);
	   if (a!=b&&(sel[a]==parc||sel[b]==parc)) muc[i].pus='1';
	   grad[a]=0;grad[b]=0;
	   if (gr[a])
	      {while (gr[a]) {p=gr[a];gr[a]=gr[a]->leg;delete p;}
	       gr[a]=NULL;
	      }
	   if (gr[b])
	      {while (gr[b]) {p=gr[b];gr[b]=gr[b]->leg;delete p;}
	       gr[b]=NULL;
	      }
	  }
      if (find(muc[i].c1)!=find(muc[i].c2))
	 {uneste(find(muc[i].c1),find(muc[i].c2));}
     }
 for (i=1,salt=0;i<=m;++i)
     if (muc[i].pus!='1') ++salt;
     else muc[i-salt]=muc[i];
 m-=salt;
 Heapsort2();
 fout=fopen("vitale.out","w");
 for (i=1;i<=m;++i)
   fprintf(fout,"%ld %ld\n",muc[i].c1,muc[i].c2);
 fclose(fout);

 return 0;
}