#include <cstdio>
#include <cstdlib>
#include <cstring>

#define NMAX 21
#define MODULO 30103
#define MAX(a, b) ((a) >= (b) ? (a) : (b))
int N, M, H, K, mx, i, j, k, Ans;
int u0[NMAX], u1[NMAX], u2[NMAX], nr0, nr1, nr2;

inline int max3(int a, int b, int c)
{
    if (a >= b && a >= c) return a;
    if (b >= a && b >= c) return b;
    if (c >= a && c >= b) return c;
    return -1; // :-?
}

void baga(int x, int y, int z, int rem)
{
    if (rem < max3(N - nr0, M - nr1, H - nr2))
       return;
    if (rem > N*M*H - (x - 1)*M*H - (y - 1) * H - (z - 1))
       return;

    if (x > N)
    {
        if (rem == 0 && nr0 == N && nr1 == M && nr2 == H)
           (++ Ans) %= MODULO;
        return;
    }

    int nx = x, ny = y, nz = z + 1;
    if (z == H)
       nx = x, ny = y + 1, nz = 1;
    if (y == M && z == H)
       nx = x + 1, ny = 1, nz = 1;

    //il iau
    if (!u0[x]) ++ nr0;
    if (!u1[y]) ++ nr1;
    if (!u2[z]) ++ nr2;
    ++ u0[x], ++ u1[y], ++ u2[z];
    baga(nx, ny, nz, rem - 1);
    -- u0[x], -- u1[y], -- u2[z];
    if (!u0[x]) -- nr0;
    if (!u1[y]) -- nr1;
    if (!u2[z]) -- nr2;

    //nu il iau
    baga(nx, ny, nz, rem);
}


int main(void)
{
    freopen("borg.in", "r", stdin);
    freopen("borg.out", "w", stdout);
    scanf("%d %d %d %d", &N, &M, &H, &K);

    mx = MAX(N, M), mx = MAX(mx, H);
    if (K < mx)
    {
        printf("0\n"); return 0;
    }

    memset(u0, 0, sizeof(u0));
    memset(u1, 0, sizeof(u1));
    memset(u2, 0, sizeof(u2));
    Ans = nr0 = nr1 = nr2 = 0;
    baga(1, 1, 1, K);

    printf("%d\n", Ans);
    return 0;
}
