
var
    n,i,j,k,m: longint;
    nr:longint;
    a,b: array[1..200001,1..3] of longint;
    apm: array[1..50001,1..3] of integer;
    vital: array[1..50001] of boolean;
    x1,x2,x3: longint;
    intree: array[1..50001]of boolean;
    p: array[1..50001]of longint;
    l: array[1..50001]of longint;
    inli: array[1..50001]of boolean;
    tree: array[1..50001]of integer;

procedure scan;
var i: longint;
begin
    assign(input,'vitale.in');
    reset(input);

    readln(n,m);
    for i:=1 to m do readln(a[i,1],a[i,2],a[i,3]);

    for i:=1 to m do
     begin
      a[m+i,1]:=a[i,2];
      a[m+i,2]:=a[i,1];
      a[m+i,3]:=a[i,3];
     end;

    m:=2*m;

    close(input);
end;

procedure inter(x,y: longint);
var t: longint;
begin
    t:=a[x,1];
    a[x,1]:=a[y,1];
    a[y,1]:=t;
    t:=a[x,2];
    a[x,2]:=a[y,2];
    a[y,2]:=t;
    t:=a[x,3];
    a[x,3]:=a[y,3];
    a[y,3]:=t;
end;

procedure inter2(x,y: longint);
var t: longint;
begin
    t:=apm[x,1];
    apm[x,1]:=apm[y,1];
    apm[y,1]:=t;
    t:=apm[x,2];
    apm[x,2]:=apm[y,2];
    apm[y,2]:=t;
    t:=apm[x,3];
    apm[x,3]:=apm[y,3];
    apm[y,3]:=t;
end;


procedure sort1(l,r: longint);
var i,j,x: longint;
begin
  i := l; j := r; x := a[(l+r) DIV 2,3];
  repeat
    while a[i,3] < x do i := i + 1;
    while x < a[j,3] do j := j - 1;
    if i <= j then
    begin
      inter(i,j);
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then sort1(l, j);
  if i < r then sort1(i, r);
end;

procedure skal;
var i,nr: longint;
begin
    for i:=1 to n do
     begin
      intree[i]:=false;
     end;

    apm[1,1]:=a[1,1];
    apm[1,2]:=a[1,2];
    apm[1,3]:=a[1,3];
    intree[a[1,1]]:=true;
    intree[a[1,2]]:=true;
    nr:=2;

    repeat
     for i:=2 to m do
     if (intree[a[i,2]] and not intree[a[i,1]]) or
        (intree[a[i,1]] and not intree[a[i,2]]) then
      begin
       apm[nr,1]:=a[i,1];
       apm[nr,2]:=a[i,2];
       apm[nr,3]:=a[i,3];
       intree[a[i,1]]:=true;
       intree[a[i,2]]:=true;
       inc(nr);
       break;
      end;
    until nr=n;

end;

procedure sort2(l,r: longint);
var i,j,x: longint;
begin
  i := l; j := r; x := apm[(l+r) DIV 2,1];
  repeat
    while apm[i,1] < x do i := i + 1;
    while x < apm[j,1] do j := j - 1;
    if i <= j then
    begin
      inter2(i,j);
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then sort2(l, j);
  if i < r then sort2(i, r);
end;

procedure sort3(l,r: longint);
var i,j,x: longint;
begin
  i := l; j := r; x := apm[(l+r) DIV 2,2];
  repeat
    while apm[i,2] < x do i := i + 1;
    while x < apm[j,2] do j := j - 1;
    if i <= j then
    begin
      inter2(i,j);
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then sort3(l, j);
  if i < r then sort3(i, r);
end;

procedure detpos;
begin
    p[apm[1,1]]:=1;

    for i:=2 to 2*n-2 do
     if apm[i,1]<>apm[i-1,1] then p[apm[i,1]]:=i;

    p[n+1]:=2*n-1;
end;

procedure bf(nod,nr: longint);
var i,pi,pf: longint;
begin
    fillchar(inli,sizeof(inli),0);
    fillchar(l,sizeof(l),0);

    pi:=1;
    pf:=1;
    l[1]:=nod;
    inli[nod]:=true;

    while pf>=pi do
     begin
      tree[l[pi]]:=nr;
      for i:=p[l[pi]] to p[l[pi]+1]-1 do

      if (not ((apm[i,1]=x1) and (apm[i,2]=x2))) and
         (not ((apm[i,2]=x1) and (apm[i,1]=x2))) then

       if not inli[apm[i,2]] then
        begin
         inc(pf);
         l[pf]:=apm[i,2];
         inli[apm[i,2]]:=true;
        end;
      inc(pi);
     end;
end;

function bs(x: longint): longint;
var i,up,lo:longint;
begin
    lo:=1;
    up:=m;
    repeat
     if a[(lo+up) div 2,3]>x then begin up:=(lo+up) div 2; end;
     if a[(lo+up) div 2,3]<x then begin lo:=(lo+up) div 2; end;
    until a[(lo+up) div 2,3]=x;
    bs:=(lo+up) div 2;
end;

begin
    scan;

    sort1(1,m);
    skal;

    for i:=1 to n-1 do
     begin
      apm[n-1+i,1]:=apm[i,2];
      apm[n-1+i,2]:=apm[i,1];
      apm[n-1+i,3]:=apm[i,3];
     end;

    sort2(1,2*n-2);
    detpos;

    for i:=1 to n do sort3(p[i],p[i+1]-1);

    for i:=1 to 2*n-2 do vital[i]:=true;

    for i:=1 to 2*n-2 do
     begin
      x1:=apm[i,1];
      x2:=apm[i,2];
      x3:=apm[i,3];

      bf(x1,1);
      bf(x2,2);

      k:=bs(x3);

      j:=k;
      while (a[j,3]=x3)and(j<m) do
       begin
      if (not ((a[j,1]=x1) and (a[j,2]=x2))) and
         (not ((a[j,2]=x1) and (a[j,1]=x2))) then
        if tree[a[j,1]]<>tree[a[j,2]] then
        begin vital[i]:=false; break; end;
        inc(j);
       end;

      j:=k;
      while (a[j,3]=x3)and(j>1) do
       begin
      if (not ((a[j,1]=x1) and (a[j,2]=x2))) and
         (not ((a[j,2]=x1) and (a[j,1]=x2))) then
        if tree[a[j,1]]<>tree[a[j,2]] then
        begin vital[i]:=false; break; end;
        dec(j);
       end;
     end;

    nr:=0;
    for i:=1 to 2*n-2 do
     if vital[i] then inc(nr);

     nr:=nr div 2;

    assign(output,'vitale.out');
    rewrite(output);

    writeln(nr);

    for i:=1 to 2*n-2 do
     if (vital[i]) and (apm[i,1]<apm[i,2]) then writeln(apm[i,1],' ',apm[i,2]);

    close(output);
end.
