{$S-,R-,Q-,B-}

const maxN = 50010;
      maxM = 100010;
      hValue = 1000000001;

type point = ^celula;
     celula = record
      inf, ind: longint;
      leg: point;
     end;

var x, y, c: array[0..maxM] of longint;
    p, rang: array[0..maxN] of longint;
    a: array[0..maxN] of point;
    seen: array[0..maxN] of boolean;
    sel: array[0..maxM] of boolean;
    l, nod1, nod2, nr, i, n, m, j, aux, high: longint;
    q: point;

procedure read_data;
var f: text;
begin

 assign(f, 'vitale.in'); reset(f);

  readln(f, n, m);
  for i := 1 to n do a[i] := nil;
  for i := 1 to m do begin

      readln(f, x[i], y[i], c[i]);

      if x[i] > y[i] then begin
         aux := x[i]; x[i] := y[i]; y[i] := aux;
      end;

  end;

 close(f);

end;

procedure qSortc(l, r: longInt);
var
  i, j, xx, yy: longint;
begin
  i := l; j := r; xx := c[(l + r) DIV 2];
  repeat
    while c[i] < xx do i := i + 1;
    while xx < c[j] do j := j - 1;
    if i <= j then
    begin
      yy := x[i]; x[i] := x[j]; x[j] := yy;
      yy := y[i]; y[i] := y[j]; y[j] := yy;
      yy := c[i]; c[i] := c[j]; c[j] := yy;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then qSortc(l, j);
  if i < r then qSortc(i, r);
end;

procedure qSortx(l, r: longInt);
var
  i, j, xx, yy: longint;
begin
  i := l; j := r; xx := x[(l + r) DIV 2];
  repeat
    while x[i] < xx do i := i + 1;
    while xx < x[j] do j := j - 1;
    if i <= j then
    begin
      yy := x[i]; x[i] := x[j]; x[j] := yy;
      yy := y[i]; y[i] := y[j]; y[j] := yy;
      yy := c[i]; c[i] := c[j]; c[j] := yy;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then qSortx(l, j);
  if i < r then qSortx(i, r);
end;

procedure qSorty(l, r: longInt);
var
  i, j, xx, yy: longint;
begin
  i := l; j := r; xx := y[(l + r) DIV 2];
  repeat
    while y[i] < xx do i := i + 1;
    while xx < y[j] do j := j - 1;
    if i <= j then
    begin
      yy := x[i]; x[i] := x[j]; x[j] := yy;
      yy := y[i]; y[i] := y[j]; y[j] := yy;
      yy := c[i]; c[i] := c[j]; c[j] := yy;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then qSorty(l, j);
  if i < r then qSorty(i, r);
end;

function dad(nod: longint): longint;
begin

 while p[nod] <> nod do nod := p[nod];
 dad := nod;

end;

procedure df(k: longint);
var q: point;
begin

 seen[k] := true; q := a[k];
 while q <> nil do begin

  if (not seen[q^.inf]) and (not seen[y[i]]) then begin
     df(q^.inf);
     if c[q^.ind] = c[i] then sel[q^.ind] := false;
  end;

  q := q^.leg;

 end;

end;

procedure main;
begin

 qsortc(1, m);
 // sortare dupa cost;

 i := 1;
 while (i <= m) do begin

  j := i;
  while (j <= m) and (c[i] = c[j]) do inc(j);
  if i < j - 1 then qsortx(i, j - 1);
  i := j;

 end;
 // sortare dupa x

 i := 1;
 while (i <= m) do begin

  j := i;
  while (j <= m) and (c[i] = c[j]) and (x[i] = x[j]) do inc(j);
  if i < j - 1 then qsorty(i, j - 1);
  i := j;

 end;
 // sortare dupa y

 fillchar(sel, sizeof(sel), false);
 for i := 1 to n do begin
     p[i] := i;
     rang[i] := 1;
 end;
 // initializari pentru APM

 high := hValue; l := 0;
 for i := 1 to m do begin

     if (c[i] > high) and (l = n - 1) then exit;

     nod1 := dad(x[i]);
     nod2 := dad(y[i]);

     if nod1 <> nod2 then begin

        sel[i] := true; inc(l);
        if rang[nod1] < rang[nod2] then p[nod1] := nod2 else
        if rang[nod1] > rang[nod2] then p[nod2] := nod1 else
        if rang[nod1] = rang[nod2] then begin
           p[nod1] := p[nod2];
           rang[nod2] := rang[nod2] + 1;
        end;

        new(q); q^.inf := y[i]; q^.leg := a[x[i]]; a[x[i]] := q; q^.ind := i;
        new(q); q^.inf := x[i]; q^.leg := a[y[i]]; a[y[i]] := q; q^.ind := i;
        high := c[i];

     end else begin

       // elimin toate muchiile pe de traseul de la x[i] la y[i] cu cost = c[i]
       fillchar(seen, sizeof(seen), false);
       df(x[i]);

     end;

 end;
 // APM

end;

procedure write_data;
var g: text;
begin

 assign(g, 'vitale.out'); rewrite(g);

  nr := 0;
  for i := 1 to m do
   if sel[i] then inc(nr);

  writeln(g, nr);
  for i := 1 to m do
   if sel[i] then writeln(g, x[i], ' ', y[i]);

 close(g);

end;

begin

 read_data;
 main;
 write_data;

end.
