#include <stdio.h>
#include <string.h>
#define modulo 30103

int V[32][32][32], UX[32], UY[32], UZ[32], N, M, H, K, sol;

int Check()
{
    int i, j, l;

    memset(UX, 0, sizeof(UX));
    memset(UY, 0, sizeof(UY));
    memset(UZ, 0, sizeof(UZ));
    for (i = 0; i < N; i++)
    for (j = 0; j < M; j++)
    for (l = 0; l < H; l++)
        if (V[i][j][l]) UX[i] = UY[j] = UZ[l] = 1;
    for (i = 0; i < N && UX[i]; i++);
    if (i < N) return 0;
    for (i = 0; i < M && UY[i]; i++);
    if (i < M) return 0;
    for (i = 0; i < H && UZ[i]; i++);
    if (i < H) return 0;
    return 1;
}

void back(int k, int x, int y, int z)
{
    int i, j, l;

    if (k > K)
    {
        if (Check()) sol++;
        return;
    }

    i = x, j = y, l = z;
    l++;
    if (l == H) j++, l = 0;
    if (j == M) i++, j = 0;
    for (; i < N;)
    {
        V[i][j][l] = 1;
        back(k+1, i, j, l);
        V[i][j][l] = 0;
        l++;
        if (l == H) j++, l = 0;
        if (j == M) i++, j = 0;
    }
}

int main()
{
    int i;
    
    freopen("borg.in", "r", stdin);
    freopen("borg.out", "w", stdout);
    scanf("%d %d %d %d", &N, &M, &H, &K);

    i = N;
    if (M > i) i = M;
    if (H > i) i = H;

    if (K == N * M * H)
    {
        printf("1\n");
        return 0;
    }
    sol = 0;
    if (K >= i) back(1, 0, 0, -1);
    printf("%d\n", sol % modulo);
    
    return 0;
}
