#include <stdio.h>
#include <algorithm>

using namespace std;

#define MAX_N 50005
#define MAX_M 100005
#define FIN "vitale.in"
#define FOUT "vitale.out"
#define FOR(i, a, b) for (i = (a); i < (b); i++)
#define mp make_pair
#define f first
#define s second

int N, M, ne, up[MAX_N], rank[MAX_N]; char U[MAX_N];
pair < int, pair<int, int> > E[MAX_M];
pair < pair<int, int>, int > E2[MAX_M];

int find(int n)
{
    if (n != up[n])
       up[n] = find(up[n]);
    return up[n];
}

void reunion(int i, int j)
{
    if (rank[i] < rank[j])
       up[i] = j;
    else
       up[j] = i;
    if (rank[i] == rank[j]) rank[i]++;
}

int main(void)
{
    int a, b, c, x, y, m, i, j;
    
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d %d", &N, &M);
    for (m = 0; m < M; m++)
    {
        scanf("%d %d %d", &a, &b, &c);
        E[m] = mp(c, mp(a, b));
    }

    FOR (i, 1, N+1) up[i] = i;

    sort(E, E+M);
    for (i = 0; i < M; i = j)
    {
        a = E[i].s.f; b = E[i].s.s; c = E[i].f;
        for (ne = 0, j = i; j < M && E[j].f == c; j++)
        {
            x = find(E[j].s.f); y = find(E[j].s.s);
            if (x > y) swap(x, y);
            if (x != y) E2[ne++] = mp(mp(x, y), j);
        }
        sort(E2, E2+ne);
        for (j = 0; j < ne; j++)
            if ((j == 0 || E2[j].f != E2[j-1].f) && (j == ne-1 || E2[j].f != E2[j+1].f)) U[E2[j].s] = 1;

        for (j = i; j < M && E[j].f == c; j++)
        {
            x = find(E[j].s.f); y = find(E[j].s.s);
            if (x == y) continue;
            if (U[j]) U[j] = 2;
            reunion(x, y);
        }
    }

    ne = 0;
    FOR (i, 0, M)
    {
        a = E[i].s.f; b = E[i].s.s;
        if (a > b) swap(a, b);
        if (U[i] == 2) E2[ne++] = mp(mp(a, b), i);
    }
    sort(E2, E2+ne);

    printf("%d\n", ne);
    FOR (i, 0, ne) printf("%d %d\n", E2[i].f.f, E2[i].f.s);

    return 0;
}
