type rec=record
x,y,c:longint;
end;
const MAXN=1000;
const MAXM=100000;
var f,g:text;
    i,j,n,m,nk,ncst,cst,ns,nd,mxx,mnn:longint;
    mc,sl:array[1..MAXM] of rec;
    sol,used,tsol:array[0..100] of integer;
    mat:array[1..MAXN,0..MAXN] of byte;
    tata,chosen:array[1..MAXN] of longint;

    procedure QSort(left, right:longint);
    var i,j,mid:longint;
        t:rec;
    begin
      i:=left; j:=right;
      mid:=mc[(i+j)shr 1].c;
      while i<=j do begin
        while mc[i].c<mid do inc(i);
        while mc[j].c>mid do dec(j);
        if i<=j then begin
           t:=mc[i]; mc[i]:=mc[j]; mc[j]:=t;
          inc(i); dec(j);
        end;
      end;
      if i<right then QSort(i, right);
      if j>left then QSort(left, j);
    end;

    procedure QSortMc(left, right:longint);
    var i,j,midx,midy:longint;
        t:rec;
    begin
      i:=left; j:=right;
      midx:=sl[(i+j)shr 1].x;
      midy:=sl[(i+j)shr 1].y;
      while i<=j do begin
        while (sl[i].x<midx)or((sl[i].x=midx)and(sl[i].y<midy)) do inc(i);
        while (sl[j].x>midx)or((sl[j].x=midx)and(sl[j].y>midy)) do dec(j);
        if i<=j then begin
          t:=sl[i]; sl[i]:=sl[j]; sl[j]:=t;
          inc(i); dec(j);
        end;
      end;
      if i<right then QSortMc(i, right);
      if j>left then QSortMc(left, j);
    end;

    function conex:boolean;
    var i,j,ps,pf,x,y,node,node2:integer;
        c,viz:array[1..100] of integer;
    begin
      for i:=1 to n do mat[i,0]:=0;
      for i:=1 to nk do begin
        x:=mc[sol[i]].x; y:=mc[sol[i]].y;
        inc(mat[x,0]); mat[x,mat[x,0]]:=y;
        inc(mat[y,0]); mat[y,mat[y,0]]:=x;
      end;
      fillchar(viz, sizeof(viz), 0);
      ps:=1; pf:=1; c[ps]:=1; viz[1]:=1;
      while ps<=pf do begin
        node:=c[ps];
        for i:=1 to mat[node,0] do begin
          node2:=mat[node,i];
          if viz[node2]=0 then begin
            viz[node2]:=1;
            inc(pf);
            c[pf]:=node2;
          end;
        end;
        inc(ps);
      end;
      conex:=pf=n;
    end;

    procedure bktr(p:integer);
    var i:integer;
        ok:boolean;
    begin
      if p>nk then begin
        if (ncst=cst)and(conex) then begin
          inc(ns);
          if ns=1 then move(used, tsol, sizeof(used)) else
          for i:=1 to m do tsol[i]:=tsol[i] and used[i];
        end;
      end else begin
        for i:=sol[p-1]+1 to m-nk+p do if used[i]=0 then begin
          used[i]:=1;
          sol[p]:=i;
          inc(ncst,mc[i].c);
          ok:=true;
          if ncst>cst then ok:=false;
          if ncst+(nk-p)*mnn>cst then ok:=false;
          if ncst+(nk-p)*mxx<cst then ok:=false;
          if ok then
            bktr(p+1);
          used[i]:=0;
          dec(ncst, mc[i].c);
        end;
      end;
    end;

    procedure Solve;
    var i,j,ii,jj,mn,nc,sl:integer;
    begin
      QSort(1,m);
      for i:=1 to n do tata[i]:=i;
      mn:=1; cst:=0;  mxx:=0; mnn:=maxlongint;
      for i:=1 to n-1 do begin
        while tata[mc[mn].x]=tata[mc[mn].y] do inc(mn);
        chosen[i]:=mn;
        if mc[mn].c>mxx then mxx:=mc[mn].c;
        if mc[mn].c<mnn then mnn:=mc[mn].c;
        inc(cst,mc[mn].c);
        ii:=tata[mc[mn].x]; jj:=tata[mc[mn].y];
        for j:=1 to n do if tata[j]=jj then tata[j]:=ii;
      end;
    end;

    procedure GenGraph(s:string;n,m,dm:integer);
    var i,j,x,y:integer;
    begin
      randomize;
      fillchar(mat, sizeof(mat),0);
      assign(f,s); rewrite(f);
      writeln(f,n,' ',m);
      for i:=1 to n-1 do begin
        mat[i,i+1]:=1; mat[i+1,i]:=1;
        writeln(f,i,' ',i+1,' ',random(dm)+1);
      end;
      for i:=n to m do begin
        repeat
          x:=random(n)+1; y:=random(n)+1;
        until (x<>y)and(mat[x,y]=0);
        mat[x,y]:=1; mat[y,x]:=1;
        writeln(f,x,' ',y,' ',random(dm)+1);
      end;
      close(f);
    end;

begin
  assign(f,'vitale.in'); reset(f);
  readln(f,n,m);
  for i:=1 to m do readln(f,mc[i].x,mc[i].y,mc[i].c);
  close(f);
  Solve;
  assign(g,'vitale.out'); rewrite(g);
  nk:=n-1; ncst:=0; fillchar(sol, sizeof(sol), 0);
  fillchar(used, sizeof(used), 0);
  fillchar(tsol,sizeof(tsol),0);
  for i:=1 to n do tsol[i]:=1; ns:=0;
  bktr(1);
  nd:=0;
  for i:=1 to n do if tsol[i]=1 then begin
    inc(nd);
    sl[nd]:=mc[i];
  end;
  for i:=1 to nd do begin
    if sl[i].x>sl[i].y then begin
      ns:=sl[i].x; sl[i].x:=sl[i].y; sl[i].y:=ns;
    end;
  end;
  QSortMC(1,nd);
  writeln(g,nd);
  for i:=1 to nd do writeln(g,sl[i].x,' ',sl[i].y);
  close(g);
end.