#include <cstdio>
#include <cstring>
#include <ctime>
using namespace std;

const int nmax=1001;

short mat[ nmax ][ nmax ];
int m,n;

void read() {	
	FILE *fin=fopen ("matrice.in","r");
	fscanf (fin,"%d %d\n",&m,&n);
	int i;
	for (i=0; i <m; ++i) {
		char s[ 10000 ];
		fgets(s,10000,fin);
		int j,ll,x=0;
		bool minus=0;
		int count=0;
		ll=strlen(s);
		for (j=0; j <ll; ++j) {
			if (s[ j ]=='-') {minus=1;continue;}
			if (s[ j ]>='0' && s[j]<='9') x=x*10 + s[ j ]-'0';
			else {
				if (minus) x=-x;
				mat[ i ][ count++ ]=x;
				x=0;
				minus=0;
			}
		}
		if (count+1 < n) {
			if (minus) x=-x;
			mat[ i ][ count++ ]=x;
		}
	}
	fclose(fin);
}

int best[ nmax ][ nmax ]; //best[ i ]=lungimea celui mai lung sir
			//care se termina la i 
				
void build() {
	int i;
	for (i=0; i < m; ++i) {
		int l=0,c;
		bool cresc=0;
		if (mat[ i ][ 1 ] > mat[ i ][ 0 ]) {cresc=1;c=2;}
		else c=2;
		best[ i ][ 0 ]=1;
		best[ i ][ 1 ]=2;
		int j;
		for (j=2; j < n; ++j) {
			if (mat[ i ][ j ] < mat[ i ][ j-1 ]) {
				if (cresc) {l=c-1;c=2;cresc=0;}
				else c++;
			}
			else {
				if (cresc) c++;
				else {l=c-1;c=2;cresc=1;}
			}
			best[ i ][ j ]=l+c;
		}
	}
}


void debug() {
	int i,j;
	printf ("Matricea:\n");
	for (i=0; i < m; ++i,printf ("\n"))
		for (j=0; j < n; ++j)
			printf ("%d ",mat[ i ][ j ]);
	printf ("Best:\n");
	for (i=0; i < m; ++i,printf ("\n"))
		for (j=0; j < n; ++j)
			printf ("%d ",best[ i ][ j]);
}

int sol=-1,l1,l2,c1,c2;

const double lim=0.9;

void brute() {
	int i,j,k;
	clock_t aa,bb;
	aa=clock();
	for (i=0; i < m; ++i) {
		bb=clock();
		double elp=(double)(bb-aa)/CLOCKS_PER_SEC;
		if (elp > lim) return;
		for ( j=0; j < n; ++j) {
			int mn=best[ i ][ j ];
			if (mn > sol) {sol=mn;l1=l2=i; c2=j; c1=c2-mn+1;}
			for (k=i-1; k >=0; --k) {
				if (best[ k ][ j ] < mn) mn=best[ k ][ j ];
				if (mn *(i-k+1) >= sol) {
					sol=mn *(i-k+1); l1=k;
					l2=i;
					c1=j-mn+1;
					c2=j;
				}
			}
		}
	}
}
	

int main() {
	FILE *fout=fopen ("matrice.out","w");
	read();
	build();
	brute();
	fprintf (fout,"%d %d %d %d\n",l1+1,c1+1,l2+1,c2+1);
	fclose(fout);
	return 0;
}



					
	
