# include <stdio.h>
# include <string.h>

# define _fin  "ratina.in"
# define _fout "ratina.out"

# define maxn  10002  	// 10002
# define maxl  2002   	// 2002
# define maxt  12

# define sigma 26


char *c[maxn];	// cuvintele -> lungime variabila = 0.2M
int l[maxn], o[maxn], no[maxn], g[maxn];
int m, n;


void readf()
{
	int i;
	char bufr[maxl];

# define strip(a) ( a[ strlen(a)-1 ] = '\0' )

	for(scanf("%d %d\n", &n, &m), i=0; i<n; i++)
	{
	    gets(bufr);//, strip(bufr);
	    c[i] = new char [ strlen(bufr)+1 ];
	    strcpy(c[i], bufr), l[i] = strlen(c[i]);
	    o[i] = i;
	}
}

int qs_poz(int st, int dr)
{
    char aux[maxl];
    strcpy(aux, c[st]);

    while ( st < dr )
    {
	while ( st < dr && strcmp(c[dr], aux) >= 0 ) dr--;
	if ( st != dr )
	    strcpy(c[st], c[dr]), o[st] ^= o[dr] ^= o[st] ^= o[dr];
	while ( st < dr && strcmp(c[st], aux) <= 0 ) st++;
	if ( st != dr )
	    strcpy(c[dr], c[st]), o[st] ^= o[dr] ^= o[st] ^= o[dr];
    }

    strcpy(c[st], aux);
    return st;
}

void qs_norm(int st, int dr)
{
    int m = qs_poz(st, dr);
    if ( st < m ) qs_norm(st, m-1);
    if ( m < dr ) qs_norm(m+1, dr);
}

inline int min(int a, int b) { return a < b ? a : b; }

void solve()
{
    int i, j, k, smin, itr[maxt], t;
    for(i=0; i<n; i++)
	no[ o[i] ] = i;

    memcpy(o, no, sizeof(no));

    for(i=0; i<n-1; i++)
    {
	// grad de asemanare intre i si i+1
	smin = min(strlen(c[i]), strlen(c[i+1]));

	for(j=0; j<=smin && c[i][j] == c[i+1][j]; j++);

	g[i] = j;
    }

    for(i=0; i<m; i++)
    {
	for(scanf("%d", &t), j=1; j<=t; j++)
	    scanf("%d", itr+j), --itr[j];

	// sortam in ordine alfabetica
	for(j=1; j<t; j++)
		for(k=j+1; k<=t; k++)
			if ( o[ itr[j] ] > o[ itr[k] ] )
			     itr[k] ^= itr[j] ^= itr[k] ^= itr[j];

	if ( itr[1] == itr[t] )		// acelasi cuvant intr-un lant
	    printf("%d\n", strlen( c[ o[itr[1]] ] ) );

	else if ( c[ o[itr[1]] ][0] != c[ o[itr[t]] ][0] )
	    printf("%d\n", 0);

	else
	{
	    smin=maxl;
	    for(j=o[ itr[1] ]; j != o[ itr[t] ]; j++)	// parcurgem toate cuvintele
		smin = min(smin, g[j] );

	    printf("%d\n", smin);
	}
    }
}

int main()
{
	freopen(_fin, "r", stdin);
	freopen(_fout,"w", stdout);

	readf();
	qs_norm(0, n-1);
	solve();

	fclose(stdin);
	fclose(stdout);

	return 0;
}