#include<stdio.h>

#include<algorithm>
using namespace std;

#define MAX(x,y) ((x)>(y)?(x):(y))
#define MIN(x,y) ((x)<(y)?(x):(y))

#define oo 2000000

#define MAXN 402
#define MAXK 302

struct sv
{
   int val;
   int ix;
   const bool operator < (const sv &b) const
   {
      return val==b.val ? ix<b.ix : val<b.val;
   }
} op[MAXN];

int d[MAXN][MAXK];
int b[MAXN][MAXK];
int dis[MAXN];
int n, k;

int sol[MAXN], sn;

int main(void)
{
   freopen("petrom.in", "rt", stdin);
   freopen("petrom.out", "wt", stdout);

   int i, j, l;
   int xv;

   scanf("%d%d", &n, &k);
   for (int i=1; i<=n; ++i)
   {
      scanf("%d", &xv);
//      dis[i] = xv;
      op[i].ix = i; op[i].val = xv;
//      scanf("%d", &dis[i]);
   }
   sort(&op[1], &op[n+1]);
   for (int i=1; i<=n; ++i)
      dis[i] = op[i].val;

   d[1][1] = 0; dis[n+1] = oo; dis[0] = -oo;
   for (i=1; i<=n+1; ++i) d[i][0] = oo;

   int t=0, q=0;

   for (i=2; i<=n+1; ++i)
   {
      int maxj = MIN(i, k+1);
      for (j=1; j<=maxj; ++j)
      {
         d[i][j] = oo;
         t = 0; q=i-1;
         for (l=i-1; l>=0; --l)
         {
            t += (q-l) * (dis[l+1]-dis[l]);
            while (q>l && dis[i]-dis[q] <= dis[q]-dis[l])
            {
               t -= dis[q]-dis[l];
               t += dis[i]-dis[q];
               --q;
            }

            if (d[l][j-1]+t < d[i][j])
            {
               d[i][j] = d[l][j-1]+t;
               b[i][j] = l;
            }
         }
      }
   }

   printf("%d\n", d[n+1][k+1]);

   int x=n+1, y=k+1;
   while (b[x][y] != 0)
   {
      sol[sn++] = op[b[x][y]].ix;
      x = b[x][y];
      y--;
   }
   sort(&sol[0], &sol[sn]);

   for (i=0; i<sn; ++i)
      printf("%d\n", sol[i]);
      
   fclose(stdin);
   fclose(stdout);
   return 0;
}

