#include <stdio.h>

short int cost[400][400];
short int mate[400];
short int cnt[400];
int used; //how much D1-D2 is used

int n, k;

FILE *in, *out;

int d[400];

struct elem {
	short int a;
	short int b;
};

char have[400][400];

struct elem dist[160000];

int compare (const struct elem *a, const struct elem *b) {
	return cost[a->a][a->b] - cost[b->a][b->b];
}

int main () {
	int i, j, l;
	int tcost = 0;
	
	in = fopen ("petrom.in", "r");
	out = fopen ("petrom.out", "w");

	fscanf (in, "%d %d", &n, &k);
	for (i=0;i<n;i++) {
		fscanf (in, "%d", &d[i]);
	}
	for (i=0;i<n;i++) {
		for (j=i+1;j<n;j++) {
			cost[i][j] = cost[j][i] = d[j] - d[i];
		}
	}

/*	for (i=0;i<n;i++) {
		for (j=0;j<n;j++) {
			printf ("%3d", cost[i][j]);
		}
		printf ("\n");
	}*/

	for (i=0,l=0;i<n;i++) {
		for (j=0;j<n;j++,l++) {
			dist[l].a = i;
			dist[l].b = j;
		}
	}
	qsort (dist, n*n, sizeof (struct elem), \
		(int (*)(const void *,const void *)) compare);
/*	for (i=0;i<n*n;i++) {
		printf ("%d ", cost[dist[i].a][dist[i].b]);
	}
	printf ("\n");*/
	memset (mate, 0xFF, n*sizeof (short int));

	used = 0;
	for (i=0;i<n;) {
		for (j=0;j<n*n;j++) {
			if ((used < k || \
				(mate[dist[j].a] != -1 && cnt[mate[dist[j].a]] == 1) || \
				(cnt[dist[j].b] > 0)) && \
				have[dist[j].a][dist[j].b] == 0) {
				if (mate[dist[j].a] != -1) {
					cnt[mate[dist[j].a]]--;
					if (cnt[mate[dist[j].a]] == 0) used--;
					else if (cost[mate[dist[j].a]][dist[j].a] < cost[dist[j].a][dist[j].b]) continue;
				}
				else i++;
				have[dist[j].a][dist[j].b] = 1;
				mate[dist[j].a] = dist[j].b;
				if (cnt[dist[j].b] == 0) used++;
				cnt[dist[j].b]++;
				break;
			}
		}
	}

	for (i=0;i<n;i++) {
		tcost += cost[i][mate[i]];
	}
	fprintf (out, "%d\n", tcost);
	for (i=0;i<n;i++) {
		if (cnt[i] > 0) fprintf (out, "%d\n", i+1);
	}

	fclose (in);
	fclose (out);
	
	return 0;
}
