#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>
#define intrare "petrom.in"
#define iesire "petrom.out"
#define PlusInfinit 10000000
FILE *fin,*fout;
int n,k,d[500],dmin[500],used[500],sol[500],costmin=PlusInfinit;

int min(int x, int y)
  {return (x<y)?x:y;}

int distanta(int start, int end)
  {return d[end]-d[start];}
  
double timp(clock_t start, clock_t end)
  {return ((double)(end-start))/CLOCKS_PER_SEC;}

int costul(int poz)
  {int poz1,poz2,c1=-1,c2=-1;
   poz1=poz-1;
   while(poz1>=1 && !used[poz1])
        poz1--;
   poz2=poz+1;
   while(poz2<=n && !used[poz2])
        poz2++;
   if(poz1>=1)
     c1=distanta(poz1,poz);
   if(poz2<=n)
     c2=distanta(poz,poz2);
   return min(c1,c2);}


int main()
{
int i;
clock_t start,end;
srand(time(0));
start=clock();
fin=fopen(intrare,"r");
fout=fopen(iesire,"w");
fscanf(fin,"%d %d",&n,&k);
d[0]=0;
for(i=1;i<=n;i++)
   fscanf(fin,"%d",&d[i]);
dmin[1]=d[2]-d[1];
dmin[n]=distanta(n-1,n);
for(i=2;i<=n-1;i++)
   dmin[i]=min( distanta(i-1,i), distanta(i,i+1) );
if(k>=n)
  {fprintf(fout,"0\n");
   for(i=1;i<=n;i++)
      fprintf(fout,"%d\n",i);
   fclose(fout);
   exit(0);}
if(k==n-1)
  {int minim=dmin[1],poz=1;
   for(i=2;i<=n;i++)
      {minim=min(minim,dmin[i]);
       if(minim==dmin[i])
         poz=i;}
   fprintf(fout,"%d\n",minim);
   for(i=1;i<=n;i++)
      if(i!=poz)
        fprintf(fout,"%d\n",i);
   fclose(fout);
   exit(0);}
end=clock();
while(timp(start,end)<0.18)
  {for(i=1;i<=n;i++)
      used[i]=0;
   i=0;
   while(i<k)
       {int poz=rand()%n+1;
        if(!used[poz])
          {used[poz]=1;
           i++;}}
   int cost=0;
   for(i=1;i<=n;i++)
      if(!used[i])
        {int cost2=costul(i);
         if(cost2!=-1)
      cost+=cost2;}
   if(costmin>cost)
     {costmin=cost;
      memcpy(sol,used,(n+1)*sizeof(int));}
   end=clock();}
fprintf(fout,"%d\n",costmin);
for(i=1;i<=n;i++)
   if(sol[i])
     fprintf(fout,"%d\n",i);
fclose(fin);fclose(fout);
return 0;
}
