#include <stdio.h>

#define MAXN 150
#define max(a,b) ((a) > (b) ? (a) : (b))

int N, M, best;
int A[MAXN][MAXN], L1, L2, C1, C2;
char ok[MAXN][MAXN][MAXN];

void preproc(void)
{
	int l, c1, c2, c, w, sgn;

	for(l = 1; l <= N; l++)
	 for(c1 = 1; c1 <= M; c1++)
	 {
		ok[l][c1][c1] = 1;
		for(c2 = c1+1; c2 <= M; c2++)
		{
			w = 0, c = c1;
			if(A[l][c] > A[l][c+1])
				sgn = 1;
			else
				sgn = 0;
			while(1)
			{
				if(sgn == 0) // crescator
				{
					while(A[l][c] < A[l][c+1] && c < c2)
						c++;
					c++, sgn = 1;
				}
				else // descrescator
				{
					while(A[l][c] > A[l][c+1] && c < c2)
						c++;
					c++, sgn = 0;
				}
				if(c > c2) break;
				w++;
				if(w >= 2) break;
			}
			if(w < 2)
				ok[l][c1][c2] = 1;
            else
			{
				for(c = c2; c <= M; c++)
					ok[l][c1][c] = 0;
				c2 = M+1;
			}
		}
     }
}

void solve(void)
{
	int l1, l2, c1, c2;

	for(l1 = 1; l1 <= N; l1++)
	 for(c1 = 1; c1 <= M; c1++)
     {
	 	for(c2 = c1; c2 <= M; c2++)
		{
			l2 = l1;
			while(ok[l2][c1][c2])
				l2++;
            if(best < (l2-l1)*(c2-c1+1))
            {
				best = (l2-l1)*(c2-c1+1);
				L1 = l1, L2 = l2-1, C1 = c1, C2 = c2;
            }
        }
     }
}

void read_data(void)
{
	int i, j;

	scanf("%d %d\n", &N, &M);

	for(i = 1; i <= N; i++)
	 for(j = 1; j <= M; j++)
	 	scanf("%d", &A[i][j]);
}

void write_data(void)
{
	printf("%d %d %d %d\n", L1, C1, L2, C2);
}

int main(void)
{
	freopen("matrice.in", "rt", stdin);
	freopen("matrice.out", "wt", stdout);

	read_data();
	preproc();
	solve();
	write_data();

	return 0;
}




				




	  
