#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#define LMAX 200010
#define KMAX 2048
#define LOG 20
#define NMAX 10000

void read(void);
void solve(void);
int cmp(const void *a, const void *b);
int lcp(int x, int y);

int N, M, lim, pos[LMAX], bck[LMAX], prm[LMAX], A[LOG][LMAX], seen[LMAX],
	c_bck, nr[LMAX], wh[NMAX], v[16], lenght[NMAX];

char S[LMAX], tmp[KMAX];

int main(void)
{
	freopen("ratina.in", "r", stdin);
     freopen("ratina.out", "w", stdout);

     read();
	return 0;
}

void read(void)
{
	int j = 0, k, i, rez, t;
     
	scanf("%d %d ", &N, &M);
     for(i = 0; i < N; i++)
     {
     	scanf("%s ", tmp);
          k = strlen(tmp);
          wh[i] = j;
          lenght[i] = k;
          memcpy(S + j, tmp, k * sizeof(char));
          j += k;
     }
      lim = j;
      solve();
       for(; M--;)
      {
      	scanf("%d ", &t);
          for(i = 0; i < t; i++)
          	scanf("%d ", &v[i]);
          rez = lenght[v[0] - 1];
          for(i = 0; i < t - 1; i++)
		{
          	if(lenght[v[i + 1] - 1] < rez)
               	rez = lenght[v[i + 1] - 1];
          	k = lcp(wh[v[i] - 1], wh[v[i + 1] - 1]);
               if(k < rez)
               	rez = k;
          }
          printf("%d\n", rez);
      }
}

void solve(void)
{
	int h, i, k;

     for(i = 0; i < lim; i++)
     pos[i] = i;
	qsort(pos, lim, sizeof(int), cmp);
     seen[0] = 1;
	for(i = 1; i < lim; i++)
     if(S[pos[i]] != S[pos[i - 1]])
     	seen[i] = 1;
     for(h = 1, k = 0; h <= lim; h <<= 1, k++)
     {
     	for(i = 0; i < lim; i++)
          {
          	if(seen[i])
               	nr[c_bck = i] = 0;
			bck[pos[i]] = c_bck;
          }
		for(i = 0; i < lim; i++)
          if(pos[i] < h)
          {
          	const int d = pos[i] - h + lim;
               const int e = bck[d];

               prm[d] = bck[d] + (nr[e]++);
               seen[bck[d] + nr[e] - 1] = 1;
          }
          for(i = 0; i < lim; i++)
          if(pos[i] >= h)
          {
          	const int d = pos[i] - h;
               const int e = bck[d];

               prm[d] = bck[d] + (nr[e]++);
          }
		for(i = 0; i < lim; i++)
          	pos[prm[i]] = i;
          for(i = 0; i < lim; i++)
          if(!seen[i])
          {
          	const int d = pos[i] + h;
               const int e = pos[i - 1] + h;

               if(bck[d] != bck[e])
               	seen[i] = 1;
          }
          
          memcpy(A[k], bck, lim * sizeof(int));
     }
     memcpy(A[k], bck, lim * sizeof(int));
     
}

int cmp(const void *a, const void *b)
{
	if(S[(*(int *)a)] < S[(*(int *)b)])
     	return -1;
          return 1;
}

int lcp(int x, int y)
{
	int d = 0, i, j, k;

     i = x, j = y;

     for(k = 0; (1 << k) <= lim; k++);
	for(--k; k >= 0; k--)
     if(A[k][i] == A[k][j])
     	i += 1 << k, j += 1 << k, d += 1 << k;
          
     return d;
}
