#include <stdlib.h>
#include <stdio.h>
#define INF 99999999
int n,m,d[401],ndr,dst,dr,st,x[401][401],nst,ndr,v[401][401],q[401];
struct evaluation{
	int st,dr,nst,ndr,val;
} eval[401][401];
void cit()
{
    int i;
	FILE *f=fopen("petrom.in","r");
    fscanf(f,"%d %d",&n,&m);
    for(i=1;i<=n;i++)
        {
        	fscanf(f,"%d",&d[i]);
            dr+=d[i];
        }
    ndr=n-1;
    fclose(f);
}
void makeeval()
{
    int i,j;
	for(i=1;i<=n-2;i++)
    for(j=2;i+j<=n;j++)
    {
    	eval[i][i+j]=eval[i][i+j-1];
        eval[i][i+j].ndr++;
        eval[i][i+j].dr+=eval[i][i+j].ndr*(d[i+j]-d[i+j-1]);
        eval[i][i+j].val=eval[i][i+j].dr+eval[i][i+j].st;
        while(eval[i][i+j].val - ( d[i+j]-d[i+j-eval[i][i+j].ndr]) + ( d[i+j-eval[i][i+j].ndr] - d[i]) <=eval[i][i+j].val )
        {
            eval[i][i+j].dr-=d[i+j]-d[i+j-eval[i][i+j].ndr];
            eval[i][i+j].st+=d[i+j-eval[i][i+j].ndr] - d[i];
    		eval[i][i+j].ndr--;
            eval[i][i+j].nst++;
	        eval[i][i+j].val=eval[i][i+j].dr+eval[i][i+j].st;
        }
    }
}
void makex1()
{
    int i;
    dr=dr-(ndr+1)*d[1];
	x[1][1]=0;
    nst++;
    ndr--;
    st=st+nst*(d[2]-d[1]);
    dr=dr-(ndr+1)*(d[2]-d[1]);
	for(i=2;i<=n;i++)
    {
        x[i][1]=st;
        ndr--;
        nst++;
	    st=st+    nst*(d[i+1]-d[i]);
    	dr=dr-(ndr+1)*(d[i+1]-d[i]);
    }
}
void solve(int i, int j)
{
    int a,b,m,m2,mm;
    a=j;
    b=i-1;
    do
	{
    	m=(a+b)/2;
        mm=x[m][j-1]+eval[m][i].val;
        m2=x[m+1][j-1]+eval[m+1][i].val;
        if (m2>mm) b=m;
        else a=m;
        if (m2<mm)mm=m2,m++;
    }
	while (a+1<b);
    x[i][j]=mm;
    v[i][j]=m;
}
static int cmp ( const void *a, const void *b)
{
	int * aa= (int*)a;
    int * bb= (int*)b;
    return *aa-*bb;
}
void rez()
{
    int j,i;
    qsort(d+1,n,sizeof(d[0]),cmp);
	makeeval();
    makex1();
    for(j=2;j<=m;j++)
    for(i=j;i<=n;i++)
					solve(i,j);
}
void makesol(int n, int m)
{
	q[m]=n;
    if (m!=1) makesol(v[n][m],m-1);
}
void finishsol()
{
    int i;
    ndr=1;
    dr=d[n]-d[n-1];
	for(i=n-1;i>=m;i--)
    {
    	x[i][m]+=dr;
        ndr++;
		dr+=ndr*(d[i+1]-d[i]);
    }
}
void scr()
{
    int i,j,mini,minj,min=INF;
	FILE *f=fopen("petrom.out","w");
    finishsol();
    for(i=m;i<=n;i++)
    {
    	if (x[i][m]<min)
        {
        	min=x[i][m];
            mini=i;
            minj=m;
        }
    }

    fprintf(f,"%d\n",x[mini][minj]);
    makesol(mini,minj);
    for(i=1;i<=m;i++)
    	fprintf(f,"%d\n",q[i]);
    fclose(f);
}
int main (void)
{
	cit();
    rez();
    scr();
	return 0;
}
