#include<stdio.h>
#define N 41
#define K 31
#define MAX 30001*15000

int n,P,a[N],s[30010],t[K][N];

long d[K][N],dd[N][N],q[N][N];

void READ()
{
   FILE *f;

   int i,j;

   f=fopen("petrom.in","r");

   fscanf(f,"%d %d",&n,&P);

   for(i=1;i<=n;i++)
     fscanf(f,"%d",&a[i]);

   fclose(f);
}


void SOLVE()
{
   int i,j,k;

   for(i=1;i<=P;i++)
     for(j=1;j<=n;j++)
       d[i][j]=MAX;

   for(i=1;i<=n;i++)
   {
      d[1][i]=dd[i][1];
   }

   for(k=2;k<=P;k++)

     for(i=k;i<=n;i++)
	for(j=i-1;j>=1;j--)

	    if(d[k][i]>d[k-1][j]+ q[j][i] )

	      {	 d[k][i]=d[k-1][j]+q[j][i];
		 t[k][i]=j;
	      }


}


void PRINT()
{
  FILE *g;
  g=fopen("petrom.out","w");

  int i,ii;
  long min=MAX;

  for(i=P;i<=n;i++)
  {
    if(d[P][i]+dd[i][n] <min) { min=d[P][i]+dd[i][n]; ii=i; }
  }


  fprintf(g,"%ld\n",min);

  for(i=P;i>0;i--)
  {   a[i]=ii;
      ii=t[i][ii];
  }
  for(i=1;i<=P;i++)
    fprintf(g,"%d\n",a[i] );



  fclose(g);
}

void DISTANTA()
{

   int i,j,k;

   for(i=1;i<=n-1;i++)
   {
     dd[i][i]=0;
     for(j=i+1;j<=n;j++)
       dd[i][j]=dd[i][j-1]*2+a[j]-a[j-1];
   }
   for(i=n;i>=2;i--)
   {
      dd[i][j]=0;
      for(j=i-1;j>=1;j--)
	dd[i][j]=dd[i][j+1]*2+a[j+1]-a[j];
   }
   k=0;
   for(i=a[1];i<=a[n];i++)
   {  if(i==a[k+1])  k++;
       s[i]=k;
   }


   for(i=1;i<=n-1;i++)
     q[i][i+1]=0;

   for(i=1;i<=n;i++)
     for(j=i+1;j<=n;j++)
     {
       k=(a[i]+a[j])/2;
       k=s[k];
       q[i][j]=dd[i][k]+dd[j][k+1];
     }

}

int main()
{
  READ();

  DISTANTA();

  SOLVE();

  PRINT();

  return 0;
}