#include <stdio.h>
#include <string.h>
#define Nmax 402
int n, m, v[Nmax], c[Nmax][Nmax], d[Nmax][Nmax], f[Nmax][Nmax], min, sol[Nmax];
FILE *fi, *fo;

void read_data()
{
	int i;
	fscanf(fi, "%d %d", &n, &m);
	for (i = 1; i <= n; ++i)
		fscanf(fi, "%d",&v[i]);
}

void precalc()
{
	int i, j, k;
	for (i = 0; i < n; ++i)
		for (j = i + 2; j <= n; ++j)
			for (k = i + 1; k < j; ++k)
				if (v[k] - v[i] < v[j] - v[k] && i)
					c[i][j] += v[k] - v[i];
				else
					c[i][j] += v[j] - v[k];
	for (i = 1; i < n; ++i)
		for (j = i + 1; j <= n; ++j)
			c[i][n + 1] += v[j] - v[i];
}

void solve()
{
	int i, j, k;
	for (i = 1; i <= n; ++i)
		d[i][1] = c[0][i];
	for (i = 2; i <= n; ++i)
		for (j = 2; j <= m; ++j)
		{
			d[i][j] = 0x3f3f3f3f;
			for (k = i - 1; k; --k)
			{
				if (d[k][j - 1] + c[k][i] < d[i][j])
					d[i][j] = d[k][j - 1] + c[k][i],
					f[i][j] = k;
			}
		}
	min = 0x3f3f3f3f;
	for (i = 1; i <= n; ++i)
		if (d[i][m] + c[i][n + 1] < min)
			min = d[i][m] + c[i][n + 1], k = i;
	fprintf(fo, "%d\n",min);
	for (j = m; k; k = f[k][j], --j)
		sol[++sol[0]] = k;
	for (i = sol[0]; i; --i)
		fprintf(fo, "%d\n",sol[i]);
}

int main()
{
	fi = fopen("petrom.in","r");
	fo = fopen("petrom.out","w");
	read_data();
	precalc();
	solve();
	fclose(fi);
	fclose(fo);
	return 0;
}
