#include <stdio.h>
#include <iostream.h>
#define Infile "petrom.in"
#define Outfile "petrom.out"
#define DIM 400
#define _INF 32000

long int n, k;
long int d[DIM], dist[DIM][DIM];
long int sol[DIM], nr;
long int cost[DIM], sel[DIM], c[DIM];
long int maxdist, pos, s, sum;

void Read();
void Solve();
void Write();

int main()
{
	Read();
	Solve();
	Write();

	return 0;
}

void Read()
{
	freopen(Infile,"r",stdin);

	scanf("%d%d",&n,&k);

	long int i;
	for ( i = 1; i <= n; i++ )
		scanf("%ld",&d[i]);
        
    fclose(stdin);
}

void Solve()
{
	int i, j, ok;

	for ( i = 1; i < n; i++ )
		for ( j = i + 1; j <= n; j++ )
		{
			dist[i][j] = dist[j][i] = d[j] - d[i];
			dist[i][i] = 0;
		}
	dist[n][n] = 0;


	maxdist = -1;
	for ( i = 1; i <= n / 2; i++ )
	{
		if ( maxdist <= dist[i][1] + dist[i][n] )
		{
			maxdist = dist[i][1] + dist[i][n];
			pos = i;
		}
		if ( maxdist <= dist[n-i+1][1] + dist[n-i+1][n] )
		{
			maxdist = dist[n-i+1][1] + dist[n-i+1][n];
			pos = n - i + 1;
		}
	}
	if ( maxdist <= dist[n/2+1][1] + dist[n/2+1][n] )
	{
		maxdist = dist[n/2][1] + dist[n/2][n];
		pos = n / 2 + 1;
	}

	for ( i = 1; i <= n; i++ )
	{
		cost[i] = dist[pos][i];
		c[i] = cost[i];
		s += cost[i];
	}

	nr++;
	sol[nr] = pos;
	sel[pos] = 1;
	k--;
	while ( k )
	{

		for ( j = 1; j <= n; j++ )
			if ( sel[j] == 0  )
			{
				for ( i = 1; i <= n; i++ )
					c[i] = cost[i];
				sum = 0;
				for ( i = 1; i <= n; i++ )
				{
					if ( c[i] > dist[i][j] ) c[i] = dist[j][i];
					sum += c[i];
				}

				if ( sum < s )
					for ( i = 1; i <= n; i++ )
					{
						cost[i] = c[i];
						sel[j] = 1;
						sum = s;
					}


			}
		k--;
	}
}

void Write()
{
	freopen(Outfile,"w",stdout);


	printf("%s ",sum);

	fclose(stdout);
}


