#include <stdio.h>
#include <string.h>
#define Infile "ratina.in"
#define Outfile "ratina.out"
#define DIM 10002
#define DIM2 2001

char a[DIM][DIM2];
int l[DIM][DIM2];
long int n, m, t;

void Solve();

int main()
{
    freopen(Infile,"r",stdin);
    freopen(Outfile,"w",stdout);

    scanf("%ld%ld",&n,&m);

    long int i, value, min, inter, x, y;
    for ( i = 1; i <= n; i++ )
        scanf("%s",&a[i]);
    
    Solve();

    for ( inter = 1; inter <= m; inter++ )
    {
        scanf("%ld",&t);
        scanf("%ld%ld",&x,&y);
        value = x;
        min = l[x][y];

        for ( i = 3; i <= t; i++ )
        {
            scanf("%ld",&x);
            if ( l[value][x] < min )
            {
                min = l[value][x];
                value = x;
            }
            if ( min == 0 ) break;
        }

        printf("%ld\n",min);
    }

    printf("\n");


    fclose(stdin);
    fclose(stdout);
    return 0;
}

void Solve()
{
    long int i, j, k, nr;

    for ( i = 1; i <= n; i++ )
    {
        nr = k = 0;
        while ( 'a' <= a[i][k] && a[i][k] <= 'z' )
        {
            nr++;
            k++;
        }

        l[i][i] = nr;
    }

    for ( i = 1; i < n; i++ )
        for ( j = i + 1; j <= n; j++ )
        {
            k = nr = 0;
            while ( 'a' <= a[i][k] && a[i][k] <= 'z' && 'a' <= a[j][k] && a[j][k] <= 'z' )
            {
                if ( a[i][k] == a[j][k] ) nr++;
                else break;
                k++;
            }

            l[i][j] = l[j][i] = nr;
        }
}


