#include <stdio.h>
#include <string.h>
#define nmax 211111
#define lmax 10111
#define pt(i) (1<<(i))

int lab[19][nmax],start[lmax],p[nmax],n,m,sum,H,L,M,count[nmax],r[nmax],sol;
char s[nmax];

int MIN(int i,int j)
{
  return(i>j?j:i);
}

void radix(int z)
{
  int i;
  memset(count,0,sizeof(count));
  for(i=1;i<=n;++i)
    count[lab[z][i]]++;
  for(i=1;i<=M;++i)
    count[i]+=count[i-1];
  for(i=n;i;--i)
    r[count[lab[z][p[i]]]--]=p[i];
  memcpy(p,r,sizeof(r));
}

void relab(int z)
{
  int i,x,y;
  for(x=lab[z][p[1]],lab[z][p[1]]=1,i=2;i<=n;++i)
  {
    y=lab[z][p[i]];
    lab[z][p[i]]=lab[z][p[i-1]]+(x==y&&lab[z-1][p[i]]==lab[z-1][p[i-1]]?0:1);
    x=y;
  }
  M=lab[z][p[n]];
}

void relab1()
{
  int i,x,y;
  for(x=lab[0][p[1]],lab[0][p[1]]=1,i=2;i<=n;++i)
  {
    y=lab[0][p[i]];
    lab[0][p[i]]=lab[0][p[i-1]]+(x==y?0:1);
    x=y;
  }
  M=lab[0][p[n]];
}

int lcp(int i,int j,int L)
{
  if(!L)
    return(lab[0][i]==lab[0][j]);
  if(lab[L][i]==lab[L][j])
    return(pt(L)+lcp(i+pt(L),j+pt(L),L-1));
  else
    return(lcp(i,j,L-1));
}

int main()
{
  FILE *fi=fopen("ratina.in","r"),*fo=fopen("ratina.out","w");  
  int i,ii,x,t,y;
  fscanf(fi,"%d %d",&n,&m);
  for(sum=i=1;i<=n;++i)
  {
    start[i]=sum;
    fscanf(fi,"%s",s+sum);    
    sum+=strlen(s+sum);
    s[sum++]='z'+1;
  }
  start[n+1]=sum;
  n=--sum;
  s[n]='z'+2;
  for(i=1;i<=n;++i)
    lab[0][i]=s[i]-'a'+1,p[i]=i;
  M='z'-'a'+3;
  radix(0);
  relab1();
  for(L=1,H=1;H<(n>>1)&&M<n;H<<=1,L++)
  {
    for(i=1;i<=n;++i)
      lab[L][i]=lab[L-1][(i+H)>n?i+H-n:i+H];
    radix(L), radix(L-1);
    relab(L);
  }
  for(ii=1;ii<=m;++ii)
  {
    fscanf(fi,"%d %d",&t,&x);
    for(sol=start[x+1]-start[x]-1,i=2;i<=t;++i)
    {
      fscanf(fi,"%d",&y);
      sol=MIN(sol,start[y+1]-start[y]-1);
      if(start[x]!=start[y])
        sol=MIN(sol,lcp(start[x],start[y],L-1));
    }
    fprintf(fo,"%d\n",sol);
  }
  fclose(fi);
  fclose(fo);  
  return(0);
}
