#include <stdio.h>
#include <string.h>

#define FIN "matrice.in"
#define FOUT "matrice.out"

#define MAX_N 1024

int N, M, ans, min_line, max_line, min_col, max_col;
int A[MAX_N][MAX_N], P[MAX_N][MAX_N];
char line[100000];

void read()
{
	int i, j;
	FILE *fi = fopen(FIN, "r");
	char *p;
	fscanf(fi, "%d %d\n", &N, &M);
	for (i = 1; i <= N; ++i) {
		fgets(line, sizeof(line), fi), p = line;
		for (j = 1; j <= M; ++j) {
			while ('0' > *p || '9' < *p)
				p++;
			for (A[i][j] = 0; '0' <= *p && *p <= '9'; ++p)
				A[i][j] = A[i][j]*10+*p-'0';
		}
	}
	fclose(fi);
}

inline int max(int x, int y)
{
	return x > y ? x : y;
}

void solve()
{
	int l, i, j;
	int stk[MAX_N], up[MAX_N], ss;
	int pks[MAX_N], np, cur;
	for (i = 1; i <= N; ++i) {
		for (np = 0, j = 2; j < M; ++j)
			if ((A[i][j-1] < A[i][j] && A[i][j] > A[i][j+1]) ||
				(A[i][j-1] > A[i][j] && A[i][j] < A[i][j+1]))
				pks[np++] = j;
		pks[np++] = M, pks[np++] = M, pks[np++] = M;
		for (cur = 0, j = 1; j <= M; ++j) {
			if (j == pks[cur])
				cur++;
			P[i][j] = pks[cur+1];
		}
	}
	
	for (i = 1; i <= M; ++i)
		P[0][i] = P[N+1][i] = i-1;
	for (ans = 0, j = 1; j <= M; ++j) {
		for (stk[(ss = 0)++] = 0, i = 1; i <= N; ++i) {
			while (P[ stk[ss-1] ][j] >= P[i][j])
				ss--;
			up[i] = stk[ss-1]+1;
			stk[ss++] = i;
		}
		for (stk[(ss = 0)++] = N+1, i = N; i > 0; --i) {
			while (P[ stk[ss-1] ][j] >= P[i][j]) {
				ss--;
			}
			if (ans < (stk[ss-1]-up[i])*(P[i][j]-j+1)) {
				ans = (stk[ss-1]-up[i])*(P[i][j]-j+1);
				min_line = up[i];
				max_line = stk[ss-1]-1;
				min_col = j;
				max_col = P[i][j];
			}
			stk[ss++] = i;
		}
	}
}

void write()
{
	FILE *fo = fopen(FOUT, "w");
	fprintf(fo, "%d %d %d %d\n", min_line, min_col, max_line, max_col);
	fclose(fo);
}

int main()
{
	read();
	solve();
	write();
	//fprintf(stderr, "%d\n", ans);
	return 0;
}
