#include <stdio.h>

#define NMAX 401
#define KMAX 301

FILE *fin,*fout;
int N,K;
int d[NMAX+1];
long S1[NMAX+1],S2[NMAX+2];
long c[KMAX+1][NMAX+1],b[KMAX+1][NMAX+1];
int jump1[KMAX+1][NMAX+1],jump2[KMAX+1][NMAX+1];
struct dreapta
{long a,b,ind;
}cd1[NMAX+1],cd2[NMAX+1];
long i_c1,sf_c1,i_c2,sf_c2;
const long pin=2000000000;

double intersec(dreapta p1,dreapta p2)
{return ((double)p2.a-p1.a)/((double)p1.b-p2.b);
}
double intersec2(dreapta p1,dreapta p2)
{return ((double)p2.a-p1.a)/((double)p2.b-p1.b);
}

void rebuild(int i,int j,int tip)
{if (j>0&&i>0)
    {if (!tip)
	{rebuild(i-1,jump1[i][j],1);
	 fprintf(fout,"%d\n",j);
	}
     else rebuild(i,jump2[i][j],0);
    }
}

int main()
{int i,poz,j;
 long val,vmin;
 dreapta p;
 fin=fopen("petrom.in","r");
 fscanf(fin,"%d %d",&N,&K);
 for (i=1;i<=N;++i) fscanf(fin,"%d",&d[i]);
 fclose(fin);
 for (i=1;i<=N;++i) S1[i]=S1[i-1]+d[i];
 for (i=N;i>=1;--i) S2[i]=S2[i+1]+d[N]-d[i];
 if (N==K) {fout=fopen("petrom.out","w");
	    fprintf(fout,"0\n");
	    fclose(fout);
	   }
 else
     {for (i=1;i<=K;++i)
	  {c[i][i]=c[i-1][i-1];
	   b[i][i]=c[i][i];
	   jump1[i][i]=i-1;jump2[i][i]=i;
	   i_c2=sf_c2=1;
	   if (i-1>0)
	      {i_c1=sf_c1=1;
	       cd1[sf_c1].a=b[i-1][i-1]+S2[i];
	       cd1[sf_c1].b=i-1;cd1[sf_c1].ind=i-1;
	      }
	   else {i_c1=1;sf_c1=0;}
	   if (i-1>0)
	     {p.a=b[i-1][i]+S2[i+1];
	      p.b=i;p.ind=i;
	      while (sf_c1>=i_c1&&(p.a<=cd1[sf_c1].a||intersec(p,cd1[sf_c1])>d[N]-d[i+1]))
		   --sf_c1;
	      ++sf_c1;
	      cd1[sf_c1]=p;
	     }
	   cd2[sf_c2].a=c[i][i]-S1[i]+d[i]*i;
	   cd2[sf_c2].b=d[i];cd2[sf_c2].ind=i;
	   for (j=i+1;j<=N;++j)
	       {//c[i][j]
		c[i][j]=pin;
		if (i==1) {c[i][j]=S2[1]-S2[j]-(d[N]-d[j])*(j-1);jump1[i][j]=0;}
		while (i_c1<sf_c1&&intersec(cd1[i_c1],cd1[i_c1+1])>=d[N]-d[j]) ++i_c1;
		if (i_c1<=sf_c1)
		  {val=cd1[i_c1].a+cd1[i_c1].b*(d[N]-d[j])-S2[j]-(d[N]-d[j])*j+(d[N]-d[j]);
		   c[i][j]=val;jump1[i][j]=cd1[i_c1].ind;
		  }
		if (j<N&&i-1>0)
		   {p.a=b[i-1][j]+S2[j+1];
		    p.b=j;p.ind=j;
		    while (sf_c1>=i_c1&&(p.a<=cd1[sf_c1].a||intersec(p,cd1[sf_c1])>d[N]-d[j+1]))
			  --sf_c1;
		    ++sf_c1;
		    cd1[sf_c1]=p;
		   }
		//b[i][j]
		b[i][j]=c[i][j];
		jump2[i][j]=j;
		while (i_c2<sf_c2&&intersec2(cd2[i_c2],cd2[i_c2+1])<=j) ++i_c2;
		if (i_c2<=sf_c2)
		   {val=cd2[i_c2].a-cd2[i_c2].b*j+S1[j];
		    if (b[i][j]>val) {b[i][j]=val;jump2[i][j]=cd2[i_c2].ind;}
		   }
		if (j<N)
		   {p.a=c[i][j]+d[j]*j-S1[j];
		    p.b=d[j];p.ind=j;
		    while (sf_c2>=i_c2&&(p.a<=cd2[sf_c2].a||intersec2(p,cd2[sf_c2])<=j+1))
			  --sf_c2;
		    ++sf_c2;
		    cd2[sf_c2]=p;
		   }
	       }
	  }
      vmin=pin;
      for (i=K;i<=N;++i)
	 if (vmin>c[K][i]+S1[N]-S1[i]-d[i]*(N-i))
	    {vmin=c[K][i]+S1[N]-S1[i]-d[i]*(N-i);
	     poz=i;
	    }
      fout=fopen("petrom.out","w");
      fprintf(fout,"%ld\n",vmin);
      rebuild(K,poz,0);
      fclose(fout);
     }
 return 0;
}