#include <cstdio>
#include <cstdlib>
#include <cstring>

#define NMAX 405
#define KMAX 305
#define INF  1000000999
#define MIN(a, b) ((a) < (b) ? (a) : (b))

int N, K, i, j, k;
int d[NMAX];
int dist[NMAX][NMAX];
int m[KMAX][NMAX], pi[KMAX][NMAX];
int st[NMAX], stk;

void gen(void)
{
    freopen("petrom.in", "w", stdout);
    N = 400, K = 300;
    printf("%d %d\n", N, K);
    for (i = 1; i <= N; i ++)
        printf("%d\n", i * 4 + rand() % 4);
}

int main(void)
{
// gen();
// return 0;

    freopen("petrom.in", "r", stdin);
    freopen("petrom.out", "w", stdout);
    scanf("%d %d", &N, &K);
    
    for (i = 1; i <= N; i ++)
        scanf("%d", &d[i]);
    d[0] = -INF, d[N + 1] = INF;

    memset(dist, 0, sizeof(dist));
    for (i = 0; i <= N; i ++)
        for (j = i + 1; j <= N + 1; j ++)
        {
            for (k = i + 1; k < j; k ++)
                dist[i][j] += MIN(d[k] - d[i], d[j] - d[k]);
        }

    memset(pi, 0, sizeof(pi));
    for (i = 1; i <= K + 1; i ++)
        for (j = i; j <= N + 1; j ++)   // statia i in benzinaria j
        {
            if (i == 1)
               m[i][j] = dist[0][j];
            else
            {
                m[i][j] = INF;
                for (k = i - 1; k < j; k ++)
                    if (m[i - 1][k] + dist[k][j] < m[i][j])
                    {
                       m[i][j] = m[i - 1][k] + dist[k][j];
                       pi[i][j] = k;
                    }
            }
        }

    stk = 0, i = K + 1, j = N + 1;
    for (; i; j = pi[i][j], i --)
        st[stk ++] = j;

    printf("%d\n", m[K + 1][N + 1]);
    for (i = K; i >= 1; i --)
        printf("%d\n", st[i]);
    return 0;
}
