/*
time complexity O(L log^2 L + M lg L), doesn't fit very well the time limit
*/

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
using namespace std;

#define LMAX 200005
#define GMAX 13
#define NMAX 10005

struct entry{
    int n1, n2, p;
} o[LMAX];

char buf[2048];
int len[NMAX], start_pos[NMAX];
int p[GMAX][LMAX];
int N, M, S, i, j, k, x, stp, cnt, MAXLEN;
FILE *fi, *fo;

void read(void)
{
    fi = fopen("ratina.in", "r");
    fscanf(fi, "%d %d\n", &N, &M);

    memset(len, 0, sizeof(len)), start_pos[0] = 0, S = MAXLEN = 0;
    for (i = 0; i < N; i ++)
    {
        fgets(buf, 2048, fi);

        start_pos[i] = (i == 0) ? 0 : start_pos[i - 1] + len[i - 1];
        for (j = 0; j < strlen(buf); j ++)
            if ('a' <= buf[j] && buf[j] <= 'z')
               ++ len[i], p[0][S ++] = buf[j] - 'a' + 1;
        if (len[i] > MAXLEN) MAXLEN = len[i];
    }
}

int cmp(struct entry a, struct entry b)
{
    if (a.n1 == b.n1)
       return a.n2 < b.n2 ? 1 : 0;
    else
       return a.n1 < b.n1 ? 1 : 0;
}

void suffix(void)
{
    for (stp = 1, cnt = 1; cnt < MAXLEN; stp ++, cnt <<= 1)
    {
        for (i = 0; i < S; i ++)
        {
            o[i].n1 = p[stp - 1][i];
            o[i].n2 = i + cnt < S ? p[stp - 1][i + cnt] : -1;
            o[i].p = i;
        }
        sort(o, o + S, cmp);

        for (i = 0; i < S; i ++)
            if (i > 0 && o[i].n1 == o[i - 1].n1 && o[i].n2 == o[i - 1].n2)
                p[stp][o[i].p] = p[stp][o[i - 1].p];
            else
                p[stp][o[i].p] = i;
    }

//    printf("stp > %d\n cnt > %d\n", stp, cnt);
}

int lcp(int x, int y, int max)
{
    int ret = 0, delta, ln;
    for (delta = 1, ln = 0; 2 * delta <= max; delta <<= 1, ++ ln);
    for (; delta; delta >>= 1, -- ln)
    {
        if (p[ln][x] == p[ln][y] && ret + delta <= max)
           ret += delta, x += delta, y += delta;
    }
    return ret;
}

void solve(void)
{
    int T, maxAns, minp, maxp, ret;
    fo = fopen("ratina.out", "w");
    
    for (; M; M --)
    {
        fscanf(fi, "%d %d", &T, &x), -- x;
        maxAns = len[x], minp = maxp = start_pos[x];
        for (i = 1; i < T; i ++)
        {
            fscanf(fi, "%d", &x), -- x;

            
            if (len[x] < maxAns) maxAns = len[x];
            if (start_pos[x] < minp) minp = start_pos[x];
            if (start_pos[x] > maxp) maxp = start_pos[x];
        }

        // do some lcp query
        if (minp == maxp)
           fprintf(fo, "%d\n", maxAns);
        else
        {
            ret = lcp(minp, maxp, maxAns);
            fprintf(fo, "%d\n", ret);
        }
    }

    fclose(fi);
}

int main(void)
{
    read();
    suffix();
    solve();
    return 0;
}
