/*
	ratian
	
	O(n log n + (m - kerdezettek)*tav_atlag)

	rendezes, majd keresgeles egy tombben
		mar megy a peldara
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXN 10001	// !!!

int n,m,
	szam[MAXN], poz[MAXN], ndata[MAXN],
	megold[MAXN][MAXN];

char *data[MAXN];

void rendez(void){
	int i,j,d;
	char *st;
	
	d = (n+1)>>1;
	while( d > 0){
		for( i=0; i+d < n; i++)
			if( strcmp( data[i], data[i+d]) > 0){
				st = data[i]; data[i] = data[i+d]; data[i+d] = st;
				j = szam[i]; szam[i] = szam[i+d]; szam[i+d] = j;
				j = ndata[i]; ndata[i] = ndata[i+d]; ndata[i+d] = j;
            }
        if( d>1)
			d = (d+1)>>1;
        else
			d = 0;
    }
}

int main(void){
	FILE *fi, *fo;
	int i,j,k, nn, min, max, d, ndata_min, ndata_max;
	char sor[2000];

	// printf("\n--Start--\n");

	// olvasas
	fi = fopen( "ratina.in", "r");
	fscanf(fi, "%i %i", &n, &m);
	for( i=0; i<n; i++){
		fscanf(fi, "%s", sor);
		ndata[i] = strlen(sor);
		data[i] = (char *) malloc( ndata[i]+2);
		strcpy( data[i], sor);
		szam[i] = i;
    }
	
	// feldolgozas
	rendez();

	for( i=0; i<n; i++)
		poz[ szam[i]] = i;
	// poz[i] = az i. elem helye a sorban

	// irogassunk
	fo = fopen("ratina.out", "w");
	
	// eredmenyek
	for( i=0; i<m; i++){
		fscanf(fi, "%i", &nn);
		min = MAXN; max = 0;
		for( j=0; j<nn; j++){
			fscanf(fi, "%i", &k);
			k--; 	// mert 0-tol indexelunk
			if( poz[k]<min) min = poz[k];
			if( poz[k]>max) max = poz[k];
        }
		// printf("%i %i\n", min, max);
		if( min == max)		// onmagaval valyon mennyi ??
			fprintf( fo, "%i\n", ndata[min]);
        else
			if( !megold[min][max]){		// ezt az esetet meg nem targyaltuk ?
				ndata_min = ndata[min];
				ndata_max = ndata[max];
				for( d = 0; (d<ndata_min)&&(d<ndata_max)		// optimizalas !!!
					&& (data[min][d] == data[max][d]); d++);
				megold[min][max] = d;	// targyalva ez is
            	fprintf(fo, "%i\n", d);
			} else	// mar volt ilyen ? akkor tudjuk !
    			fprintf(fo, "%i\n", megold[min][max]);
    }

	// ezt illik
	fclose(fi);
	fclose(fo);
	
	return 0;
}

