#include <stdio.h>

#define MAX_N 1024
#define INF 30666
#define MAX_BUF 1048576
#define FIN "matrice.in"
#define FOUT "matrice.out"
#define FOR(i, a, b) for (i = (a); i < (b); i++)
#define FORD(i, a, b) for (i = (a)-1; i >= (b); i--)
#define MAX(a, b) ((a) > (b) ? (a) : (b))

int N, M, Res, x1, y1, x2, y2, stk[MAX_N], stk_len, val[MAX_N], L[MAX_N], R[MAX_N], H[MAX_N];
short A[MAX_N][MAX_N], up[MAX_N][MAX_N], dn[MAX_N][MAX_N], bst[MAX_N][MAX_N];
char buf[MAX_BUF], *p;

inline int get(void)
{
    int n = 0, sgn = +1;

    if (*p == '-') { sgn = -1; p++; }
    for (; *p >= '0' && *p <= '9'; p++)
        n = n*10 + *p-'0';
    p++;
    return n*sgn;
}

int main(void)
{
    int i, j, t;
    
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d %d\n", &N, &M);
    FOR (i, 1, N+1)
    {
        fgets(buf, MAX_BUF, stdin); p = buf;
        FOR (j, 1, M+1)
        {
            A[i][j] = get();
            up[i][j] = (j > 1 && A[i][j] > A[i][j-1]) ? up[i][j-1]+1 : 1;
            dn[i][j] = (j > 1 && A[i][j] < A[i][j-1]) ? dn[i][j-1]+1 : 1;
            bst[i][j] = MAX(up[i][j]+dn[i][j-up[i][j]], dn[i][j]+up[i][j-dn[i][j]]);
        }
    }

    FOR (j, 1, M+1)
    {
        FOR (i, 1, N+1) H[i] = bst[i][j];

        stk[stk_len = 0] = 0; val[0] = -INF;
        FOR (i, 1, N+1)
        {
            for (; stk_len >= 0 && val[stk_len] >= H[i]; stk_len--);
            L[i] = i-stk[stk_len];
            stk[++stk_len] = i;
            val[stk_len] = H[i];
        }

        stk[stk_len = 0] = N+1; val[0] = -INF;
        FORD (i, N+1, 1)
        {
            for (; stk_len >= 0 && val[stk_len] >= H[i]; stk_len--);
            R[i] = stk[stk_len]-i;
            stk[++stk_len] = i;
            val[stk_len] = H[i];
        }

        FOR (i, 1, N+1)
        {
            t = (L[i]+R[i]-1)*H[i];
            if (Res >= t) continue;
            Res = t;
            x1 = i-L[i]+1; x2 = i+R[i]-1;
            y1 = j-H[i]+1; y2 = j;
        }
    }

    printf("%d %d %d %d\n", x1, y1, x2, y2);
    
    return 0;
}
