#include <stdio.h>

#define FIN "matrice.in"
#define FOUT "matrice.out"

#define MAX_N 601
#define MAX_L 30000
#define isok(c) (('0' <= c && c <= '9') || c == '-')

int N, M, m[MAX_N][MAX_N], q[MAX_N], I[MAX_N], D[MAX_N];

int max(int a, int b)
{
    return a > b ? a : b;
}

void process(void)
{
    int i, j;

    for (i = 0; i < N; i++)
    {
        I[0] = D[0] = 1;
        for (j = 1; j < M; j++)
        {
            I[j] = m[i][j] > m[i][j - 1] ? I[j - 1] + 1 : 1;
            D[j] = m[i][j] < m[i][j - 1] ? D[j - 1] + 1 : 1;
        }
        for (j = 0; j < M; j++)
        {
            m[i][j] = I[j] + (j - I[j] >= 0 ? D[j - I[j]] : 0);
            m[i][j] = max(m[i][j], D[j] + (j - D[j] >= 0 ? I[j - D[j]] : 0));
        }
    }
}

int main(void)
{
    char str[MAX_L], *p;
    int i, j, k, l, r, minus, x, y, d, depth, area, n, length;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d %d\n", &N, &M);
    for (i = 0; i < N; i++)
    {
        gets(str), p = str;
        for (j = minus = 0; *p; )
        {
            for (; *p && !isok(*p); p++) ;
            if (*p == '-')
               minus = 1, p++;
            else minus = 0;
            for (n = 0; *p && isok(*p); p++)
                n = n * 10 + (*p) - '0';
            m[i][j++] = n * (minus ? -1 : 1);
        }
    }

    process();

    for (depth = 1; depth <= N; depth++)
        for (j = area = 0; j < M; j++)
        {
            l = 0, r = -1;
            for (k = 0; k < depth; k++)
            {
                for (; r >= l && m[k][j] < m[q[r]][j]; r--) ;
                q[++r] = k;
            }
            if (m[q[l]][j] * depth > area)
            {
                area = m[q[l]][j] * depth;
                d = depth;
                length = m[q[l]][j];
                x = k != N ? k : N - 1;
                y = j;
            }
            for (; k < N; k++)
            {
                if (k - q[l] == depth) l++;
                for (; r >= l && m[k][j] < m[q[r]][j]; r--) ;
                q[++r] = k;
                if (m[q[l]][j] * depth > area)
                {
                   area = m[q[l]][j] * depth;
                   d = depth;
                   length = m[q[l]][j];
                   x = k != N ? k : N - 1;
                   y = j;
                }
            }
        }

    printf("%d %d %d %d\n", x - d + 2, y - length + 2, x + 1, y + 1);

    return 0;
}
