#include <stdio.h>
#include <string.h>

#define MAXN 1024
#define MAXCH 100000

void read(void);

int M, N, A[MAXN][MAXN];
short C[MAXN][MAXN], D[MAXN][MAXN], V[MAXN][MAXN], urm[MAXN][MAXN];

int main(void)
{
	int i, j, k, p, rez = 0, l1, c1, l2, c2, min;

	freopen("matrice.in", "r", stdin);
    freopen("matrice.out", "w", stdout);

    read();

    for (i = 0; i < M; i++)
    {
    	C[i][N - 1] = D[i][N - 1] = 1;
        for (j = N - 2; j >= 0; j--)
        	if (A[i][j] < A[i][j + 1])
            	C[i][j] = 1 + C[i][j + 1], D[i][j] = 1;
			else
            	D[i][j] = 1 + D[i][j + 1], C[i][j] = 1;
    }

    for (i = 0; i < M;i++)
    	for (j = 0; j < N; j++)
        	if (C[i][j] > 1)
            	V[i][j] = C[i][j] + D[i][j + C[i][j]];
			else
            	V[i][j] = D[i][j] + C[i][j + D[i][j]];

	for (j = 0; j < N; j++)
    {
    	urm[M - 1][j] = M;
        for (i = M - 2; i >= 0; i--)
        {
        	for (p = i + 1; p < M && V[p][j] >= V[i][j]; p = urm[p][j]);
            urm[i][j] = p;
        }
    }

	for (i = 0; i < M; i++)
    	for (j = 0; j < N; j++)
			for (k = urm[i][j], min = V[i][j]; 1; k = urm[k][j])
            {
            	if ((k - i) * min > rez)
                	rez = (k - i) * min, l1 = i, c1 = j, l2 = k - 1, c2 = c1 + min - 1;
				min = V[k][j];
				if (k == M || (M - i) * min < rez)
                	break;                
            }

	printf("%d\n%d %d %d %d\n", rez, l1 + 1, c1 + 1, l2 + 1, c2 + 1);

    return 0;
}

void read(void)
{
	int i, j;

    scanf("%d %d", &M, &N);

    for (i = 0; i < M; i++)
    	for (j = 0; j < N; j++)
        	scanf("%d", &A[i][j]);
}
