#include <stdio.h>
#include <stdlib.h>

#define MAXN 10010
#define MAXC 2010
#define MAX(a, b) ((a) > (b) ? (a) : (b))

typedef struct t_elem
{
	int id[2], poz;
} elem;

void read_and_solve(void);
void sort(void);
void srt(int r);

int N, M, len[MAXN], *sortp[MAXN], B[MAXN], cnt[MAXN];
char *s[MAXN], line[MAXC];
elem E[MAXN], tmp[MAXN];

int main(void)
{
    freopen("ratina.in", "r", stdin);
    freopen("ratina.out", "w", stdout);

	read_and_solve();

    return 0;
}

void read_and_solve(void)
{
	int i, t, minp, maxp, nr, pas, rez = 0, lenm;

	scanf("%d %d ", &N, &M);

    for (i = 0; i < N; i++)
    {
    	scanf("%s ", line);
		len[i] = strlen(line);
		s[i] = malloc(len[i] * sizeof(char));
        memcpy(s[i], line, len[i] * sizeof(char));
        sortp[i] = malloc(len[i] * sizeof(int));
    }

    sort();

    for (i = 0; i < M; i++)
    {
    	minp = -1;
    	for (scanf("%d", &t); t; t--)
        {
        	scanf("%d", &nr);
			if (minp == -1)
            	minp = maxp = nr - 1;
			else
            {
            	if (B[nr] < B[minp])
                	minp = nr - 1;
				if (B[nr] > B[maxp])
                	maxp = nr - 1;
			}
        }

        lenm = len[maxp] < len[minp] ? len[maxp] : len[minp];
        for (pas = 1; pas <= lenm; pas <<= 1);

        for (rez = 0; pas; pas >>= 1)
        	if (rez + pas <= lenm && sortp[minp][rez + pas] == sortp[maxp][rez + pas])
            	rez += pas;

		printf("%d\n", rez);
    }
}

void sort(void)
{
	int pas, i, newi, flag = 1;

    for (pas = 1; flag; pas++)
    {
    	flag = 0;
    	for (i = 0; i < N; i++)
        {
			E[i].id[0] = B[i], E[i].id[1] = len[i] >= pas ? s[i][pas - 1] - 'a' : 0, E[i].poz = i;
			if (len[i] >= pas)
            	flag = 1;
		}
        if (!flag)
        	break;

		srt(1), srt(0);

        for (i = newi = 0; i < N; i++)
        {
        	newi += !i || E[i].id[0] != E[i - 1].id[0] || E[i].id[1] != E[i - 1].id[1];
			B[E[i].poz] = newi;
            sortp[E[i].poz][pas] = newi;
        }
    }
}

void srt(int r)
{
	int i;

    memset(cnt, 0, sizeof(cnt));
    for (i = 0; i < N; i++)
    	cnt[E[i].id[r]]++;
	for (i = 1; i <= MAX(N, 256); i++)
    	cnt[i] += cnt[i - 1];
	for (i = N - 1; i >= 0; i--)
    	tmp[--cnt[E[i].id[r]]] = E[i];

	memcpy(E, tmp, sizeof(tmp));
}
